/* valum-asterisk-route.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-asterisk-route.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include <libsoup/soup.h>
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>


struct _ValumAsteriskRoutePrivate {
	ValumHandlerCallback _fire;
	gpointer _fire_target;
	GDestroyNotify _fire_target_destroy_notify;
};


static gpointer valum_asterisk_route_parent_class = NULL;

#define VALUM_ASTERISK_ROUTE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALUM_TYPE_ASTERISK_ROUTE, ValumAsteriskRoutePrivate))
enum  {
	VALUM_ASTERISK_ROUTE_DUMMY_PROPERTY
};
static gboolean valum_asterisk_route_real_match (ValumRoute* base, VSGIRequest* req, ValumContext* ctx);
static gboolean valum_asterisk_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static gchar* valum_asterisk_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params);
static void valum_asterisk_route_finalize (GObject* obj);


ValumAsteriskRoute* valum_asterisk_route_construct (GType object_type, ValumMethod method, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	ValumAsteriskRoute * self = NULL;
	ValumMethod _tmp0_ = 0;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	GDestroyNotify _tmp1__target_destroy_notify = NULL;
	_tmp0_ = method;
	self = (ValumAsteriskRoute*) g_object_new (object_type, "method", _tmp0_, NULL);
	_tmp1_ = handler;
	_tmp1__target = handler_target;
	_tmp1__target_destroy_notify = handler_target_destroy_notify;
	handler_target_destroy_notify = NULL;
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	self->priv->_fire = _tmp1_;
	self->priv->_fire_target = _tmp1__target;
	self->priv->_fire_target_destroy_notify = _tmp1__target_destroy_notify;
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
	return self;
}


ValumAsteriskRoute* valum_asterisk_route_new (ValumMethod method, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	return valum_asterisk_route_construct (VALUM_TYPE_ASTERISK_ROUTE, method, handler, handler_target, handler_target_destroy_notify);
}


static gboolean valum_asterisk_route_real_match (ValumRoute* base, VSGIRequest* req, ValumContext* ctx) {
	ValumAsteriskRoute * self;
	gboolean result = FALSE;
	VSGIRequest* _tmp0_ = NULL;
	SoupURI* _tmp1_ = NULL;
	SoupURI* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	self = (ValumAsteriskRoute*) base;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = req;
	_tmp1_ = vsgi_request_get_uri (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = soup_uri_get_path (_tmp2_);
	result = g_strcmp0 ("*", _tmp3_) == 0;
	return result;
}


static gboolean valum_asterisk_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	ValumAsteriskRoute * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	ValumNextCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	ValumContext* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (ValumAsteriskRoute*) base;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp1_ = self->priv->_fire;
	_tmp1__target = self->priv->_fire_target;
	_tmp2_ = req;
	_tmp3_ = res;
	_tmp4_ = next;
	_tmp4__target = next_target;
	_tmp5_ = ctx;
	_tmp6_ = _tmp1_ (_tmp2_, _tmp3_, _tmp4_, _tmp4__target, _tmp5_, _tmp1__target, &_inner_error_);
	_tmp0_ = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp0_;
	return result;
}


static gchar* valum_asterisk_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params) {
	ValumAsteriskRoute * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	self = (ValumAsteriskRoute*) base;
	_tmp0_ = g_strdup ("*");
	result = _tmp0_;
	return result;
}


static void valum_asterisk_route_class_init (ValumAsteriskRouteClass * klass) {
	valum_asterisk_route_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValumAsteriskRoutePrivate));
	((ValumRouteClass *) klass)->match = valum_asterisk_route_real_match;
	((ValumRouteClass *) klass)->fire = valum_asterisk_route_real_fire;
	((ValumRouteClass *) klass)->to_url_from_hash = valum_asterisk_route_real_to_url_from_hash;
	G_OBJECT_CLASS (klass)->finalize = valum_asterisk_route_finalize;
}


static void valum_asterisk_route_instance_init (ValumAsteriskRoute * self) {
	self->priv = VALUM_ASTERISK_ROUTE_GET_PRIVATE (self);
}


static void valum_asterisk_route_finalize (GObject* obj) {
	ValumAsteriskRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALUM_TYPE_ASTERISK_ROUTE, ValumAsteriskRoute);
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	G_OBJECT_CLASS (valum_asterisk_route_parent_class)->finalize (obj);
}


/**
 * Route supporting the asterisk '*' path.
 */
GType valum_asterisk_route_get_type (void) {
	static volatile gsize valum_asterisk_route_type_id__volatile = 0;
	if (g_once_init_enter (&valum_asterisk_route_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValumAsteriskRouteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valum_asterisk_route_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValumAsteriskRoute), 0, (GInstanceInitFunc) valum_asterisk_route_instance_init, NULL };
		GType valum_asterisk_route_type_id;
		valum_asterisk_route_type_id = g_type_register_static (VALUM_TYPE_ROUTE, "ValumAsteriskRoute", &g_define_type_info, 0);
		g_once_init_leave (&valum_asterisk_route_type_id__volatile, valum_asterisk_route_type_id);
	}
	return valum_asterisk_route_type_id__volatile;
}



