/* valum-authenticate.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-authenticate.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Block1Data {
	int _ref_count_;
	VSGIAuthentication* auth;
	ValumAuthCallback callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	ValumForwardCallback forward;
	gpointer forward_target;
	GDestroyNotify forward_target_destroy_notify;
};



static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda12_ (Block1Data* _data1_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static gboolean ___lambda12__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);


/**
 * Challenge incoming requests against the provided authentication
 * definition.
 *
 * On success, the request is forwarded with the authenticated username.
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->auth);
		(_data1_->callback_target_destroy_notify == NULL) ? NULL : (_data1_->callback_target_destroy_notify (_data1_->callback_target), NULL);
		_data1_->callback = NULL;
		_data1_->callback_target = NULL;
		_data1_->callback_target_destroy_notify = NULL;
		(_data1_->forward_target_destroy_notify == NULL) ? NULL : (_data1_->forward_target_destroy_notify (_data1_->forward_target), NULL);
		_data1_->forward = NULL;
		_data1_->forward_target = NULL;
		_data1_->forward_target_destroy_notify = NULL;
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean __lambda12_ (Block1Data* _data1_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	gboolean result = FALSE;
	gchar* authorization_header = NULL;
	VSGIRequest* _tmp0_ = NULL;
	SoupMessageHeaders* _tmp1_ = NULL;
	SoupMessageHeaders* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	VSGIAuthentication* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	GError* _tmp26_ = NULL;
	GError* _tmp27_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = req;
	_tmp1_ = vsgi_request_get_headers (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = soup_message_headers_get_one (_tmp2_, "Authorization");
	_tmp4_ = g_strdup (_tmp3_);
	authorization_header = _tmp4_;
	_tmp5_ = authorization_header;
	if (_tmp5_ != NULL) {
		VSGIAuthorization* authorization = NULL;
		VSGIAuthentication* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		VSGIAuthorization* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		_tmp6_ = _data1_->auth;
		_tmp7_ = authorization_header;
		_tmp9_ = vsgi_authentication_parse_authorization_header (_tmp6_, _tmp7_, &_tmp8_);
		_g_object_unref0 (authorization);
		authorization = _tmp8_;
		if (_tmp9_) {
			ValumAuthCallback _tmp10_ = NULL;
			void* _tmp10__target = NULL;
			VSGIAuthorization* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			_tmp10_ = _data1_->callback;
			_tmp10__target = _data1_->callback_target;
			_tmp11_ = authorization;
			_tmp12_ = _tmp10_ (_tmp11_, _tmp10__target);
			if (_tmp12_) {
				gboolean _tmp13_ = FALSE;
				ValumForwardCallback _tmp14_ = NULL;
				void* _tmp14__target = NULL;
				VSGIRequest* _tmp15_ = NULL;
				VSGIResponse* _tmp16_ = NULL;
				ValumNextCallback _tmp17_ = NULL;
				void* _tmp17__target = NULL;
				ValumContext* _tmp18_ = NULL;
				VSGIAuthorization* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				gboolean _tmp22_ = FALSE;
				_tmp14_ = _data1_->forward;
				_tmp14__target = _data1_->forward_target;
				_tmp15_ = req;
				_tmp16_ = res;
				_tmp17_ = next;
				_tmp17__target = next_target;
				_tmp18_ = ctx;
				_tmp19_ = authorization;
				_tmp20_ = vsgi_authorization_get_username (_tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = _tmp14_ (_tmp15_, _tmp16_, _tmp17_, _tmp17__target, _tmp18_, _tmp21_, _tmp14__target, &_inner_error_);
				_tmp13_ = _tmp22_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (authorization);
					_g_free0 (authorization_header);
					return FALSE;
				}
				result = _tmp13_;
				_g_object_unref0 (authorization);
				_g_free0 (authorization_header);
				return result;
			} else {
			}
		} else {
		}
		_g_object_unref0 (authorization);
	}
	_tmp23_ = _data1_->auth;
	_tmp24_ = vsgi_authentication_to_authenticate_header (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = g_error_new_literal (VALUM_CLIENT_ERROR, VALUM_CLIENT_ERROR_UNAUTHORIZED, _tmp25_);
	_tmp27_ = _tmp26_;
	_g_free0 (_tmp25_);
	_inner_error_ = _tmp27_;
	g_propagate_error (error, _inner_error_);
	_g_free0 (authorization_header);
	return FALSE;
}


static gboolean ___lambda12__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda12_ (self, req, res, next, next_target, context, error);
	return result;
}


ValumHandlerCallback valum_authenticate (VSGIAuthentication* auth, ValumAuthCallback callback, void* callback_target, GDestroyNotify callback_target_destroy_notify, ValumForwardCallback forward, void* forward_target, GDestroyNotify forward_target_destroy_notify, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block1Data* _data1_;
	VSGIAuthentication* _tmp0_ = NULL;
	VSGIAuthentication* _tmp1_ = NULL;
	ValumAuthCallback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	ValumForwardCallback _tmp3_ = NULL;
	void* _tmp3__target = NULL;
	ValumHandlerCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	GDestroyNotify _tmp4__target_destroy_notify = NULL;
	g_return_val_if_fail (auth != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = auth;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data1_->auth);
	_data1_->auth = _tmp1_;
	_tmp2_ = callback;
	_tmp2__target = callback_target;
	(_data1_->callback_target_destroy_notify == NULL) ? NULL : (_data1_->callback_target_destroy_notify (_data1_->callback_target), NULL);
	_data1_->callback = NULL;
	_data1_->callback_target = NULL;
	_data1_->callback_target_destroy_notify = NULL;
	_data1_->callback = _tmp2_;
	_data1_->callback_target = _tmp2__target;
	_data1_->callback_target_destroy_notify = callback_target_destroy_notify;
	_tmp3_ = forward;
	_tmp3__target = forward_target;
	(_data1_->forward_target_destroy_notify == NULL) ? NULL : (_data1_->forward_target_destroy_notify (_data1_->forward_target), NULL);
	_data1_->forward = NULL;
	_data1_->forward_target = NULL;
	_data1_->forward_target_destroy_notify = NULL;
	_data1_->forward = _tmp3_;
	_data1_->forward_target = _tmp3__target;
	_data1_->forward_target_destroy_notify = forward_target_destroy_notify;
	_tmp4_ = ___lambda12__valum_handler_callback;
	_tmp4__target = block1_data_ref (_data1_);
	_tmp4__target_destroy_notify = block1_data_unref;
	*result_target = _tmp4__target;
	*result_target_destroy_notify = _tmp4__target_destroy_notify;
	result = _tmp4_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}



