/* valum-basepath.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-basepath.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include <stdlib.h>
#include <string.h>
#include "vsgi.h"
#include <libsoup/soup.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Block2Data {
	int _ref_count_;
	gchar* path;
	ValumHandlerCallback forward;
	gpointer forward_target;
	GDestroyNotify forward_target_destroy_notify;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	VSGIRequest* req;
	VSGIResponse* res;
	ValumNextCallback next;
	gpointer next_target;
};

struct _Block4Data {
	int _ref_count_;
	Block3Data * _data3_;
	gchar* original_path;
};



static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda13_ (Block2Data* _data2_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, GError** error);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean ____lambda14_ (Block4Data* _data4_, GError** error);
static gboolean _____lambda14__valum_next_callback (gpointer self, GError** error);
static gboolean ___lambda13__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);


/**
 * Rebase and forward requests which path match the provided basepath.
 *
 * If the {@link VSGI.Request.uri} path has the provided prefix, it is
 * stripped and the resulting request is forwared.
 *
 * Typically, a leading slash and no ending slash are used to form the
 * prefix path (e.g. '/user').
 *
 * If 'next' is called while forwarding, the URI path is restored.
 *
 * Error which message consist of a 'Location' header are prefixed by
 * the basepath.
 *
 * @param path    path prefix stripped on forwarded requests
 * @param forward callback used to forward the request
 */
static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_g_free0 (_data2_->path);
		(_data2_->forward_target_destroy_notify == NULL) ? NULL : (_data2_->forward_target_destroy_notify (_data2_->forward_target), NULL);
		_data2_->forward = NULL;
		_data2_->forward_target = NULL;
		_data2_->forward_target_destroy_notify = NULL;
		g_slice_free (Block2Data, _data2_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_g_object_unref0 (_data3_->req);
		_g_object_unref0 (_data3_->res);
		block2_data_unref (_data3_->_data2_);
		_data3_->_data2_ = NULL;
		g_slice_free (Block3Data, _data3_);
	}
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (void * _userdata_) {
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		_g_free0 (_data4_->original_path);
		block3_data_unref (_data4_->_data3_);
		_data4_->_data3_ = NULL;
		g_slice_free (Block4Data, _data4_);
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static gboolean ____lambda14_ (Block4Data* _data4_, GError** error) {
	Block3Data* _data3_;
	Block2Data* _data2_;
	gboolean result = FALSE;
	VSGIRequest* _tmp0_ = NULL;
	SoupURI* _tmp1_ = NULL;
	SoupURI* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* location = NULL;
	VSGIResponse* _tmp4_ = NULL;
	SoupMessageHeaders* _tmp5_ = NULL;
	SoupMessageHeaders* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	VSGIResponse* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp24_ = FALSE;
	ValumNextCallback _tmp25_ = NULL;
	void* _tmp25__target = NULL;
	gboolean _tmp26_ = FALSE;
	GError * _inner_error_ = NULL;
	_data3_ = _data4_->_data3_;
	_data2_ = _data3_->_data2_;
	_tmp0_ = _data3_->req;
	_tmp1_ = vsgi_request_get_uri (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _data4_->original_path;
	soup_uri_set_path (_tmp2_, _tmp3_);
	_tmp4_ = _data3_->res;
	_tmp5_ = vsgi_response_get_headers (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = soup_message_headers_get_one (_tmp6_, "Location");
	_tmp8_ = g_strdup (_tmp7_);
	location = _tmp8_;
	_tmp11_ = _data3_->res;
	_tmp12_ = vsgi_response_get_head_written (_tmp11_);
	_tmp13_ = _tmp12_;
	if (!_tmp13_) {
		const gchar* _tmp14_ = NULL;
		_tmp14_ = location;
		_tmp10_ = _tmp14_ != NULL;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		const gchar* _tmp15_ = NULL;
		gchar _tmp16_ = '\0';
		_tmp15_ = location;
		_tmp16_ = string_get (_tmp15_, (glong) 0);
		_tmp9_ = _tmp16_ == '/';
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		VSGIResponse* _tmp17_ = NULL;
		SoupMessageHeaders* _tmp18_ = NULL;
		SoupMessageHeaders* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		_tmp17_ = _data3_->res;
		_tmp18_ = vsgi_response_get_headers (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = _data2_->path;
		_tmp21_ = location;
		_tmp22_ = g_strconcat (_tmp20_, _tmp21_, NULL);
		_tmp23_ = _tmp22_;
		soup_message_headers_replace (_tmp19_, "Location", _tmp23_);
		_g_free0 (_tmp23_);
	}
	_tmp25_ = _data3_->next;
	_tmp25__target = _data3_->next_target;
	_tmp26_ = _tmp25_ (_tmp25__target, &_inner_error_);
	_tmp24_ = _tmp26_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (location);
		return FALSE;
	}
	result = _tmp24_;
	_g_free0 (location);
	return result;
}


static gboolean _____lambda14__valum_next_callback (gpointer self, GError** error) {
	gboolean result;
	result = ____lambda14_ (self, error);
	return result;
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static gboolean __lambda13_ (Block2Data* _data2_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, GError** error) {
	gboolean result = FALSE;
	Block3Data* _data3_;
	VSGIRequest* _tmp0_ = NULL;
	VSGIRequest* _tmp1_ = NULL;
	VSGIResponse* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	ValumNextCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	VSGIRequest* _tmp5_ = NULL;
	SoupURI* _tmp6_ = NULL;
	SoupURI* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->_data2_ = block2_data_ref (_data2_);
	_tmp0_ = req;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data3_->req);
	_data3_->req = _tmp1_;
	_tmp2_ = res;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (_data3_->res);
	_data3_->res = _tmp3_;
	_tmp4_ = next;
	_tmp4__target = next_target;
	_data3_->next = _tmp4_;
	_data3_->next_target = _tmp4__target;
	_tmp5_ = _data3_->req;
	_tmp6_ = vsgi_request_get_uri (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = soup_uri_get_path (_tmp7_);
	_tmp9_ = _data2_->path;
	_tmp10_ = g_str_has_prefix (_tmp8_, _tmp9_);
	if (_tmp10_) {
		Block4Data* _data4_;
		VSGIRequest* _tmp11_ = NULL;
		SoupURI* _tmp12_ = NULL;
		SoupURI* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		VSGIRequest* _tmp17_ = NULL;
		SoupURI* _tmp18_ = NULL;
		SoupURI* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		gint _tmp21_ = 0;
		gint _tmp22_ = 0;
		const gchar* _tmp23_ = NULL;
		gint _tmp24_ = 0;
		gint _tmp25_ = 0;
		VSGIRequest* _tmp35_ = NULL;
		SoupURI* _tmp36_ = NULL;
		SoupURI* _tmp37_ = NULL;
		_data4_ = g_slice_new0 (Block4Data);
		_data4_->_ref_count_ = 1;
		_data4_->_data3_ = block3_data_ref (_data3_);
		_tmp11_ = _data3_->req;
		_tmp12_ = vsgi_request_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = soup_uri_get_path (_tmp13_);
		_tmp15_ = g_strdup (_tmp14_);
		_data4_->original_path = _tmp15_;
		_tmp17_ = _data3_->req;
		_tmp18_ = vsgi_request_get_uri (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = soup_uri_get_path (_tmp19_);
		_tmp21_ = strlen (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = _data2_->path;
		_tmp24_ = strlen (_tmp23_);
		_tmp25_ = _tmp24_;
		if (_tmp22_ > _tmp25_) {
			VSGIRequest* _tmp26_ = NULL;
			SoupURI* _tmp27_ = NULL;
			SoupURI* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			const gchar* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gint _tmp32_ = 0;
			gchar* _tmp33_ = NULL;
			_tmp26_ = _data3_->req;
			_tmp27_ = vsgi_request_get_uri (_tmp26_);
			_tmp28_ = _tmp27_;
			_tmp29_ = soup_uri_get_path (_tmp28_);
			_tmp30_ = _data2_->path;
			_tmp31_ = strlen (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = string_substring (_tmp29_, (glong) _tmp32_, (glong) (-1));
			_g_free0 (_tmp16_);
			_tmp16_ = _tmp33_;
		} else {
			gchar* _tmp34_ = NULL;
			_tmp34_ = g_strdup ("/");
			_g_free0 (_tmp16_);
			_tmp16_ = _tmp34_;
		}
		_tmp35_ = _data3_->req;
		_tmp36_ = vsgi_request_get_uri (_tmp35_);
		_tmp37_ = _tmp36_;
		soup_uri_set_path (_tmp37_, _tmp16_);
		{
			gboolean _tmp38_ = FALSE;
			ValumHandlerCallback _tmp39_ = NULL;
			void* _tmp39__target = NULL;
			VSGIRequest* _tmp40_ = NULL;
			VSGIResponse* _tmp41_ = NULL;
			ValumContext* _tmp42_ = NULL;
			gboolean _tmp43_ = FALSE;
			_tmp39_ = _data2_->forward;
			_tmp39__target = _data2_->forward_target;
			_tmp40_ = _data3_->req;
			_tmp41_ = _data3_->res;
			_tmp42_ = context;
			_tmp43_ = _tmp39_ (_tmp40_, _tmp41_, _____lambda14__valum_next_callback, _data4_, _tmp42_, _tmp39__target, &_inner_error_);
			_tmp38_ = _tmp43_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch0_g_error;
			}
			result = _tmp38_;
			{
				VSGIRequest* _tmp44_ = NULL;
				SoupURI* _tmp45_ = NULL;
				SoupURI* _tmp46_ = NULL;
				const gchar* _tmp47_ = NULL;
				gchar* location = NULL;
				VSGIResponse* _tmp48_ = NULL;
				SoupMessageHeaders* _tmp49_ = NULL;
				SoupMessageHeaders* _tmp50_ = NULL;
				const gchar* _tmp51_ = NULL;
				gchar* _tmp52_ = NULL;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				VSGIResponse* _tmp55_ = NULL;
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
				_tmp44_ = _data3_->req;
				_tmp45_ = vsgi_request_get_uri (_tmp44_);
				_tmp46_ = _tmp45_;
				_tmp47_ = _data4_->original_path;
				soup_uri_set_path (_tmp46_, _tmp47_);
				_tmp48_ = _data3_->res;
				_tmp49_ = vsgi_response_get_headers (_tmp48_);
				_tmp50_ = _tmp49_;
				_tmp51_ = soup_message_headers_get_one (_tmp50_, "Location");
				_tmp52_ = g_strdup (_tmp51_);
				location = _tmp52_;
				_tmp55_ = _data3_->res;
				_tmp56_ = vsgi_response_get_head_written (_tmp55_);
				_tmp57_ = _tmp56_;
				if (!_tmp57_) {
					const gchar* _tmp58_ = NULL;
					_tmp58_ = location;
					_tmp54_ = _tmp58_ != NULL;
				} else {
					_tmp54_ = FALSE;
				}
				if (_tmp54_) {
					const gchar* _tmp59_ = NULL;
					gchar _tmp60_ = '\0';
					_tmp59_ = location;
					_tmp60_ = string_get (_tmp59_, (glong) 0);
					_tmp53_ = _tmp60_ == '/';
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					VSGIResponse* _tmp61_ = NULL;
					SoupMessageHeaders* _tmp62_ = NULL;
					SoupMessageHeaders* _tmp63_ = NULL;
					const gchar* _tmp64_ = NULL;
					const gchar* _tmp65_ = NULL;
					gchar* _tmp66_ = NULL;
					gchar* _tmp67_ = NULL;
					_tmp61_ = _data3_->res;
					_tmp62_ = vsgi_response_get_headers (_tmp61_);
					_tmp63_ = _tmp62_;
					_tmp64_ = _data2_->path;
					_tmp65_ = location;
					_tmp66_ = g_strconcat (_tmp64_, _tmp65_, NULL);
					_tmp67_ = _tmp66_;
					soup_message_headers_replace (_tmp63_, "Location", _tmp67_);
					_g_free0 (_tmp67_);
				}
				_g_free0 (location);
			}
			_g_free0 (_tmp16_);
			block4_data_unref (_data4_);
			_data4_ = NULL;
			block3_data_unref (_data3_);
			_data3_ = NULL;
			return result;
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			gboolean _tmp68_ = FALSE;
			gboolean _tmp69_ = FALSE;
			gboolean _tmp70_ = FALSE;
			gboolean _tmp71_ = FALSE;
			gboolean _tmp72_ = FALSE;
			GError* _tmp73_ = NULL;
			GError* _tmp92_ = NULL;
			GError* _tmp93_ = NULL;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp73_ = err;
			if (g_error_matches (_tmp73_, VALUM_SUCCESS, VALUM_SUCCESS_CREATED)) {
				_tmp72_ = TRUE;
			} else {
				GError* _tmp74_ = NULL;
				_tmp74_ = err;
				_tmp72_ = g_error_matches (_tmp74_, VALUM_REDIRECTION, VALUM_REDIRECTION_MOVED_PERMANENTLY);
			}
			if (_tmp72_) {
				_tmp71_ = TRUE;
			} else {
				GError* _tmp75_ = NULL;
				_tmp75_ = err;
				_tmp71_ = g_error_matches (_tmp75_, VALUM_REDIRECTION, VALUM_REDIRECTION_FOUND);
			}
			if (_tmp71_) {
				_tmp70_ = TRUE;
			} else {
				GError* _tmp76_ = NULL;
				_tmp76_ = err;
				_tmp70_ = g_error_matches (_tmp76_, VALUM_REDIRECTION, VALUM_REDIRECTION_SEE_OTHER);
			}
			if (_tmp70_) {
				_tmp69_ = TRUE;
			} else {
				GError* _tmp77_ = NULL;
				_tmp77_ = err;
				_tmp69_ = g_error_matches (_tmp77_, VALUM_REDIRECTION, VALUM_REDIRECTION_USE_PROXY);
			}
			if (_tmp69_) {
				_tmp68_ = TRUE;
			} else {
				GError* _tmp78_ = NULL;
				_tmp78_ = err;
				_tmp68_ = g_error_matches (_tmp78_, VALUM_REDIRECTION, VALUM_REDIRECTION_TEMPORARY_REDIRECT);
			}
			if (_tmp68_) {
				gchar* _tmp79_ = NULL;
				GError* _tmp80_ = NULL;
				const gchar* _tmp81_ = NULL;
				gchar _tmp82_ = '\0';
				GError* _tmp90_ = NULL;
				gchar* _tmp91_ = NULL;
				_tmp80_ = err;
				_tmp81_ = _tmp80_->message;
				_tmp82_ = string_get (_tmp81_, (glong) 0);
				if (_tmp82_ == '/') {
					const gchar* _tmp83_ = NULL;
					GError* _tmp84_ = NULL;
					const gchar* _tmp85_ = NULL;
					gchar* _tmp86_ = NULL;
					_tmp83_ = _data2_->path;
					_tmp84_ = err;
					_tmp85_ = _tmp84_->message;
					_tmp86_ = g_strconcat (_tmp83_, _tmp85_, NULL);
					_g_free0 (_tmp79_);
					_tmp79_ = _tmp86_;
				} else {
					GError* _tmp87_ = NULL;
					const gchar* _tmp88_ = NULL;
					gchar* _tmp89_ = NULL;
					_tmp87_ = err;
					_tmp88_ = _tmp87_->message;
					_tmp89_ = g_strdup (_tmp88_);
					_g_free0 (_tmp79_);
					_tmp79_ = _tmp89_;
				}
				_tmp90_ = err;
				_tmp91_ = g_strdup (_tmp79_);
				_g_free0 (_tmp90_->message);
				_tmp90_->message = _tmp91_;
				_g_free0 (_tmp79_);
			}
			_tmp92_ = err;
			_tmp93_ = _g_error_copy0 (_tmp92_);
			_inner_error_ = _tmp93_;
			_g_error_free0 (err);
			goto __finally0;
		}
		__finally0:
		{
			VSGIRequest* _tmp94_ = NULL;
			SoupURI* _tmp95_ = NULL;
			SoupURI* _tmp96_ = NULL;
			const gchar* _tmp97_ = NULL;
			gchar* location = NULL;
			VSGIResponse* _tmp98_ = NULL;
			SoupMessageHeaders* _tmp99_ = NULL;
			SoupMessageHeaders* _tmp100_ = NULL;
			const gchar* _tmp101_ = NULL;
			gchar* _tmp102_ = NULL;
			gboolean _tmp53_ = FALSE;
			gboolean _tmp54_ = FALSE;
			VSGIResponse* _tmp103_ = NULL;
			gboolean _tmp104_ = FALSE;
			gboolean _tmp105_ = FALSE;
			_tmp94_ = _data3_->req;
			_tmp95_ = vsgi_request_get_uri (_tmp94_);
			_tmp96_ = _tmp95_;
			_tmp97_ = _data4_->original_path;
			soup_uri_set_path (_tmp96_, _tmp97_);
			_tmp98_ = _data3_->res;
			_tmp99_ = vsgi_response_get_headers (_tmp98_);
			_tmp100_ = _tmp99_;
			_tmp101_ = soup_message_headers_get_one (_tmp100_, "Location");
			_tmp102_ = g_strdup (_tmp101_);
			location = _tmp102_;
			_tmp103_ = _data3_->res;
			_tmp104_ = vsgi_response_get_head_written (_tmp103_);
			_tmp105_ = _tmp104_;
			if (!_tmp105_) {
				const gchar* _tmp106_ = NULL;
				_tmp106_ = location;
				_tmp54_ = _tmp106_ != NULL;
			} else {
				_tmp54_ = FALSE;
			}
			if (_tmp54_) {
				const gchar* _tmp107_ = NULL;
				gchar _tmp108_ = '\0';
				_tmp107_ = location;
				_tmp108_ = string_get (_tmp107_, (glong) 0);
				_tmp53_ = _tmp108_ == '/';
			} else {
				_tmp53_ = FALSE;
			}
			if (_tmp53_) {
				VSGIResponse* _tmp109_ = NULL;
				SoupMessageHeaders* _tmp110_ = NULL;
				SoupMessageHeaders* _tmp111_ = NULL;
				const gchar* _tmp112_ = NULL;
				const gchar* _tmp113_ = NULL;
				gchar* _tmp114_ = NULL;
				gchar* _tmp115_ = NULL;
				_tmp109_ = _data3_->res;
				_tmp110_ = vsgi_response_get_headers (_tmp109_);
				_tmp111_ = _tmp110_;
				_tmp112_ = _data2_->path;
				_tmp113_ = location;
				_tmp114_ = g_strconcat (_tmp112_, _tmp113_, NULL);
				_tmp115_ = _tmp114_;
				soup_message_headers_replace (_tmp111_, "Location", _tmp115_);
				_g_free0 (_tmp115_);
			}
			_g_free0 (location);
		}
		g_propagate_error (error, _inner_error_);
		_g_free0 (_tmp16_);
		block4_data_unref (_data4_);
		_data4_ = NULL;
		block3_data_unref (_data3_);
		_data3_ = NULL;
		return FALSE;
	} else {
		gboolean _tmp116_ = FALSE;
		ValumNextCallback _tmp117_ = NULL;
		void* _tmp117__target = NULL;
		gboolean _tmp118_ = FALSE;
		_tmp117_ = _data3_->next;
		_tmp117__target = _data3_->next_target;
		_tmp118_ = _tmp117_ (_tmp117__target, &_inner_error_);
		_tmp116_ = _tmp118_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			block3_data_unref (_data3_);
			_data3_ = NULL;
			return FALSE;
		}
		result = _tmp116_;
		block3_data_unref (_data3_);
		_data3_ = NULL;
		return result;
	}
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


static gboolean ___lambda13__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda13_ (self, req, res, next, next_target, context, error);
	return result;
}


ValumHandlerCallback valum_basepath (const gchar* path, ValumHandlerCallback forward, void* forward_target, GDestroyNotify forward_target_destroy_notify, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block2Data* _data2_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	ValumHandlerCallback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	ValumHandlerCallback _tmp3_ = NULL;
	void* _tmp3__target = NULL;
	GDestroyNotify _tmp3__target_destroy_notify = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_tmp0_ = path;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data2_->path);
	_data2_->path = _tmp1_;
	_tmp2_ = forward;
	_tmp2__target = forward_target;
	(_data2_->forward_target_destroy_notify == NULL) ? NULL : (_data2_->forward_target_destroy_notify (_data2_->forward_target), NULL);
	_data2_->forward = NULL;
	_data2_->forward_target = NULL;
	_data2_->forward_target_destroy_notify = NULL;
	_data2_->forward = _tmp2_;
	_data2_->forward_target = _tmp2__target;
	_data2_->forward_target_destroy_notify = forward_target_destroy_notify;
	_tmp3_ = ___lambda13__valum_handler_callback;
	_tmp3__target = block2_data_ref (_data2_);
	_tmp3__target_destroy_notify = block2_data_unref;
	*result_target = _tmp3__target;
	*result_target_destroy_notify = _tmp3__target_destroy_notify;
	result = _tmp3_;
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}



