/* valum-basic.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-basic.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))



static gboolean __lambda15_ (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, GError** error);
gboolean valum_is_status (GError* err);
static void _g_free0_ (gpointer var);
static gboolean ___lambda15__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);


/**
 * Provide a set of basic behaviours such as status and error handling.
 *
 * Raised status code are handled according to the expectations of the HTTP
 * specification.
 *
 * Other errors are treated as '500 Internal Server Error' with a
 * pre-defined payload.
 */
static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static gboolean __lambda15_ (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, GError** error) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		ValumNextCallback _tmp1_ = NULL;
		void* _tmp1__target = NULL;
		gboolean _tmp2_ = FALSE;
		_tmp1_ = next;
		_tmp1__target = next_target;
		_tmp2_ = _tmp1_ (_tmp1__target, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch1_g_error;
		}
		result = _tmp0_;
		return result;
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		VSGIResponse* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gint _tmp13_ = 0;
		GError* _tmp14_ = NULL;
		gboolean _tmp15_ = FALSE;
		VSGIResponse* _tmp18_ = NULL;
		VSGIResponse* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gboolean _tmp23_ = FALSE;
		VSGIResponse* _tmp40_ = NULL;
		guint _tmp41_ = 0U;
		guint _tmp42_ = 0U;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = res;
		_tmp4_ = vsgi_response_get_head_written (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			GError* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			GError* _tmp8_ = NULL;
			GQuark _tmp9_ = 0U;
			const gchar* _tmp10_ = NULL;
			GError* _tmp11_ = NULL;
			gint _tmp12_ = 0;
			_tmp6_ = err;
			_tmp7_ = _tmp6_->message;
			_tmp8_ = err;
			_tmp9_ = _tmp8_->domain;
			_tmp10_ = g_quark_to_string (_tmp9_);
			_tmp11_ = err;
			_tmp12_ = _tmp11_->code;
			g_critical ("valum-basic.vala:41: %s (%s, %d)", _tmp7_, _tmp10_, _tmp12_);
			result = TRUE;
			_g_error_free0 (err);
			return result;
		}
		_tmp14_ = err;
		_tmp15_ = valum_is_status (_tmp14_);
		if (_tmp15_) {
			GError* _tmp16_ = NULL;
			gint _tmp17_ = 0;
			_tmp16_ = err;
			_tmp17_ = _tmp16_->code;
			_tmp13_ = _tmp17_;
		} else {
			_tmp13_ = 500;
		}
		_tmp18_ = res;
		vsgi_response_set_status (_tmp18_, (guint) _tmp13_);
		_tmp19_ = res;
		_tmp20_ = vsgi_response_get_reason_phrase (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = _tmp21_;
		_tmp23_ = _tmp22_ == NULL;
		_g_free0 (_tmp22_);
		if (_tmp23_) {
			VSGIResponse* _tmp24_ = NULL;
			guint _tmp25_ = 0U;
			guint _tmp26_ = 0U;
			_tmp24_ = res;
			_tmp25_ = vsgi_response_get_status (_tmp24_);
			_tmp26_ = _tmp25_;
			switch (_tmp26_) {
				case 208:
				{
					VSGIResponse* _tmp27_ = NULL;
					_tmp27_ = res;
					vsgi_response_set_reason_phrase (_tmp27_, "Already Reported");
					break;
				}
				case 226:
				{
					VSGIResponse* _tmp28_ = NULL;
					_tmp28_ = res;
					vsgi_response_set_reason_phrase (_tmp28_, "IM Used");
					break;
				}
				case 308:
				{
					VSGIResponse* _tmp29_ = NULL;
					_tmp29_ = res;
					vsgi_response_set_reason_phrase (_tmp29_, "Permanent Redirect");
					break;
				}
				case 418:
				{
					VSGIResponse* _tmp30_ = NULL;
					_tmp30_ = res;
					vsgi_response_set_reason_phrase (_tmp30_, "I'm a teapot");
					break;
				}
				case 419:
				{
					VSGIResponse* _tmp31_ = NULL;
					_tmp31_ = res;
					vsgi_response_set_reason_phrase (_tmp31_, "Authentication Timeout");
					break;
				}
				case 421:
				{
					VSGIResponse* _tmp32_ = NULL;
					_tmp32_ = res;
					vsgi_response_set_reason_phrase (_tmp32_, "Misdirected Request");
					break;
				}
				case 426:
				{
					VSGIResponse* _tmp33_ = NULL;
					_tmp33_ = res;
					vsgi_response_set_reason_phrase (_tmp33_, "Upgrade Required");
					break;
				}
				case 428:
				{
					VSGIResponse* _tmp34_ = NULL;
					_tmp34_ = res;
					vsgi_response_set_reason_phrase (_tmp34_, "Precondition Required");
					break;
				}
				case 429:
				{
					VSGIResponse* _tmp35_ = NULL;
					_tmp35_ = res;
					vsgi_response_set_reason_phrase (_tmp35_, "Too Many Requests");
					break;
				}
				case 431:
				{
					VSGIResponse* _tmp36_ = NULL;
					_tmp36_ = res;
					vsgi_response_set_reason_phrase (_tmp36_, "Request Header Fields Too Large");
					break;
				}
				case 506:
				{
					VSGIResponse* _tmp37_ = NULL;
					_tmp37_ = res;
					vsgi_response_set_reason_phrase (_tmp37_, "Variants Also Negotiate");
					break;
				}
				case 508:
				{
					VSGIResponse* _tmp38_ = NULL;
					_tmp38_ = res;
					vsgi_response_set_reason_phrase (_tmp38_, "Loop Detected");
					break;
				}
				case 511:
				{
					VSGIResponse* _tmp39_ = NULL;
					_tmp39_ = res;
					vsgi_response_set_reason_phrase (_tmp39_, "Network Authentication Required");
					break;
				}
				default:
				break;
			}
		}
		_tmp40_ = res;
		_tmp41_ = vsgi_response_get_status (_tmp40_);
		_tmp42_ = _tmp41_;
		switch (_tmp42_) {
			case SOUP_STATUS_SWITCHING_PROTOCOLS:
			{
				VSGIResponse* _tmp43_ = NULL;
				SoupMessageHeaders* _tmp44_ = NULL;
				SoupMessageHeaders* _tmp45_ = NULL;
				GError* _tmp46_ = NULL;
				const gchar* _tmp47_ = NULL;
				VSGIResponse* _tmp48_ = NULL;
				SoupMessageHeaders* _tmp49_ = NULL;
				SoupMessageHeaders* _tmp50_ = NULL;
				_tmp43_ = res;
				_tmp44_ = vsgi_response_get_headers (_tmp43_);
				_tmp45_ = _tmp44_;
				_tmp46_ = err;
				_tmp47_ = _tmp46_->message;
				soup_message_headers_replace (_tmp45_, "Upgrade", _tmp47_);
				_tmp48_ = res;
				_tmp49_ = vsgi_response_get_headers (_tmp48_);
				_tmp50_ = _tmp49_;
				soup_message_headers_set_encoding (_tmp50_, SOUP_ENCODING_NONE);
				break;
			}
			case SOUP_STATUS_CREATED:
			{
				VSGIResponse* _tmp51_ = NULL;
				SoupMessageHeaders* _tmp52_ = NULL;
				SoupMessageHeaders* _tmp53_ = NULL;
				GError* _tmp54_ = NULL;
				const gchar* _tmp55_ = NULL;
				_tmp51_ = res;
				_tmp52_ = vsgi_response_get_headers (_tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = err;
				_tmp55_ = _tmp54_->message;
				soup_message_headers_replace (_tmp53_, "Location", _tmp55_);
				break;
			}
			case SOUP_STATUS_ACCEPTED:
			{
				VSGIResponse* _tmp56_ = NULL;
				SoupMessageHeaders* _tmp57_ = NULL;
				SoupMessageHeaders* _tmp58_ = NULL;
				GError* _tmp59_ = NULL;
				const gchar* _tmp60_ = NULL;
				_tmp56_ = res;
				_tmp57_ = vsgi_response_get_headers (_tmp56_);
				_tmp58_ = _tmp57_;
				_tmp59_ = err;
				_tmp60_ = _tmp59_->message;
				soup_message_headers_replace (_tmp58_, "Content-Location", _tmp60_);
				break;
			}
			case SOUP_STATUS_NO_CONTENT:
			case SOUP_STATUS_RESET_CONTENT:
			{
				VSGIResponse* _tmp61_ = NULL;
				SoupMessageHeaders* _tmp62_ = NULL;
				SoupMessageHeaders* _tmp63_ = NULL;
				_tmp61_ = res;
				_tmp62_ = vsgi_response_get_headers (_tmp61_);
				_tmp63_ = _tmp62_;
				soup_message_headers_set_encoding (_tmp63_, SOUP_ENCODING_NONE);
				break;
			}
			case SOUP_STATUS_PARTIAL_CONTENT:
			{
				VSGIResponse* _tmp64_ = NULL;
				SoupMessageHeaders* _tmp65_ = NULL;
				SoupMessageHeaders* _tmp66_ = NULL;
				GError* _tmp67_ = NULL;
				const gchar* _tmp68_ = NULL;
				_tmp64_ = res;
				_tmp65_ = vsgi_response_get_headers (_tmp64_);
				_tmp66_ = _tmp65_;
				_tmp67_ = err;
				_tmp68_ = _tmp67_->message;
				soup_message_headers_replace (_tmp66_, "Range", _tmp68_);
				break;
			}
			case SOUP_STATUS_MOVED_PERMANENTLY:
			case SOUP_STATUS_FOUND:
			case SOUP_STATUS_SEE_OTHER:
			{
				VSGIResponse* _tmp69_ = NULL;
				SoupMessageHeaders* _tmp70_ = NULL;
				SoupMessageHeaders* _tmp71_ = NULL;
				GError* _tmp72_ = NULL;
				const gchar* _tmp73_ = NULL;
				_tmp69_ = res;
				_tmp70_ = vsgi_response_get_headers (_tmp69_);
				_tmp71_ = _tmp70_;
				_tmp72_ = err;
				_tmp73_ = _tmp72_->message;
				soup_message_headers_replace (_tmp71_, "Location", _tmp73_);
				break;
			}
			case SOUP_STATUS_NOT_MODIFIED:
			{
				VSGIResponse* _tmp74_ = NULL;
				SoupMessageHeaders* _tmp75_ = NULL;
				SoupMessageHeaders* _tmp76_ = NULL;
				_tmp74_ = res;
				_tmp75_ = vsgi_response_get_headers (_tmp74_);
				_tmp76_ = _tmp75_;
				soup_message_headers_set_encoding (_tmp76_, SOUP_ENCODING_NONE);
				break;
			}
			case SOUP_STATUS_USE_PROXY:
			case SOUP_STATUS_TEMPORARY_REDIRECT:
			{
				VSGIResponse* _tmp77_ = NULL;
				SoupMessageHeaders* _tmp78_ = NULL;
				SoupMessageHeaders* _tmp79_ = NULL;
				GError* _tmp80_ = NULL;
				const gchar* _tmp81_ = NULL;
				_tmp77_ = res;
				_tmp78_ = vsgi_response_get_headers (_tmp77_);
				_tmp79_ = _tmp78_;
				_tmp80_ = err;
				_tmp81_ = _tmp80_->message;
				soup_message_headers_replace (_tmp79_, "Location", _tmp81_);
				break;
			}
			case SOUP_STATUS_UNAUTHORIZED:
			{
				VSGIResponse* _tmp82_ = NULL;
				SoupMessageHeaders* _tmp83_ = NULL;
				SoupMessageHeaders* _tmp84_ = NULL;
				GError* _tmp85_ = NULL;
				const gchar* _tmp86_ = NULL;
				_tmp82_ = res;
				_tmp83_ = vsgi_response_get_headers (_tmp82_);
				_tmp84_ = _tmp83_;
				_tmp85_ = err;
				_tmp86_ = _tmp85_->message;
				soup_message_headers_replace (_tmp84_, "WWW-Authenticate", _tmp86_);
				break;
			}
			case SOUP_STATUS_METHOD_NOT_ALLOWED:
			{
				VSGIResponse* _tmp87_ = NULL;
				SoupMessageHeaders* _tmp88_ = NULL;
				SoupMessageHeaders* _tmp89_ = NULL;
				GError* _tmp90_ = NULL;
				const gchar* _tmp91_ = NULL;
				_tmp87_ = res;
				_tmp88_ = vsgi_response_get_headers (_tmp87_);
				_tmp89_ = _tmp88_;
				_tmp90_ = err;
				_tmp91_ = _tmp90_->message;
				soup_message_headers_append (_tmp89_, "Allow", _tmp91_);
				break;
			}
			case 426:
			{
				VSGIResponse* _tmp92_ = NULL;
				SoupMessageHeaders* _tmp93_ = NULL;
				SoupMessageHeaders* _tmp94_ = NULL;
				GError* _tmp95_ = NULL;
				const gchar* _tmp96_ = NULL;
				_tmp92_ = res;
				_tmp93_ = vsgi_response_get_headers (_tmp92_);
				_tmp94_ = _tmp93_;
				_tmp95_ = err;
				_tmp96_ = _tmp95_->message;
				soup_message_headers_replace (_tmp94_, "Upgrade", _tmp96_);
				break;
			}
			default:
			{
				GHashTable* params = NULL;
				GHashTable* _tmp97_ = NULL;
				GHashTable* _tmp98_ = NULL;
				gchar* _tmp99_ = NULL;
				gchar* _tmp100_ = NULL;
				VSGIResponse* _tmp101_ = NULL;
				SoupMessageHeaders* _tmp102_ = NULL;
				SoupMessageHeaders* _tmp103_ = NULL;
				GHashTable* _tmp104_ = NULL;
				_tmp97_ = g_hash_table_new_full ((GHashFunc) soup_str_case_hash, (GEqualFunc) soup_str_case_equal, _g_free0_, _g_free0_);
				params = _tmp97_;
				_tmp98_ = params;
				_tmp99_ = g_strdup ("charset");
				_tmp100_ = g_strdup ("utf-8");
				g_hash_table_insert (_tmp98_, _tmp99_, _tmp100_);
				_tmp101_ = res;
				_tmp102_ = vsgi_response_get_headers (_tmp101_);
				_tmp103_ = _tmp102_;
				_tmp104_ = params;
				soup_message_headers_set_content_type (_tmp103_, "text/plain", _tmp104_);
				{
					GError* _tmp105_ = NULL;
					gboolean _tmp106_ = FALSE;
					_tmp105_ = err;
					_tmp106_ = valum_is_status (_tmp105_);
					if (_tmp106_) {
						gboolean _tmp107_ = FALSE;
						VSGIResponse* _tmp108_ = NULL;
						GError* _tmp109_ = NULL;
						const gchar* _tmp110_ = NULL;
						gboolean _tmp111_ = FALSE;
						_tmp108_ = res;
						_tmp109_ = err;
						_tmp110_ = _tmp109_->message;
						_tmp111_ = vsgi_response_expand_utf8 (_tmp108_, _tmp110_, NULL, &_inner_error_);
						_tmp107_ = _tmp111_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == G_IO_ERROR) {
								goto __catch2_g_io_error;
							}
							_g_hash_table_unref0 (params);
							_g_error_free0 (err);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return FALSE;
						}
						result = _tmp107_;
						_g_hash_table_unref0 (params);
						_g_error_free0 (err);
						return result;
					} else {
						GError* _tmp112_ = NULL;
						const gchar* _tmp113_ = NULL;
						GError* _tmp114_ = NULL;
						GQuark _tmp115_ = 0U;
						const gchar* _tmp116_ = NULL;
						GError* _tmp117_ = NULL;
						gint _tmp118_ = 0;
						gboolean _tmp119_ = FALSE;
						VSGIResponse* _tmp120_ = NULL;
						gboolean _tmp121_ = FALSE;
						_tmp112_ = err;
						_tmp113_ = _tmp112_->message;
						_tmp114_ = err;
						_tmp115_ = _tmp114_->domain;
						_tmp116_ = g_quark_to_string (_tmp115_);
						_tmp117_ = err;
						_tmp118_ = _tmp117_->code;
						g_critical ("valum-basic.vala:169: %s (%s, %d)", _tmp113_, _tmp116_, _tmp118_);
						_tmp120_ = res;
						_tmp121_ = vsgi_response_expand_utf8 (_tmp120_, "The server encountered an unexpected condition which prevented it from" \
" fulfilling the request.", NULL, &_inner_error_);
						_tmp119_ = _tmp121_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == G_IO_ERROR) {
								goto __catch2_g_io_error;
							}
							_g_hash_table_unref0 (params);
							_g_error_free0 (err);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return FALSE;
						}
						result = _tmp119_;
						_g_hash_table_unref0 (params);
						_g_error_free0 (err);
						return result;
					}
				}
				goto __finally2;
				__catch2_g_io_error:
				{
					GError* io_err = NULL;
					GError* _tmp122_ = NULL;
					const gchar* _tmp123_ = NULL;
					GError* _tmp124_ = NULL;
					GQuark _tmp125_ = 0U;
					const gchar* _tmp126_ = NULL;
					GError* _tmp127_ = NULL;
					gint _tmp128_ = 0;
					io_err = _inner_error_;
					_inner_error_ = NULL;
					_tmp122_ = io_err;
					_tmp123_ = _tmp122_->message;
					_tmp124_ = io_err;
					_tmp125_ = _tmp124_->domain;
					_tmp126_ = g_quark_to_string (_tmp125_);
					_tmp127_ = io_err;
					_tmp128_ = _tmp127_->code;
					g_critical ("valum-basic.vala:173: %s (%s, %d)", _tmp123_, _tmp126_, _tmp128_);
					_g_error_free0 (io_err);
				}
				__finally2:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_hash_table_unref0 (params);
					_g_error_free0 (err);
					_g_hash_table_unref0 (params);
					_g_error_free0 (err);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return FALSE;
				}
				_g_hash_table_unref0 (params);
				break;
			}
		}
		{
			gboolean _tmp129_ = FALSE;
			VSGIResponse* _tmp130_ = NULL;
			gboolean _tmp131_ = FALSE;
			_tmp130_ = res;
			_tmp131_ = vsgi_response_end (_tmp130_, NULL, &_inner_error_);
			_tmp129_ = _tmp131_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch3_g_io_error;
				}
				_g_error_free0 (err);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			result = _tmp129_;
			_g_error_free0 (err);
			return result;
		}
		goto __finally3;
		__catch3_g_io_error:
		{
			GError* io_err = NULL;
			GError* _tmp132_ = NULL;
			const gchar* _tmp133_ = NULL;
			GError* _tmp134_ = NULL;
			GQuark _tmp135_ = 0U;
			const gchar* _tmp136_ = NULL;
			GError* _tmp137_ = NULL;
			gint _tmp138_ = 0;
			io_err = _inner_error_;
			_inner_error_ = NULL;
			_tmp132_ = io_err;
			_tmp133_ = _tmp132_->message;
			_tmp134_ = io_err;
			_tmp135_ = _tmp134_->domain;
			_tmp136_ = g_quark_to_string (_tmp135_);
			_tmp137_ = io_err;
			_tmp138_ = _tmp137_->code;
			g_critical ("valum-basic.vala:181: %s (%s, %d)", _tmp133_, _tmp136_, _tmp138_);
			result = TRUE;
			_g_error_free0 (io_err);
			_g_error_free0 (err);
			return result;
		}
		__finally3:
		_g_error_free0 (err);
		_g_error_free0 (err);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	__finally1:
	g_propagate_error (error, _inner_error_);
	return FALSE;
}


static gboolean ___lambda15__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda15_ (req, res, next, next_target, error);
	return result;
}


ValumHandlerCallback valum_basic (void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	ValumHandlerCallback _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	_tmp0_ = ___lambda15__valum_handler_callback;
	_tmp0__target = NULL;
	_tmp0__target_destroy_notify = NULL;
	*result_target = _tmp0__target;
	*result_target_destroy_notify = _tmp0__target_destroy_notify;
	result = _tmp0_;
	return result;
}



