/* valum-cache-control.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-cache-control.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>

typedef struct _Block5Data Block5Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _Block5Data {
	int _ref_count_;
	ValumCacheControlDirective directive;
	GTimeSpan max_age;
};



static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda16_ (Block5Data* _data5_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, GError** error);
static gboolean ___lambda16__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);


GType valum_cache_control_directive_get_type (void) {
	static volatile gsize valum_cache_control_directive_type_id__volatile = 0;
	if (g_once_init_enter (&valum_cache_control_directive_type_id__volatile)) {
		static const GEnumValue values[] = {{VALUM_CACHE_CONTROL_DIRECTIVE_PUBLIC, "VALUM_CACHE_CONTROL_DIRECTIVE_PUBLIC", "public"}, {VALUM_CACHE_CONTROL_DIRECTIVE_PRIVATE, "VALUM_CACHE_CONTROL_DIRECTIVE_PRIVATE", "private"}, {VALUM_CACHE_CONTROL_DIRECTIVE_NO_CACHE, "VALUM_CACHE_CONTROL_DIRECTIVE_NO_CACHE", "no-cache"}, {VALUM_CACHE_CONTROL_DIRECTIVE_NO_STORE, "VALUM_CACHE_CONTROL_DIRECTIVE_NO_STORE", "no-store"}, {VALUM_CACHE_CONTROL_DIRECTIVE_NO_TRANSFORM, "VALUM_CACHE_CONTROL_DIRECTIVE_NO_TRANSFORM", "no-transform"}, {VALUM_CACHE_CONTROL_DIRECTIVE_MUST_REVALIDATE, "VALUM_CACHE_CONTROL_DIRECTIVE_MUST_REVALIDATE", "must-revalidate"}, {VALUM_CACHE_CONTROL_DIRECTIVE_PROXY_REVALIDATE, "VALUM_CACHE_CONTROL_DIRECTIVE_PROXY_REVALIDATE", "proxy-revalidate"}, {VALUM_CACHE_CONTROL_DIRECTIVE_MAX_AGE, "VALUM_CACHE_CONTROL_DIRECTIVE_MAX_AGE", "max-age"}, {VALUM_CACHE_CONTROL_DIRECTIVE_S_MAXAGE, "VALUM_CACHE_CONTROL_DIRECTIVE_S_MAXAGE", "s-maxage"}, {0, NULL, NULL}};
		GType valum_cache_control_directive_type_id;
		valum_cache_control_directive_type_id = g_enum_register_static ("ValumCacheControlDirective", values);
		g_once_init_leave (&valum_cache_control_directive_type_id__volatile, valum_cache_control_directive_type_id);
	}
	return valum_cache_control_directive_type_id__volatile;
}


/**
 * Produce a 'Cache-Control' response header.
 *
 * @param directive directive for the 'Cache-Control' header
 * @param max_age   argument for 'max-age' or 's-maxage' directives if
 *                  specified in the type, otherwise it's used for 'max-age'
 *                  if greater than zero
 */
static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		g_slice_free (Block5Data, _data5_);
	}
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


static gboolean __lambda16_ (Block5Data* _data5_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, GError** error) {
	gboolean result = FALSE;
	GString* cache_control_header = NULL;
	GString* _tmp0_ = NULL;
	ValumCacheControlDirective _tmp1_ = 0;
	VSGIResponse* _tmp22_ = NULL;
	SoupMessageHeaders* _tmp23_ = NULL;
	SoupMessageHeaders* _tmp24_ = NULL;
	GString* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	gboolean _tmp27_ = FALSE;
	ValumNextCallback _tmp28_ = NULL;
	void* _tmp28__target = NULL;
	gboolean _tmp29_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	_tmp0_ = g_string_new ("");
	cache_control_header = _tmp0_;
	_tmp1_ = _data5_->directive;
	switch (_tmp1_) {
		case VALUM_CACHE_CONTROL_DIRECTIVE_PUBLIC:
		case VALUM_CACHE_CONTROL_DIRECTIVE_PRIVATE:
		case VALUM_CACHE_CONTROL_DIRECTIVE_NO_CACHE:
		case VALUM_CACHE_CONTROL_DIRECTIVE_NO_STORE:
		case VALUM_CACHE_CONTROL_DIRECTIVE_NO_TRANSFORM:
		case VALUM_CACHE_CONTROL_DIRECTIVE_MUST_REVALIDATE:
		case VALUM_CACHE_CONTROL_DIRECTIVE_PROXY_REVALIDATE:
		{
			GString* _tmp2_ = NULL;
			ValumCacheControlDirective _tmp3_ = 0;
			GEnumValue* _tmp4_;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			ValumCacheControlDirective _tmp9_ = 0;
			GEnumValue* _tmp10_;
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_ = NULL;
			GTimeSpan _tmp15_ = 0LL;
			_tmp2_ = cache_control_header;
			_tmp3_ = _data5_->directive;
			_tmp4_ = g_enum_get_value (g_type_class_ref (VALUM_TYPE_CACHE_CONTROL_DIRECTIVE), _tmp3_);
			_tmp5_ = string_replace ((_tmp4_ != NULL) ? _tmp4_->value_name : NULL, "_", "-");
			_tmp6_ = _tmp5_;
			_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) (-1));
			_tmp8_ = _tmp7_;
			_tmp9_ = _data5_->directive;
			_tmp10_ = g_enum_get_value (g_type_class_ref (VALUM_TYPE_CACHE_CONTROL_DIRECTIVE), _tmp9_);
			_tmp11_ = strlen ((_tmp10_ != NULL) ? _tmp10_->value_name : NULL);
			_tmp12_ = _tmp11_;
			_tmp13_ = string_slice (_tmp8_, (glong) 30, (glong) _tmp12_);
			_tmp14_ = _tmp13_;
			g_string_append (_tmp2_, _tmp14_);
			_g_free0 (_tmp14_);
			_g_free0 (_tmp8_);
			_g_free0 (_tmp6_);
			_tmp15_ = _data5_->max_age;
			if (_tmp15_ > ((GTimeSpan) 0)) {
				GString* _tmp16_ = NULL;
				GTimeSpan _tmp17_ = 0LL;
				_tmp16_ = cache_control_header;
				_tmp17_ = _data5_->max_age;
				g_string_append_printf (_tmp16_, ", max-age=%" G_GINT64_FORMAT, _tmp17_ / G_TIME_SPAN_SECOND);
			}
			break;
		}
		case VALUM_CACHE_CONTROL_DIRECTIVE_MAX_AGE:
		{
			GString* _tmp18_ = NULL;
			GTimeSpan _tmp19_ = 0LL;
			_tmp18_ = cache_control_header;
			_tmp19_ = _data5_->max_age;
			g_string_append_printf (_tmp18_, "max-age=%" G_GINT64_FORMAT, _tmp19_ / G_TIME_SPAN_SECOND);
			break;
		}
		case VALUM_CACHE_CONTROL_DIRECTIVE_S_MAXAGE:
		{
			GString* _tmp20_ = NULL;
			GTimeSpan _tmp21_ = 0LL;
			_tmp20_ = cache_control_header;
			_tmp21_ = _data5_->max_age;
			g_string_append_printf (_tmp20_, "s-maxage=%" G_GINT64_FORMAT, _tmp21_ / G_TIME_SPAN_SECOND);
			break;
		}
		default:
		break;
	}
	_tmp22_ = res;
	_tmp23_ = vsgi_response_get_headers (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = cache_control_header;
	_tmp26_ = _tmp25_->str;
	soup_message_headers_append (_tmp24_, "Cache-Control", _tmp26_);
	_tmp28_ = next;
	_tmp28__target = next_target;
	_tmp29_ = _tmp28_ (_tmp28__target, &_inner_error_);
	_tmp27_ = _tmp29_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_string_free0 (cache_control_header);
		return FALSE;
	}
	result = _tmp27_;
	_g_string_free0 (cache_control_header);
	return result;
}


static gboolean ___lambda16__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda16_ (self, req, res, next, next_target, error);
	return result;
}


ValumHandlerCallback valum_cache_control (ValumCacheControlDirective directive, GTimeSpan max_age, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block5Data* _data5_;
	ValumCacheControlDirective _tmp0_ = 0;
	GTimeSpan _tmp1_ = 0LL;
	ValumHandlerCallback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	GDestroyNotify _tmp2__target_destroy_notify = NULL;
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_tmp0_ = directive;
	_data5_->directive = _tmp0_;
	_tmp1_ = max_age;
	_data5_->max_age = _tmp1_;
	_tmp2_ = ___lambda16__valum_handler_callback;
	_tmp2__target = block5_data_ref (_data5_);
	_tmp2__target_destroy_notify = block5_data_unref;
	*result_target = _tmp2__target;
	*result_target_destroy_notify = _tmp2__target_destroy_notify;
	result = _tmp2_;
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return result;
}



