/* valum-decode.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-decode.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>
#include <gio/gio.h>

typedef struct _Block7Data Block7Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))

struct _Block7Data {
	int _ref_count_;
	ValumDecodeFlags flags;
};



static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda17_ (Block7Data* _data7_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static void _g_free0_ (gpointer var);
static void _g_slist_free__g_free0_ (GSList* self);
static gboolean ___lambda17__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);


GType valum_decode_flags_get_type (void) {
	static volatile gsize valum_decode_flags_type_id__volatile = 0;
	if (g_once_init_enter (&valum_decode_flags_type_id__volatile)) {
		static const GEnumValue values[] = {{VALUM_DECODE_FLAGS_NONE, "VALUM_DECODE_FLAGS_NONE", "none"}, {VALUM_DECODE_FLAGS_FORWARD_REMAINING_ENCODINGS, "VALUM_DECODE_FLAGS_FORWARD_REMAINING_ENCODINGS", "forward-remaining-encodings"}, {0, NULL, NULL}};
		GType valum_decode_flags_type_id;
		valum_decode_flags_type_id = g_enum_register_static ("ValumDecodeFlags", values);
		g_once_init_leave (&valum_decode_flags_type_id__volatile, valum_decode_flags_type_id);
	}
	return valum_decode_flags_type_id__volatile;
}


/**
 * Decode any applied 'Content-Encoding'.
 *
 * Supports 'gzip', 'deflate' and 'identity', otherwise raise a
 * {@link Valum.ServerError.NOT_IMPLEMENTED}.
 */
static Block7Data* block7_data_ref (Block7Data* _data7_) {
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}


static void block7_data_unref (void * _userdata_) {
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		g_slice_free (Block7Data, _data7_);
	}
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_slist_free__g_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
	g_slist_free (self);
}


static gboolean __lambda17_ (Block7Data* _data7_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	VSGIRequest* _tmp1_ = NULL;
	SoupMessageHeaders* _tmp2_ = NULL;
	SoupMessageHeaders* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GSList* encodings = NULL;
	GSList* _tmp5_ = NULL;
	VSGIRequest* _tmp6_ = NULL;
	SoupMessageHeaders* _tmp7_ = NULL;
	SoupMessageHeaders* _tmp8_ = NULL;
	gboolean _tmp39_ = FALSE;
	ValumNextCallback _tmp40_ = NULL;
	void* _tmp40__target = NULL;
	gboolean _tmp41_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp1_ = req;
	_tmp2_ = vsgi_request_get_headers (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = soup_message_headers_get_list (_tmp3_, "Content-Encoding");
	_tmp0_ = _tmp4_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "";
	}
	_tmp5_ = soup_header_parse_list (_tmp0_);
	encodings = _tmp5_;
	encodings = g_slist_reverse (encodings);
	_tmp6_ = req;
	_tmp7_ = vsgi_request_get_headers (_tmp6_);
	_tmp8_ = _tmp7_;
	soup_message_headers_remove (_tmp8_, "Content-Encoding");
	{
		GSList* encoding = NULL;
		GSList* _tmp9_ = NULL;
		_tmp9_ = encodings;
		encoding = _tmp9_;
		{
			gboolean _tmp10_ = FALSE;
			_tmp10_ = TRUE;
			while (TRUE) {
				GSList* _tmp13_ = NULL;
				GSList* _tmp14_ = NULL;
				gconstpointer _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				GQuark _tmp19_ = 0U;
				static GQuark _tmp18_label0 = 0;
				static GQuark _tmp18_label1 = 0;
				static GQuark _tmp18_label2 = 0;
				static GQuark _tmp18_label3 = 0;
				if (!_tmp10_) {
					GSList* _tmp11_ = NULL;
					GSList* _tmp12_ = NULL;
					_tmp11_ = encoding;
					_tmp12_ = _tmp11_->next;
					encoding = _tmp12_;
				}
				_tmp10_ = FALSE;
				_tmp13_ = encoding;
				if (!(_tmp13_ != NULL)) {
					break;
				}
				_tmp14_ = encoding;
				_tmp15_ = _tmp14_->data;
				_tmp16_ = g_utf8_strdown ((const gchar*) _tmp15_, (gssize) (-1));
				_tmp17_ = _tmp16_;
				_tmp19_ = (NULL == _tmp17_) ? 0 : g_quark_from_string (_tmp17_);
				g_free (_tmp17_);
				if ((_tmp19_ == ((0 != _tmp18_label0) ? _tmp18_label0 : (_tmp18_label0 = g_quark_from_static_string ("gzip")))) || (_tmp19_ == ((0 != _tmp18_label1) ? _tmp18_label1 : (_tmp18_label1 = g_quark_from_static_string ("x-gzip"))))) {
					switch (0) {
						default:
						{
							VSGIRequest* _tmp20_ = NULL;
							GZlibDecompressor* _tmp21_ = NULL;
							GZlibDecompressor* _tmp22_ = NULL;
							_tmp20_ = req;
							_tmp21_ = g_zlib_decompressor_new (G_ZLIB_COMPRESSOR_FORMAT_GZIP);
							_tmp22_ = _tmp21_;
							vsgi_request_convert (_tmp20_, (GConverter*) _tmp22_, (gint64) (-1));
							_g_object_unref0 (_tmp22_);
							break;
						}
					}
				} else if (_tmp19_ == ((0 != _tmp18_label2) ? _tmp18_label2 : (_tmp18_label2 = g_quark_from_static_string ("deflate")))) {
					switch (0) {
						default:
						{
							VSGIRequest* _tmp23_ = NULL;
							GZlibDecompressor* _tmp24_ = NULL;
							GZlibDecompressor* _tmp25_ = NULL;
							_tmp23_ = req;
							_tmp24_ = g_zlib_decompressor_new (G_ZLIB_COMPRESSOR_FORMAT_RAW);
							_tmp25_ = _tmp24_;
							vsgi_request_convert (_tmp23_, (GConverter*) _tmp25_, (gint64) (-1));
							_g_object_unref0 (_tmp25_);
							break;
						}
					}
				} else if (_tmp19_ == ((0 != _tmp18_label3) ? _tmp18_label3 : (_tmp18_label3 = g_quark_from_static_string ("identity")))) {
					switch (0) {
						default:
						{
							break;
						}
					}
				} else {
					switch (0) {
						default:
						{
							GSList* _tmp26_ = NULL;
							ValumDecodeFlags _tmp32_ = 0;
							encoding = g_slist_reverse (encoding);
							_tmp26_ = encoding;
							{
								GSList* remaining_collection = NULL;
								GSList* remaining_it = NULL;
								remaining_collection = _tmp26_;
								for (remaining_it = remaining_collection; remaining_it != NULL; remaining_it = remaining_it->next) {
									gchar* _tmp27_ = NULL;
									gchar* remaining = NULL;
									_tmp27_ = g_strdup ((const gchar*) remaining_it->data);
									remaining = _tmp27_;
									{
										VSGIRequest* _tmp28_ = NULL;
										SoupMessageHeaders* _tmp29_ = NULL;
										SoupMessageHeaders* _tmp30_ = NULL;
										const gchar* _tmp31_ = NULL;
										_tmp28_ = req;
										_tmp29_ = vsgi_request_get_headers (_tmp28_);
										_tmp30_ = _tmp29_;
										_tmp31_ = remaining;
										soup_message_headers_append (_tmp30_, "Content-Encoding", _tmp31_);
										_g_free0 (remaining);
									}
								}
							}
							_tmp32_ = _data7_->flags;
							if ((_tmp32_ & VALUM_DECODE_FLAGS_FORWARD_REMAINING_ENCODINGS) == VALUM_DECODE_FLAGS_FORWARD_REMAINING_ENCODINGS) {
								gboolean _tmp33_ = FALSE;
								ValumNextCallback _tmp34_ = NULL;
								void* _tmp34__target = NULL;
								gboolean _tmp35_ = FALSE;
								_tmp34_ = next;
								_tmp34__target = next_target;
								_tmp35_ = _tmp34_ (_tmp34__target, &_inner_error_);
								_tmp33_ = _tmp35_;
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									g_propagate_error (error, _inner_error_);
									__g_slist_free__g_free0_0 (encodings);
									return FALSE;
								}
								result = _tmp33_;
								__g_slist_free__g_free0_0 (encodings);
								return result;
							} else {
								GSList* _tmp36_ = NULL;
								gconstpointer _tmp37_ = NULL;
								GError* _tmp38_ = NULL;
								_tmp36_ = encoding;
								_tmp37_ = _tmp36_->data;
								_tmp38_ = g_error_new (VALUM_CLIENT_ERROR, VALUM_CLIENT_ERROR_UNSUPPORTED_MEDIA_TYPE, "The '%s' encoding is not supported.", (const gchar*) _tmp37_);
								_inner_error_ = _tmp38_;
								g_propagate_error (error, _inner_error_);
								__g_slist_free__g_free0_0 (encodings);
								return FALSE;
							}
						}
					}
				}
			}
		}
	}
	_tmp40_ = next;
	_tmp40__target = next_target;
	_tmp41_ = _tmp40_ (_tmp40__target, &_inner_error_);
	_tmp39_ = _tmp41_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		__g_slist_free__g_free0_0 (encodings);
		return FALSE;
	}
	result = _tmp39_;
	__g_slist_free__g_free0_0 (encodings);
	return result;
}


static gboolean ___lambda17__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda17_ (self, req, res, next, next_target, context, error);
	return result;
}


ValumHandlerCallback valum_decode (ValumDecodeFlags flags, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block7Data* _data7_;
	ValumDecodeFlags _tmp0_ = 0;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	GDestroyNotify _tmp1__target_destroy_notify = NULL;
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_tmp0_ = flags;
	_data7_->flags = _tmp0_;
	_tmp1_ = ___lambda17__valum_handler_callback;
	_tmp1__target = block7_data_ref (_data7_);
	_tmp1__target_destroy_notify = block7_data_unref;
	*result_target = _tmp1__target;
	*result_target_destroy_notify = _tmp1__target_destroy_notify;
	result = _tmp1_;
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return result;
}



