/* valum-forward-with.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-forward-with.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"

typedef struct _Block8Data Block8Data;

struct _Block8Data {
	int _ref_count_;
	GType t_type;
	GBoxedCopyFunc t_dup_func;
	GDestroyNotify t_destroy_func;
	ValumHandlerCallback handle;
	gpointer handle_target;
	GDestroyNotify handle_target_destroy_notify;
};



static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean __lambda18_ (Block8Data* _data8_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, gconstpointer value, GError** error);
static gboolean ___lambda18__valum_forward_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gconstpointer value, gpointer self, GError** error);


/**
 * Forward using a provided handler callback.
 *
 * This is basically a hack to pass a {@link Valum.HandlerCallback} where a
 * {@link Valum.ForwardCallback} is expected, discarding the forwarded
 * value.
 */
static Block8Data* block8_data_ref (Block8Data* _data8_) {
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}


static void block8_data_unref (void * _userdata_) {
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		GType t_type;
		GBoxedCopyFunc t_dup_func;
		GDestroyNotify t_destroy_func;
		t_type = _data8_->t_type;
		t_dup_func = _data8_->t_dup_func;
		t_destroy_func = _data8_->t_destroy_func;
		(_data8_->handle_target_destroy_notify == NULL) ? NULL : (_data8_->handle_target_destroy_notify (_data8_->handle_target), NULL);
		_data8_->handle = NULL;
		_data8_->handle_target = NULL;
		_data8_->handle_target_destroy_notify = NULL;
		g_slice_free (Block8Data, _data8_);
	}
}


static gboolean __lambda18_ (Block8Data* _data8_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, gconstpointer value, GError** error) {
	GType t_type;
	GBoxedCopyFunc t_dup_func;
	GDestroyNotify t_destroy_func;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	ValumNextCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	ValumContext* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
	t_type = _data8_->t_type;
	t_dup_func = _data8_->t_dup_func;
	t_destroy_func = _data8_->t_destroy_func;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp1_ = _data8_->handle;
	_tmp1__target = _data8_->handle_target;
	_tmp2_ = req;
	_tmp3_ = res;
	_tmp4_ = next;
	_tmp4__target = next_target;
	_tmp5_ = ctx;
	_tmp6_ = _tmp1_ (_tmp2_, _tmp3_, _tmp4_, _tmp4__target, _tmp5_, _tmp1__target, &_inner_error_);
	_tmp0_ = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp0_;
	return result;
}


static gboolean ___lambda18__valum_forward_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gconstpointer value, gpointer self, GError** error) {
	gboolean result;
	result = __lambda18_ (self, req, res, next, next_target, context, value, error);
	return result;
}


ValumForwardCallback valum_forward_with (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, ValumHandlerCallback handle, void* handle_target, GDestroyNotify handle_target_destroy_notify, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumForwardCallback result = NULL;
	Block8Data* _data8_;
	ValumHandlerCallback _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	ValumForwardCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	GDestroyNotify _tmp1__target_destroy_notify = NULL;
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->t_type = t_type;
	_data8_->t_dup_func = t_dup_func;
	_data8_->t_destroy_func = t_destroy_func;
	_tmp0_ = handle;
	_tmp0__target = handle_target;
	(_data8_->handle_target_destroy_notify == NULL) ? NULL : (_data8_->handle_target_destroy_notify (_data8_->handle_target), NULL);
	_data8_->handle = NULL;
	_data8_->handle_target = NULL;
	_data8_->handle_target_destroy_notify = NULL;
	_data8_->handle = _tmp0_;
	_data8_->handle_target = _tmp0__target;
	_data8_->handle_target_destroy_notify = handle_target_destroy_notify;
	_tmp1_ = ___lambda18__valum_forward_callback;
	_tmp1__target = block8_data_ref (_data8_);
	_tmp1__target_destroy_notify = block8_data_unref;
	*result_target = _tmp1__target;
	*result_target_destroy_notify = _tmp1__target_destroy_notify;
	result = _tmp1_;
	block8_data_unref (_data8_);
	_data8_ = NULL;
	return result;
}



