/* valum-path-route.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-path-route.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include <stdlib.h>
#include <string.h>
#include "vsgi.h"
#include <libsoup/soup.h>

#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValumPathRoutePrivate {
	gchar* _path;
	ValumHandlerCallback _fire;
	gpointer _fire_target;
	GDestroyNotify _fire_target_destroy_notify;
};


static gpointer valum_path_route_parent_class = NULL;

#define VALUM_PATH_ROUTE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALUM_TYPE_PATH_ROUTE, ValumPathRoutePrivate))
enum  {
	VALUM_PATH_ROUTE_DUMMY_PROPERTY,
	VALUM_PATH_ROUTE_PATH
};
static gboolean valum_path_route_real_match (ValumRoute* base, VSGIRequest* req, ValumContext* ctx);
static gboolean valum_path_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static gchar* valum_path_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params);
static void valum_path_route_finalize (GObject* obj);
static void _vala_valum_path_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_valum_path_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


ValumPathRoute* valum_path_route_construct (GType object_type, ValumMethod method, const gchar* path, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	ValumPathRoute * self = NULL;
	ValumMethod _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	ValumHandlerCallback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	GDestroyNotify _tmp2__target_destroy_notify = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = method;
	_tmp1_ = path;
	self = (ValumPathRoute*) g_object_new (object_type, "method", _tmp0_, "path", _tmp1_, NULL);
	_tmp2_ = handler;
	_tmp2__target = handler_target;
	_tmp2__target_destroy_notify = handler_target_destroy_notify;
	handler_target_destroy_notify = NULL;
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	self->priv->_fire = _tmp2_;
	self->priv->_fire_target = _tmp2__target;
	self->priv->_fire_target_destroy_notify = _tmp2__target_destroy_notify;
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
	return self;
}


ValumPathRoute* valum_path_route_new (ValumMethod method, const gchar* path, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	return valum_path_route_construct (VALUM_TYPE_PATH_ROUTE, method, path, handler, handler_target, handler_target_destroy_notify);
}


static gboolean valum_path_route_real_match (ValumRoute* base, VSGIRequest* req, ValumContext* ctx) {
	ValumPathRoute * self;
	gboolean result = FALSE;
	VSGIRequest* _tmp0_ = NULL;
	SoupURI* _tmp1_ = NULL;
	SoupURI* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	self = (ValumPathRoute*) base;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = req;
	_tmp1_ = vsgi_request_get_uri (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = soup_uri_get_path (_tmp2_);
	_tmp4_ = self->priv->_path;
	result = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	return result;
}


static gboolean valum_path_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	ValumPathRoute * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	ValumNextCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	ValumContext* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (ValumPathRoute*) base;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp1_ = self->priv->_fire;
	_tmp1__target = self->priv->_fire_target;
	_tmp2_ = req;
	_tmp3_ = res;
	_tmp4_ = next;
	_tmp4__target = next_target;
	_tmp5_ = ctx;
	_tmp6_ = _tmp1_ (_tmp2_, _tmp3_, _tmp4_, _tmp4__target, _tmp5_, _tmp1__target, &_inner_error_);
	_tmp0_ = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp0_;
	return result;
}


static gchar* valum_path_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params) {
	ValumPathRoute * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (ValumPathRoute*) base;
	_tmp0_ = self->priv->_path;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


const gchar* valum_path_route_get_path (ValumPathRoute* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_path;
	result = _tmp0_;
	return result;
}


static void valum_path_route_set_path (ValumPathRoute* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_path);
	self->priv->_path = _tmp1_;
	g_object_notify ((GObject *) self, "path");
}


static void valum_path_route_class_init (ValumPathRouteClass * klass) {
	valum_path_route_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValumPathRoutePrivate));
	((ValumRouteClass *) klass)->match = valum_path_route_real_match;
	((ValumRouteClass *) klass)->fire = valum_path_route_real_fire;
	((ValumRouteClass *) klass)->to_url_from_hash = valum_path_route_real_to_url_from_hash;
	G_OBJECT_CLASS (klass)->get_property = _vala_valum_path_route_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valum_path_route_set_property;
	G_OBJECT_CLASS (klass)->finalize = valum_path_route_finalize;
	/**
	 * The path matched by this route.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALUM_PATH_ROUTE_PATH, g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valum_path_route_instance_init (ValumPathRoute * self) {
	self->priv = VALUM_PATH_ROUTE_GET_PRIVATE (self);
}


static void valum_path_route_finalize (GObject* obj) {
	ValumPathRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALUM_TYPE_PATH_ROUTE, ValumPathRoute);
	_g_free0 (self->priv->_path);
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	G_OBJECT_CLASS (valum_path_route_parent_class)->finalize (obj);
}


/**
 * Route based on exact path matching.
 */
GType valum_path_route_get_type (void) {
	static volatile gsize valum_path_route_type_id__volatile = 0;
	if (g_once_init_enter (&valum_path_route_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValumPathRouteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valum_path_route_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValumPathRoute), 0, (GInstanceInitFunc) valum_path_route_instance_init, NULL };
		GType valum_path_route_type_id;
		valum_path_route_type_id = g_type_register_static (VALUM_TYPE_ROUTE, "ValumPathRoute", &g_define_type_info, 0);
		g_once_init_leave (&valum_path_route_type_id__volatile, valum_path_route_type_id);
	}
	return valum_path_route_type_id__volatile;
}


static void _vala_valum_path_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValumPathRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_PATH_ROUTE, ValumPathRoute);
	switch (property_id) {
		case VALUM_PATH_ROUTE_PATH:
		g_value_set_string (value, valum_path_route_get_path (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_valum_path_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValumPathRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_PATH_ROUTE, ValumPathRoute);
	switch (property_id) {
		case VALUM_PATH_ROUTE_PATH:
		valum_path_route_set_path (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



