/* valum-regex-route.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-regex-route.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include <stdlib.h>
#include <string.h>
#include "vsgi.h"
#include <libsoup/soup.h>

#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ValumRegexRoutePrivate {
	GRegex* _regex;
	GSList* _captures;
	ValumHandlerCallback _fire;
	gpointer _fire_target;
	GDestroyNotify _fire_target_destroy_notify;
};


static gpointer valum_regex_route_parent_class = NULL;

#define VALUM_REGEX_ROUTE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALUM_TYPE_REGEX_ROUTE, ValumRegexRoutePrivate))
enum  {
	VALUM_REGEX_ROUTE_DUMMY_PROPERTY,
	VALUM_REGEX_ROUTE_REGEX,
	VALUM_REGEX_ROUTE_CAPTURES
};
static void _g_free0_ (gpointer var);
static void _g_slist_free__g_free0_ (GSList* self);
static gboolean valum_regex_route_real_match (ValumRoute* base, VSGIRequest* req, ValumContext* context);
static gboolean valum_regex_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static gchar* valum_regex_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params);
static GObject * valum_regex_route_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valum_regex_route_finalize (GObject* obj);
static void _vala_valum_regex_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_valum_regex_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);

static GRegex* _tmp_regex_0 = NULL;

static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_slist_free__g_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
	g_slist_free (self);
}


ValumRegexRoute* valum_regex_route_construct (GType object_type, ValumMethod method, GRegex* regex, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	ValumRegexRoute * self = NULL;
	ValumMethod _tmp0_ = 0;
	GRegex* _tmp1_ = NULL;
	ValumHandlerCallback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	GDestroyNotify _tmp2__target_destroy_notify = NULL;
	g_return_val_if_fail (regex != NULL, NULL);
	_tmp0_ = method;
	_tmp1_ = regex;
	self = (ValumRegexRoute*) g_object_new (object_type, "method", _tmp0_, "regex", _tmp1_, NULL);
	_tmp2_ = handler;
	_tmp2__target = handler_target;
	_tmp2__target_destroy_notify = handler_target_destroy_notify;
	handler_target_destroy_notify = NULL;
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	self->priv->_fire = _tmp2_;
	self->priv->_fire_target = _tmp2__target;
	self->priv->_fire_target_destroy_notify = _tmp2__target_destroy_notify;
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
	return self;
}


ValumRegexRoute* valum_regex_route_new (ValumMethod method, GRegex* regex, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	return valum_regex_route_construct (VALUM_TYPE_REGEX_ROUTE, method, regex, handler, handler_target, handler_target_destroy_notify);
}


static gboolean valum_regex_route_real_match (ValumRoute* base, VSGIRequest* req, ValumContext* context) {
	ValumRegexRoute * self;
	gboolean result = FALSE;
	GMatchInfo* match_info = NULL;
	GRegex* _tmp0_ = NULL;
	VSGIRequest* _tmp1_ = NULL;
	SoupURI* _tmp2_ = NULL;
	SoupURI* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GMatchInfo* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	self = (ValumRegexRoute*) base;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = self->priv->_regex;
	_tmp1_ = req;
	_tmp2_ = vsgi_request_get_uri (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = soup_uri_get_path (_tmp3_);
	_tmp6_ = g_regex_match (_tmp0_, _tmp4_, 0, &_tmp5_);
	_g_match_info_unref0 (match_info);
	match_info = _tmp5_;
	if (_tmp6_) {
		GSList* _tmp7_ = NULL;
		guint _tmp8_ = 0U;
		_tmp7_ = self->priv->_captures;
		_tmp8_ = g_slist_length (_tmp7_);
		if (_tmp8_ > ((guint) 0)) {
			GSList* _tmp9_ = NULL;
			_tmp9_ = self->priv->_captures;
			{
				GSList* capture_collection = NULL;
				GSList* capture_it = NULL;
				capture_collection = _tmp9_;
				for (capture_it = capture_collection; capture_it != NULL; capture_it = capture_it->next) {
					gchar* _tmp10_ = NULL;
					gchar* capture = NULL;
					_tmp10_ = g_strdup ((const gchar*) capture_it->data);
					capture = _tmp10_;
					{
						gchar* value = NULL;
						GMatchInfo* _tmp11_ = NULL;
						const gchar* _tmp12_ = NULL;
						gchar* _tmp13_ = NULL;
						const gchar* _tmp14_ = NULL;
						_tmp11_ = match_info;
						_tmp12_ = capture;
						_tmp13_ = g_match_info_fetch_named (_tmp11_, _tmp12_);
						value = _tmp13_;
						_tmp14_ = value;
						if (_tmp14_ != NULL) {
							ValumContext* _tmp15_ = NULL;
							const gchar* _tmp16_ = NULL;
							const gchar* _tmp17_ = NULL;
							GValue _tmp18_ = {0};
							_tmp15_ = context;
							_tmp16_ = capture;
							_tmp17_ = value;
							g_value_init (&_tmp18_, G_TYPE_STRING);
							g_value_set_string (&_tmp18_, _tmp17_);
							valum_context_set (_tmp15_, _tmp16_, &_tmp18_);
						}
						_g_free0 (value);
						_g_free0 (capture);
					}
				}
			}
		}
		result = TRUE;
		_g_match_info_unref0 (match_info);
		return result;
	}
	result = FALSE;
	_g_match_info_unref0 (match_info);
	return result;
}


static gboolean valum_regex_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	ValumRegexRoute * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	ValumNextCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	ValumContext* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (ValumRegexRoute*) base;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp1_ = self->priv->_fire;
	_tmp1__target = self->priv->_fire_target;
	_tmp2_ = req;
	_tmp3_ = res;
	_tmp4_ = next;
	_tmp4__target = next_target;
	_tmp5_ = ctx;
	_tmp6_ = _tmp1_ (_tmp2_, _tmp3_, _tmp4_, _tmp4__target, _tmp5_, _tmp1__target, &_inner_error_);
	_tmp0_ = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp0_;
	return result;
}


static gchar* valum_regex_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params) {
	ValumRegexRoute * self;
	gchar* result = NULL;
	self = (ValumRegexRoute*) base;
	g_error ("valum-regex-route.vala:88: 'RegexRoute' does not support reversing URL" \
"s.");
	return result;
}


GRegex* valum_regex_route_get_regex (ValumRegexRoute* self) {
	GRegex* result;
	GRegex* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_regex;
	result = _tmp0_;
	return result;
}


static gpointer _g_regex_ref0 (gpointer self) {
	return self ? g_regex_ref (self) : NULL;
}


static void valum_regex_route_set_regex (ValumRegexRoute* self, GRegex* value) {
	GRegex* _tmp0_ = NULL;
	GRegex* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_regex_ref0 (_tmp0_);
	_g_regex_unref0 (self->priv->_regex);
	self->priv->_regex = _tmp1_;
	g_object_notify ((GObject *) self, "regex");
}


GSList* valum_regex_route_get_captures (ValumRegexRoute* self) {
	GSList* result;
	GSList* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_captures;
	result = _tmp0_;
	return result;
}


static void valum_regex_route_set_captures (ValumRegexRoute* self, GSList* value) {
	GSList* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	value = NULL;
	__g_slist_free__g_free0_0 (self->priv->_captures);
	self->priv->_captures = _tmp0_;
	__g_slist_free__g_free0_0 (value);
	g_object_notify ((GObject *) self, "captures");
}


static inline GRegex* _thread_safe_regex_init (GRegex** re, const gchar * pattern, GRegexMatchFlags match_options) {
	if (g_once_init_enter ((volatile gsize*) re)) {
		GRegex* val = g_regex_new (pattern, match_options, 0, NULL);
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
	}
	return *re;
}


static GObject * valum_regex_route_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ValumRegexRoute * self;
	GSList* _captures = NULL;
	GMatchInfo* capture_match_info = NULL;
	GRegex* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GSList* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (valum_regex_route_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALUM_TYPE_REGEX_ROUTE, ValumRegexRoute);
	_captures = NULL;
	_tmp0_ = self->priv->_regex;
	_tmp1_ = g_regex_get_pattern (_tmp0_);
	_tmp3_ = g_regex_match (_thread_safe_regex_init (&_tmp_regex_0, "\\(\\?<(\\w+)>.+?\\)", 0), _tmp1_, 0, &_tmp2_);
	_g_match_info_unref0 (capture_match_info);
	capture_match_info = _tmp2_;
	if (_tmp3_) {
		{
			{
				gboolean _tmp4_ = FALSE;
				_tmp4_ = TRUE;
				while (TRUE) {
					GMatchInfo* _tmp8_ = NULL;
					gchar* _tmp9_ = NULL;
					if (!_tmp4_) {
						gboolean _tmp5_ = FALSE;
						GMatchInfo* _tmp6_ = NULL;
						gboolean _tmp7_ = FALSE;
						_tmp6_ = capture_match_info;
						_tmp7_ = g_match_info_next (_tmp6_, &_inner_error_);
						_tmp5_ = _tmp7_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == G_REGEX_ERROR) {
								goto __catch6_g_regex_error;
							}
							_g_match_info_unref0 (capture_match_info);
							__g_slist_free__g_free0_0 (_captures);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
						}
						if (!_tmp5_) {
							break;
						}
					}
					_tmp4_ = FALSE;
					_tmp8_ = capture_match_info;
					_tmp9_ = g_match_info_fetch (_tmp8_, 1);
					_captures = g_slist_append (_captures, _tmp9_);
				}
			}
		}
		goto __finally6;
		__catch6_g_regex_error:
		{
			GError* err = NULL;
			err = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (err);
		}
		__finally6:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_match_info_unref0 (capture_match_info);
			__g_slist_free__g_free0_0 (_captures);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
	}
	_tmp10_ = _captures;
	_captures = NULL;
	valum_regex_route_set_captures (self, _tmp10_);
	_g_match_info_unref0 (capture_match_info);
	__g_slist_free__g_free0_0 (_captures);
	return obj;
}


static void valum_regex_route_class_init (ValumRegexRouteClass * klass) {
	valum_regex_route_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValumRegexRoutePrivate));
	((ValumRouteClass *) klass)->match = valum_regex_route_real_match;
	((ValumRouteClass *) klass)->fire = valum_regex_route_real_fire;
	((ValumRouteClass *) klass)->to_url_from_hash = valum_regex_route_real_to_url_from_hash;
	G_OBJECT_CLASS (klass)->get_property = _vala_valum_regex_route_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valum_regex_route_set_property;
	G_OBJECT_CLASS (klass)->constructor = valum_regex_route_constructor;
	G_OBJECT_CLASS (klass)->finalize = valum_regex_route_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALUM_REGEX_ROUTE_REGEX, g_param_spec_boxed ("regex", "regex", "regex", G_TYPE_REGEX, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALUM_REGEX_ROUTE_CAPTURES, g_param_spec_pointer ("captures", "captures", "captures", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valum_regex_route_instance_init (ValumRegexRoute * self) {
	self->priv = VALUM_REGEX_ROUTE_GET_PRIVATE (self);
}


static void valum_regex_route_finalize (GObject* obj) {
	ValumRegexRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALUM_TYPE_REGEX_ROUTE, ValumRegexRoute);
	_g_regex_unref0 (self->priv->_regex);
	__g_slist_free__g_free0_0 (self->priv->_captures);
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	G_OBJECT_CLASS (valum_regex_route_parent_class)->finalize (obj);
}


/**
 * Route based on {@link GLib.Regex}.
 *
 * The providen regular expression pattern will be extracted, scoped,
 * anchored and optimized. This means you must not anchor the regex yourself
 * with '^' and '$' characters and providing a pre-optimized {@link  GLib.Regex}
 * is useless.
 *
 * Like for the rules, the regular expression starts matching after the
 * scopes and the leading '/' character.
 */
GType valum_regex_route_get_type (void) {
	static volatile gsize valum_regex_route_type_id__volatile = 0;
	if (g_once_init_enter (&valum_regex_route_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValumRegexRouteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valum_regex_route_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValumRegexRoute), 0, (GInstanceInitFunc) valum_regex_route_instance_init, NULL };
		GType valum_regex_route_type_id;
		valum_regex_route_type_id = g_type_register_static (VALUM_TYPE_ROUTE, "ValumRegexRoute", &g_define_type_info, 0);
		g_once_init_leave (&valum_regex_route_type_id__volatile, valum_regex_route_type_id);
	}
	return valum_regex_route_type_id__volatile;
}


static void _vala_valum_regex_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValumRegexRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_REGEX_ROUTE, ValumRegexRoute);
	switch (property_id) {
		case VALUM_REGEX_ROUTE_REGEX:
		g_value_set_boxed (value, valum_regex_route_get_regex (self));
		break;
		case VALUM_REGEX_ROUTE_CAPTURES:
		g_value_set_pointer (value, valum_regex_route_get_captures (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_valum_regex_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValumRegexRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_REGEX_ROUTE, ValumRegexRoute);
	switch (property_id) {
		case VALUM_REGEX_ROUTE_REGEX:
		valum_regex_route_set_regex (self, g_value_get_boxed (value));
		break;
		case VALUM_REGEX_ROUTE_CAPTURES:
		valum_regex_route_set_captures (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



