/* valum-route.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-route.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _ValumRoutePrivate {
	ValumMethod _method;
};


static gpointer valum_route_parent_class = NULL;

#define VALUM_ROUTE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALUM_TYPE_ROUTE, ValumRoutePrivate))
enum  {
	VALUM_ROUTE_DUMMY_PROPERTY,
	VALUM_ROUTE_METHOD
};
static gboolean valum_route_real_match (ValumRoute* self, VSGIRequest* req, ValumContext* ctx);
static gboolean valum_route_real_fire (ValumRoute* self, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static gchar* valum_route_real_to_url_from_hash (ValumRoute* self, GHashTable* params);
static void _g_free0_ (gpointer var);
static void valum_route_finalize (GObject* obj);
static void _vala_valum_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_valum_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Matches the given request and populate its parameters on success.
 */
static gboolean valum_route_real_match (ValumRoute* self, VSGIRequest* req, ValumContext* ctx) {
	g_critical ("Type `%s' does not implement abstract method `valum_route_match'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean valum_route_match (ValumRoute* self, VSGIRequest* req, ValumContext* ctx) {
	g_return_val_if_fail (self != NULL, FALSE);
	return VALUM_ROUTE_GET_CLASS (self)->match (self, req, ctx);
}


/**
 * Apply the handler on the request and response.
 *
 * @return the return value of the callback if set, otherwise 'false'
 */
static gboolean valum_route_real_fire (ValumRoute* self, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	g_critical ("Type `%s' does not implement abstract method `valum_route_fire'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean valum_route_fire (ValumRoute* self, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return VALUM_ROUTE_GET_CLASS (self)->fire (self, req, res, next, next_target, ctx, error);
}


/**
 * Reverse the route into an URL.
 *
 * @param params parameters which are typically extract from the
 *               {@link VSGI.Request.uri} property
 *
 * @return the corresponding URL if supported, otherwise 'null'
 */
static gchar* valum_route_real_to_url_from_hash (ValumRoute* self, GHashTable* params) {
	g_critical ("Type `%s' does not implement abstract method `valum_route_to_url_from_hash'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* valum_route_to_url_from_hash (ValumRoute* self, GHashTable* params) {
	g_return_val_if_fail (self != NULL, NULL);
	return VALUM_ROUTE_GET_CLASS (self)->to_url_from_hash (self, params);
}


/**
 * Reverse the route into an URL by building from a varidic arguments
 * list.
 */
static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch7_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch7_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* valum_route_to_url_from_valist (ValumRoute* self, va_list list) {
	gchar* result = NULL;
	GHashTable* hash = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	GHashTable* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
	hash = _tmp2_;
	{
		const gchar* key = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* val = NULL;
		const gchar* _tmp4_ = NULL;
		_tmp3_ = va_arg (list, gchar*);
		key = _tmp3_;
		_tmp4_ = va_arg (list, gchar*);
		val = _tmp4_;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp8_ = FALSE;
				const gchar* _tmp9_ = NULL;
				GHashTable* _tmp11_ = NULL;
				const gchar* _tmp12_ = NULL;
				gchar* _tmp13_ = NULL;
				const gchar* _tmp14_ = NULL;
				gchar* _tmp15_ = NULL;
				if (!_tmp5_) {
					const gchar* _tmp6_ = NULL;
					const gchar* _tmp7_ = NULL;
					_tmp6_ = va_arg (list, gchar*);
					key = _tmp6_;
					_tmp7_ = va_arg (list, gchar*);
					val = _tmp7_;
				}
				_tmp5_ = FALSE;
				_tmp9_ = key;
				if (_tmp9_ != NULL) {
					const gchar* _tmp10_ = NULL;
					_tmp10_ = val;
					_tmp8_ = _tmp10_ != NULL;
				} else {
					_tmp8_ = FALSE;
				}
				if (!_tmp8_) {
					break;
				}
				_tmp11_ = hash;
				_tmp12_ = key;
				_tmp13_ = string_replace (_tmp12_, "-", "_");
				_tmp14_ = val;
				_tmp15_ = g_strdup (_tmp14_);
				g_hash_table_insert (_tmp11_, _tmp13_, _tmp15_);
			}
		}
	}
	_tmp16_ = hash;
	_tmp17_ = valum_route_to_url_from_hash (self, _tmp16_);
	result = _tmp17_;
	_g_hash_table_unref0 (hash);
	return result;
}


/**
 * Reverse the route into an URL using varidic arguments.
 *
 * Arguments alternate between keys and values, all assumed to be
 * {@link string}.
 */
gchar* valum_route_to_url (ValumRoute* self, ...) {
	gchar* result = NULL;
	va_list _tmp0_ = {0};
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	va_start (_tmp0_, self);
	_tmp1_ = valum_route_to_url_from_valist (self, _tmp0_);
	_tmp2_ = _tmp1_;
	va_end (_tmp0_);
	result = _tmp2_;
	return result;
}


ValumRoute* valum_route_construct (GType object_type) {
	ValumRoute * self = NULL;
	self = (ValumRoute*) g_object_new (object_type, NULL);
	return self;
}


ValumMethod valum_route_get_method (ValumRoute* self) {
	ValumMethod result;
	ValumMethod _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_method;
	result = _tmp0_;
	return result;
}


static void valum_route_set_method (ValumRoute* self, ValumMethod value) {
	ValumMethod _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_method = _tmp0_;
	g_object_notify ((GObject *) self, "method");
}


static void valum_route_class_init (ValumRouteClass * klass) {
	valum_route_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValumRoutePrivate));
	((ValumRouteClass *) klass)->match = valum_route_real_match;
	((ValumRouteClass *) klass)->fire = valum_route_real_fire;
	((ValumRouteClass *) klass)->to_url_from_hash = valum_route_real_to_url_from_hash;
	G_OBJECT_CLASS (klass)->get_property = _vala_valum_route_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valum_route_set_property;
	G_OBJECT_CLASS (klass)->finalize = valum_route_finalize;
	/**
	 * Flag describing allowed HTTP methods.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALUM_ROUTE_METHOD, g_param_spec_flags ("method", "method", "method", VALUM_TYPE_METHOD, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valum_route_instance_init (ValumRoute * self) {
	self->priv = VALUM_ROUTE_GET_PRIVATE (self);
}


static void valum_route_finalize (GObject* obj) {
	ValumRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALUM_TYPE_ROUTE, ValumRoute);
	G_OBJECT_CLASS (valum_route_parent_class)->finalize (obj);
}


/**
 * Describe a matching and handling process for a pair of {@link VSGI.Request}
 * and {@link VSGI.Response} objects.
 *
 * It holds metadata as well to optimize the routing process.
 */
GType valum_route_get_type (void) {
	static volatile gsize valum_route_type_id__volatile = 0;
	if (g_once_init_enter (&valum_route_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValumRouteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valum_route_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValumRoute), 0, (GInstanceInitFunc) valum_route_instance_init, NULL };
		GType valum_route_type_id;
		valum_route_type_id = g_type_register_static (G_TYPE_OBJECT, "ValumRoute", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&valum_route_type_id__volatile, valum_route_type_id);
	}
	return valum_route_type_id__volatile;
}


static void _vala_valum_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValumRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_ROUTE, ValumRoute);
	switch (property_id) {
		case VALUM_ROUTE_METHOD:
		g_value_set_flags (value, valum_route_get_method (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_valum_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValumRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_ROUTE, ValumRoute);
	switch (property_id) {
		case VALUM_ROUTE_METHOD:
		valum_route_set_method (self, g_value_get_flags (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



