/* valum-rule-route.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-rule-route.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include <stdlib.h>
#include <string.h>
#include "vsgi.h"

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ValumRuleRoutePrivate {
	gchar* _rule;
	GHashTable* _types;
	ValumHandlerCallback _fire;
	gpointer _fire_target;
	GDestroyNotify _fire_target_destroy_notify;
};


static gpointer valum_rule_route_parent_class = NULL;

#define VALUM_RULE_ROUTE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALUM_TYPE_RULE_ROUTE, ValumRuleRoutePrivate))
enum  {
	VALUM_RULE_ROUTE_DUMMY_PROPERTY,
	VALUM_RULE_ROUTE_RULE,
	VALUM_RULE_ROUTE_TYPES
};
static gboolean valum_rule_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static gchar* valum_rule_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params);
static void valum_rule_route_finalize (GObject* obj);
static void _vala_valum_rule_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_valum_rule_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static GRegex* _tmp_regex_0 = NULL;
static GRegex* _tmp_regex_1 = NULL;

/**
 * Create a Route for a given callback from a rule.
 *
 * @param rule  compiled down ot a regular expression and captures all
 *              paths if set to 'null'
 * @param types type mapping to figure out types in rule or 'null' to
 *              prevent any form of typing
 */
static inline GRegex* _thread_safe_regex_init (GRegex** re, const gchar * pattern, GRegexMatchFlags match_options) {
	if (g_once_init_enter ((volatile gsize*) re)) {
		GRegex* val = g_regex_new (pattern, match_options, 0, NULL);
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
	}
	return *re;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


ValumRuleRoute* valum_rule_route_construct (GType object_type, ValumMethod method, const gchar* rule, GHashTable* types, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, GError** error) {
	ValumRuleRoute * self = NULL;
	GString* pattern = NULL;
	GString* _tmp0_ = NULL;
	gchar** params = NULL;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint params_length1 = 0;
	gint _params_size_ = 0;
	GString* _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	GString* _tmp58_ = NULL;
	GRegex* _tmp59_ = NULL;
	GString* _tmp60_ = NULL;
	const gchar* _tmp61_ = NULL;
	GRegex* _tmp62_ = NULL;
	ValumMethod _tmp63_ = 0;
	const gchar* _tmp64_ = NULL;
	GHashTable* _tmp65_ = NULL;
	GRegex* _tmp66_ = NULL;
	GRegex* _tmp67_ = NULL;
	ValumHandlerCallback _tmp68_ = NULL;
	void* _tmp68__target = NULL;
	GDestroyNotify _tmp68__target_destroy_notify = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (rule != NULL, NULL);
	g_return_val_if_fail (types != NULL, NULL);
	_tmp0_ = g_string_new ("");
	pattern = _tmp0_;
	_tmp1_ = rule;
	_tmp3_ = _tmp2_ = g_regex_split_full (_thread_safe_regex_init (&_tmp_regex_0, "([\\*\\?\\(\\)]|<(?:\\w+:)?\\w+>)", 0), _tmp1_, (gssize) (-1), 0, 0, 0, &_inner_error_);
	params = _tmp3_;
	params_length1 = _vala_array_length (_tmp2_);
	_params_size_ = params_length1;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_string_free0 (pattern);
			(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
			handler = NULL;
			handler_target = NULL;
			handler_target_destroy_notify = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			_g_string_free0 (pattern);
			(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
			handler = NULL;
			handler_target = NULL;
			handler_target_destroy_notify = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = pattern;
	g_string_append_c (_tmp4_, '^');
	_tmp5_ = params;
	_tmp5__length1 = params_length1;
	{
		gchar** p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
		p_collection = _tmp5_;
		p_collection_length1 = _tmp5__length1;
		for (p_it = 0; p_it < _tmp5__length1; p_it = p_it + 1) {
			gchar* _tmp6_ = NULL;
			gchar* p = NULL;
			_tmp6_ = g_strdup (p_collection[p_it]);
			p = _tmp6_;
			{
				const gchar* _tmp7_ = NULL;
				_tmp7_ = p;
				if (g_strcmp0 (_tmp7_, "*") == 0) {
					GString* _tmp8_ = NULL;
					_tmp8_ = pattern;
					g_string_append (_tmp8_, ".*");
				} else {
					gboolean _tmp9_ = FALSE;
					const gchar* _tmp10_ = NULL;
					_tmp10_ = p;
					if (g_strcmp0 (_tmp10_, "?") == 0) {
						_tmp9_ = TRUE;
					} else {
						const gchar* _tmp11_ = NULL;
						_tmp11_ = p;
						_tmp9_ = g_strcmp0 (_tmp11_, ")") == 0;
					}
					if (_tmp9_) {
						GString* _tmp12_ = NULL;
						const gchar* _tmp13_ = NULL;
						_tmp12_ = pattern;
						_tmp13_ = p;
						g_string_append (_tmp12_, _tmp13_);
					} else {
						const gchar* _tmp14_ = NULL;
						_tmp14_ = p;
						if (g_strcmp0 (_tmp14_, "(") == 0) {
							GString* _tmp15_ = NULL;
							_tmp15_ = pattern;
							g_string_append (_tmp15_, "(?:");
						} else {
							const gchar* _tmp16_ = NULL;
							gchar _tmp17_ = '\0';
							_tmp16_ = p;
							_tmp17_ = string_get (_tmp16_, (glong) 0);
							if (_tmp17_ != '<') {
								GString* _tmp18_ = NULL;
								const gchar* _tmp19_ = NULL;
								gchar* _tmp20_ = NULL;
								gchar* _tmp21_ = NULL;
								_tmp18_ = pattern;
								_tmp19_ = p;
								_tmp20_ = g_regex_escape_string (_tmp19_, -1);
								_tmp21_ = _tmp20_;
								g_string_append (_tmp18_, _tmp21_);
								_g_free0 (_tmp21_);
							} else {
								gchar** cap = NULL;
								const gchar* _tmp22_ = NULL;
								const gchar* _tmp23_ = NULL;
								gint _tmp24_ = 0;
								gint _tmp25_ = 0;
								gchar* _tmp26_ = NULL;
								gchar* _tmp27_ = NULL;
								gchar** _tmp28_ = NULL;
								gchar** _tmp29_ = NULL;
								gchar** _tmp30_ = NULL;
								gint _tmp30__length1 = 0;
								gint cap_length1 = 0;
								gint _cap_size_ = 0;
								const gchar* _tmp31_ = NULL;
								gchar** _tmp32_ = NULL;
								gint _tmp32__length1 = 0;
								gchar* type = NULL;
								gchar* _tmp35_ = NULL;
								const gchar* _tmp36_ = NULL;
								gchar** _tmp37_ = NULL;
								gint _tmp37__length1 = 0;
								gchar* key = NULL;
								gchar* _tmp42_ = NULL;
								GHashTable* _tmp43_ = NULL;
								const gchar* _tmp44_ = NULL;
								gboolean _tmp45_ = FALSE;
								_tmp22_ = p;
								_tmp23_ = p;
								_tmp24_ = strlen (_tmp23_);
								_tmp25_ = _tmp24_;
								_tmp26_ = string_slice (_tmp22_, (glong) 1, (glong) (_tmp25_ - 1));
								_tmp27_ = _tmp26_;
								_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, ":", 2);
								_tmp30_ = _tmp29_;
								_tmp30__length1 = _vala_array_length (_tmp28_);
								_g_free0 (_tmp27_);
								cap = _tmp30_;
								cap_length1 = _tmp30__length1;
								_cap_size_ = cap_length1;
								_tmp32_ = cap;
								_tmp32__length1 = cap_length1;
								if (_tmp32__length1 == 1) {
									_tmp31_ = "string";
								} else {
									gchar** _tmp33_ = NULL;
									gint _tmp33__length1 = 0;
									const gchar* _tmp34_ = NULL;
									_tmp33_ = cap;
									_tmp33__length1 = cap_length1;
									_tmp34_ = _tmp33_[0];
									_tmp31_ = _tmp34_;
								}
								_tmp35_ = g_strdup (_tmp31_);
								type = _tmp35_;
								_tmp37_ = cap;
								_tmp37__length1 = cap_length1;
								if (_tmp37__length1 == 1) {
									gchar** _tmp38_ = NULL;
									gint _tmp38__length1 = 0;
									const gchar* _tmp39_ = NULL;
									_tmp38_ = cap;
									_tmp38__length1 = cap_length1;
									_tmp39_ = _tmp38_[0];
									_tmp36_ = _tmp39_;
								} else {
									gchar** _tmp40_ = NULL;
									gint _tmp40__length1 = 0;
									const gchar* _tmp41_ = NULL;
									_tmp40_ = cap;
									_tmp40__length1 = cap_length1;
									_tmp41_ = _tmp40_[1];
									_tmp36_ = _tmp41_;
								}
								_tmp42_ = g_strdup (_tmp36_);
								key = _tmp42_;
								_tmp43_ = types;
								_tmp44_ = type;
								_tmp45_ = g_hash_table_contains (_tmp43_, _tmp44_);
								if (_tmp45_) {
									GString* _tmp46_ = NULL;
									const gchar* _tmp47_ = NULL;
									GHashTable* _tmp48_ = NULL;
									const gchar* _tmp49_ = NULL;
									gconstpointer _tmp50_ = NULL;
									const gchar* _tmp51_ = NULL;
									_tmp46_ = pattern;
									_tmp47_ = key;
									_tmp48_ = types;
									_tmp49_ = type;
									_tmp50_ = g_hash_table_lookup (_tmp48_, _tmp49_);
									_tmp51_ = g_regex_get_pattern ((GRegex*) _tmp50_);
									g_string_append_printf (_tmp46_, "(?<%s>%s)", _tmp47_, _tmp51_);
								} else {
									const gchar* _tmp52_ = NULL;
									_tmp52_ = type;
									if (g_strcmp0 (_tmp52_, "string") == 0) {
										GString* _tmp53_ = NULL;
										const gchar* _tmp54_ = NULL;
										_tmp53_ = pattern;
										_tmp54_ = key;
										g_string_append_printf (_tmp53_, "(?<%s>\\w+)", _tmp54_);
									} else {
										const gchar* _tmp55_ = NULL;
										const gchar* _tmp56_ = NULL;
										GError* _tmp57_ = NULL;
										_tmp55_ = type;
										_tmp56_ = key;
										_tmp57_ = g_error_new (G_REGEX_ERROR, G_REGEX_ERROR_COMPILE, "Using an undefined type '%s' for capture '%s'.", _tmp55_, _tmp56_);
										_inner_error_ = _tmp57_;
										if (_inner_error_->domain == G_REGEX_ERROR) {
											g_propagate_error (error, _inner_error_);
											_g_free0 (key);
											_g_free0 (type);
											cap = (_vala_array_free (cap, cap_length1, (GDestroyNotify) g_free), NULL);
											_g_free0 (p);
											params = (_vala_array_free (params, params_length1, (GDestroyNotify) g_free), NULL);
											_g_string_free0 (pattern);
											(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
											handler = NULL;
											handler_target = NULL;
											handler_target_destroy_notify = NULL;
											_g_object_unref0 (self);
											return NULL;
										} else {
											_g_free0 (key);
											_g_free0 (type);
											cap = (_vala_array_free (cap, cap_length1, (GDestroyNotify) g_free), NULL);
											_g_free0 (p);
											params = (_vala_array_free (params, params_length1, (GDestroyNotify) g_free), NULL);
											_g_string_free0 (pattern);
											(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
											handler = NULL;
											handler_target = NULL;
											handler_target_destroy_notify = NULL;
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
											g_clear_error (&_inner_error_);
											return NULL;
										}
									}
								}
								_g_free0 (key);
								_g_free0 (type);
								cap = (_vala_array_free (cap, cap_length1, (GDestroyNotify) g_free), NULL);
							}
						}
					}
				}
				_g_free0 (p);
			}
		}
	}
	_tmp58_ = pattern;
	g_string_append_c (_tmp58_, '$');
	_tmp60_ = pattern;
	_tmp61_ = _tmp60_->str;
	_tmp62_ = g_regex_new (_tmp61_, G_REGEX_OPTIMIZE, 0, &_inner_error_);
	_tmp59_ = _tmp62_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			g_propagate_error (error, _inner_error_);
			params = (_vala_array_free (params, params_length1, (GDestroyNotify) g_free), NULL);
			_g_string_free0 (pattern);
			(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
			handler = NULL;
			handler_target = NULL;
			handler_target_destroy_notify = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			params = (_vala_array_free (params, params_length1, (GDestroyNotify) g_free), NULL);
			_g_string_free0 (pattern);
			(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
			handler = NULL;
			handler_target = NULL;
			handler_target_destroy_notify = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp63_ = method;
	_tmp64_ = rule;
	_tmp65_ = types;
	_tmp66_ = _tmp59_;
	_tmp59_ = NULL;
	_tmp67_ = _tmp66_;
	self = (ValumRuleRoute*) g_object_new (object_type, "method", _tmp63_, "rule", _tmp64_, "types", _tmp65_, "regex", _tmp67_, NULL);
	_g_regex_unref0 (_tmp67_);
	_tmp68_ = handler;
	_tmp68__target = handler_target;
	_tmp68__target_destroy_notify = handler_target_destroy_notify;
	handler_target_destroy_notify = NULL;
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	self->priv->_fire = _tmp68_;
	self->priv->_fire_target = _tmp68__target;
	self->priv->_fire_target_destroy_notify = _tmp68__target_destroy_notify;
	_g_regex_unref0 (_tmp59_);
	params = (_vala_array_free (params, params_length1, (GDestroyNotify) g_free), NULL);
	_g_string_free0 (pattern);
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
	return self;
}


ValumRuleRoute* valum_rule_route_new (ValumMethod method, const gchar* rule, GHashTable* types, ValumHandlerCallback handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, GError** error) {
	return valum_rule_route_construct (VALUM_TYPE_RULE_ROUTE, method, rule, types, handler, handler_target, handler_target_destroy_notify, error);
}


static gboolean valum_rule_route_real_fire (ValumRoute* base, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	ValumRuleRoute * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	ValumNextCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	ValumContext* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (ValumRuleRoute*) base;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp1_ = self->priv->_fire;
	_tmp1__target = self->priv->_fire_target;
	_tmp2_ = req;
	_tmp3_ = res;
	_tmp4_ = next;
	_tmp4__target = next_target;
	_tmp5_ = ctx;
	_tmp6_ = _tmp1_ (_tmp2_, _tmp3_, _tmp4_, _tmp4__target, _tmp5_, _tmp1__target, &_inner_error_);
	_tmp0_ = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp0_;
	return result;
}


static gchar* valum_rule_route_real_to_url_from_hash (ValumRoute* base, GHashTable* params) {
	ValumRuleRoute * self;
	gchar* result = NULL;
	GString* url = NULL;
	GString* _tmp0_ = NULL;
	gchar** pieces = NULL;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint pieces_length1 = 0;
	gint _pieces_size_ = 0;
	gboolean missing = FALSE;
	gchar* missing_key = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gboolean _tmp43_ = FALSE;
	GString* _tmp45_ = NULL;
	const gchar* _tmp46_ = NULL;
	gchar* _tmp47_ = NULL;
	self = (ValumRuleRoute*) base;
	_tmp0_ = g_string_new ("");
	url = _tmp0_;
	_tmp1_ = self->priv->_rule;
	_tmp3_ = _tmp2_ = g_regex_split (_thread_safe_regex_init (&_tmp_regex_1, "([\\*\\?\\(\\)]|<(?:\\w+:)?\\w+>)", 0), _tmp1_, 0);
	pieces = _tmp3_;
	pieces_length1 = _vala_array_length (_tmp2_);
	_pieces_size_ = pieces_length1;
	missing = FALSE;
	missing_key = NULL;
	_tmp4_ = pieces;
	_tmp4__length1 = pieces_length1;
	{
		gchar** piece_collection = NULL;
		gint piece_collection_length1 = 0;
		gint _piece_collection_size_ = 0;
		gint piece_it = 0;
		piece_collection = _tmp4_;
		piece_collection_length1 = _tmp4__length1;
		for (piece_it = 0; piece_it < _tmp4__length1; piece_it = piece_it + 1) {
			gchar* _tmp5_ = NULL;
			gchar* piece = NULL;
			_tmp5_ = g_strdup (piece_collection[piece_it]);
			piece = _tmp5_;
			{
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				const gchar* _tmp8_ = NULL;
				_tmp8_ = piece;
				if (g_strcmp0 (_tmp8_, "*") == 0) {
					_tmp7_ = TRUE;
				} else {
					const gchar* _tmp9_ = NULL;
					_tmp9_ = piece;
					_tmp7_ = g_strcmp0 (_tmp9_, "(") == 0;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					const gchar* _tmp10_ = NULL;
					_tmp10_ = piece;
					_tmp6_ = g_strcmp0 (_tmp10_, ")") == 0;
				}
				if (_tmp6_) {
					_g_free0 (piece);
					continue;
				} else {
					const gchar* _tmp11_ = NULL;
					_tmp11_ = piece;
					if (g_strcmp0 (_tmp11_, "?") == 0) {
						missing = FALSE;
					} else {
						const gchar* _tmp12_ = NULL;
						gchar _tmp13_ = '\0';
						_tmp12_ = piece;
						_tmp13_ = string_get (_tmp12_, (glong) 0);
						if (_tmp13_ != '<') {
							GString* _tmp14_ = NULL;
							const gchar* _tmp15_ = NULL;
							_tmp14_ = url;
							_tmp15_ = piece;
							g_string_append (_tmp14_, _tmp15_);
						} else {
							gchar** cap = NULL;
							const gchar* _tmp16_ = NULL;
							const gchar* _tmp17_ = NULL;
							gint _tmp18_ = 0;
							gint _tmp19_ = 0;
							gchar* _tmp20_ = NULL;
							gchar* _tmp21_ = NULL;
							gchar** _tmp22_ = NULL;
							gchar** _tmp23_ = NULL;
							gchar** _tmp24_ = NULL;
							gint _tmp24__length1 = 0;
							gint cap_length1 = 0;
							gint _cap_size_ = 0;
							const gchar* _tmp25_ = NULL;
							gchar** _tmp26_ = NULL;
							gint _tmp26__length1 = 0;
							gchar* key = NULL;
							gchar* _tmp31_ = NULL;
							gboolean _tmp32_ = FALSE;
							GHashTable* _tmp33_ = NULL;
							_tmp16_ = piece;
							_tmp17_ = piece;
							_tmp18_ = strlen (_tmp17_);
							_tmp19_ = _tmp18_;
							_tmp20_ = string_slice (_tmp16_, (glong) 1, (glong) (_tmp19_ - 1));
							_tmp21_ = _tmp20_;
							_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, ":", 2);
							_tmp24_ = _tmp23_;
							_tmp24__length1 = _vala_array_length (_tmp22_);
							_g_free0 (_tmp21_);
							cap = _tmp24_;
							cap_length1 = _tmp24__length1;
							_cap_size_ = cap_length1;
							_tmp26_ = cap;
							_tmp26__length1 = cap_length1;
							if (_tmp26__length1 == 1) {
								gchar** _tmp27_ = NULL;
								gint _tmp27__length1 = 0;
								const gchar* _tmp28_ = NULL;
								_tmp27_ = cap;
								_tmp27__length1 = cap_length1;
								_tmp28_ = _tmp27_[0];
								_tmp25_ = _tmp28_;
							} else {
								gchar** _tmp29_ = NULL;
								gint _tmp29__length1 = 0;
								const gchar* _tmp30_ = NULL;
								_tmp29_ = cap;
								_tmp29__length1 = cap_length1;
								_tmp30_ = _tmp29_[1];
								_tmp25_ = _tmp30_;
							}
							_tmp31_ = g_strdup (_tmp25_);
							key = _tmp31_;
							_tmp33_ = params;
							if (_tmp33_ != NULL) {
								GHashTable* _tmp34_ = NULL;
								const gchar* _tmp35_ = NULL;
								gboolean _tmp36_ = FALSE;
								_tmp34_ = params;
								_tmp35_ = key;
								_tmp36_ = g_hash_table_contains (_tmp34_, _tmp35_);
								_tmp32_ = _tmp36_;
							} else {
								_tmp32_ = FALSE;
							}
							if (_tmp32_) {
								GString* _tmp37_ = NULL;
								GHashTable* _tmp38_ = NULL;
								const gchar* _tmp39_ = NULL;
								gconstpointer _tmp40_ = NULL;
								_tmp37_ = url;
								_tmp38_ = params;
								_tmp39_ = key;
								_tmp40_ = g_hash_table_lookup (_tmp38_, _tmp39_);
								g_string_append (_tmp37_, (const gchar*) _tmp40_);
							} else {
								const gchar* _tmp41_ = NULL;
								gchar* _tmp42_ = NULL;
								missing = TRUE;
								_tmp41_ = key;
								_tmp42_ = g_strdup (_tmp41_);
								_g_free0 (missing_key);
								missing_key = _tmp42_;
							}
							_g_free0 (key);
							cap = (_vala_array_free (cap, cap_length1, (GDestroyNotify) g_free), NULL);
						}
					}
				}
				_g_free0 (piece);
			}
		}
	}
	_tmp43_ = missing;
	if (_tmp43_) {
		const gchar* _tmp44_ = NULL;
		_tmp44_ = missing_key;
		g_critical ("valum-rule-route.vala:139: The parameter '%s' was not provided.", _tmp44_);
	}
	_tmp45_ = url;
	_tmp46_ = _tmp45_->str;
	_tmp47_ = g_strdup (_tmp46_);
	result = _tmp47_;
	_g_free0 (missing_key);
	pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
	_g_string_free0 (url);
	return result;
}


const gchar* valum_rule_route_get_rule (ValumRuleRoute* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_rule;
	result = _tmp0_;
	return result;
}


static void valum_rule_route_set_rule (ValumRuleRoute* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_rule);
	self->priv->_rule = _tmp1_;
	g_object_notify ((GObject *) self, "rule");
}


GHashTable* valum_rule_route_get_types (ValumRuleRoute* self) {
	GHashTable* result;
	GHashTable* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_types;
	result = _tmp0_;
	return result;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


static void valum_rule_route_set_types (ValumRuleRoute* self, GHashTable* value) {
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	_g_hash_table_unref0 (self->priv->_types);
	self->priv->_types = _tmp1_;
	g_object_notify ((GObject *) self, "types");
}


static void valum_rule_route_class_init (ValumRuleRouteClass * klass) {
	valum_rule_route_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValumRuleRoutePrivate));
	((ValumRouteClass *) klass)->fire = valum_rule_route_real_fire;
	((ValumRouteClass *) klass)->to_url_from_hash = valum_rule_route_real_to_url_from_hash;
	G_OBJECT_CLASS (klass)->get_property = _vala_valum_rule_route_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valum_rule_route_set_property;
	G_OBJECT_CLASS (klass)->finalize = valum_rule_route_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALUM_RULE_ROUTE_RULE, g_param_spec_string ("rule", "rule", "rule", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALUM_RULE_ROUTE_TYPES, g_param_spec_boxed ("types", "types", "types", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valum_rule_route_instance_init (ValumRuleRoute * self) {
	self->priv = VALUM_RULE_ROUTE_GET_PRIVATE (self);
}


static void valum_rule_route_finalize (GObject* obj) {
	ValumRuleRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALUM_TYPE_RULE_ROUTE, ValumRuleRoute);
	_g_free0 (self->priv->_rule);
	_g_hash_table_unref0 (self->priv->_types);
	(self->priv->_fire_target_destroy_notify == NULL) ? NULL : (self->priv->_fire_target_destroy_notify (self->priv->_fire_target), NULL);
	self->priv->_fire = NULL;
	self->priv->_fire_target = NULL;
	self->priv->_fire_target_destroy_notify = NULL;
	G_OBJECT_CLASS (valum_rule_route_parent_class)->finalize (obj);
}


/**
 * Route based on the rule system.
 *
 * The rule pattern is composed of a few elements:
 *
 *  * '<' '>' for parameters
 *  * '(' and ')' for group
 *  * '?' for optional
 *  * '*' for wildcard
 *
 * The content of a parameters is a name with an optional type such as
 * '<type:name>'. Types are resolved in a provided mapping and names are
 * pushed on the routing {@link Valum.Context}.
 *
 * A group allow a more fine-grained application for optional parts.
 *
 * The optional symbol makes the last character or group optional. If it
 * contains parameters, they will not be pushed on the context.
 *
 * The wildcard stands for the '.*' regular expression, which match pretty
 * much anything.
 */
GType valum_rule_route_get_type (void) {
	static volatile gsize valum_rule_route_type_id__volatile = 0;
	if (g_once_init_enter (&valum_rule_route_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValumRuleRouteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valum_rule_route_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValumRuleRoute), 0, (GInstanceInitFunc) valum_rule_route_instance_init, NULL };
		GType valum_rule_route_type_id;
		valum_rule_route_type_id = g_type_register_static (VALUM_TYPE_REGEX_ROUTE, "ValumRuleRoute", &g_define_type_info, 0);
		g_once_init_leave (&valum_rule_route_type_id__volatile, valum_rule_route_type_id);
	}
	return valum_rule_route_type_id__volatile;
}


static void _vala_valum_rule_route_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValumRuleRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_RULE_ROUTE, ValumRuleRoute);
	switch (property_id) {
		case VALUM_RULE_ROUTE_RULE:
		g_value_set_string (value, valum_rule_route_get_rule (self));
		break;
		case VALUM_RULE_ROUTE_TYPES:
		g_value_set_boxed (value, valum_rule_route_get_types (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_valum_rule_route_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValumRuleRoute * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALUM_TYPE_RULE_ROUTE, ValumRuleRoute);
	switch (property_id) {
		case VALUM_RULE_ROUTE_RULE:
		valum_rule_route_set_rule (self, g_value_get_string (value));
		break;
		case VALUM_RULE_ROUTE_TYPES:
		valum_rule_route_set_types (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



