/* valum-safely.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-safely.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"

typedef struct _Block22Data Block22Data;
typedef struct _Block23Data Block23Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Block22Data {
	int _ref_count_;
	ValumSafeHandlerCallback forward;
	gpointer forward_target;
	GDestroyNotify forward_target_destroy_notify;
};

struct _Block23Data {
	int _ref_count_;
	Block22Data * _data22_;
	GError* err;
	ValumNextCallback next;
	gpointer next_target;
};



static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static gboolean __lambda32_ (Block22Data* _data22_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static gboolean __lambda33_ (Block23Data* _data23_, GError** error);
static gboolean ___lambda33__valum_safe_next_callback (gpointer self, GError** error);
static gboolean ___lambda32__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);


/**
 * Perform some operations safely.
 *
 * Typically, errors are thrown out of callbacks and handled altogether.
 * However, some critical sections might not want to have errors leaking, so
 * this middleware ensure that by providing a context where no errors, but
 * status can be raised.
 *
 * The 'next' continuation is wrapped in such way that if any non-status
 * error is raised, it will be thrown upstream but not leaked from invoking
 * it. This is useful because one only want to deal with errors in the direct
 * scope.
 */
static Block22Data* block22_data_ref (Block22Data* _data22_) {
	g_atomic_int_inc (&_data22_->_ref_count_);
	return _data22_;
}


static void block22_data_unref (void * _userdata_) {
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
		(_data22_->forward_target_destroy_notify == NULL) ? NULL : (_data22_->forward_target_destroy_notify (_data22_->forward_target), NULL);
		_data22_->forward = NULL;
		_data22_->forward_target = NULL;
		_data22_->forward_target_destroy_notify = NULL;
		g_slice_free (Block22Data, _data22_);
	}
}


static Block23Data* block23_data_ref (Block23Data* _data23_) {
	g_atomic_int_inc (&_data23_->_ref_count_);
	return _data23_;
}


static void block23_data_unref (void * _userdata_) {
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
		_g_error_free0 (_data23_->err);
		block22_data_unref (_data23_->_data22_);
		_data23_->_data22_ = NULL;
		g_slice_free (Block23Data, _data23_);
	}
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static gboolean __lambda33_ (Block23Data* _data23_, GError** error) {
	Block22Data* _data22_;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	_data22_ = _data23_->_data22_;
	{
		gboolean _tmp0_ = FALSE;
		ValumNextCallback _tmp1_ = NULL;
		void* _tmp1__target = NULL;
		gboolean _tmp2_ = FALSE;
		_tmp1_ = _data23_->next;
		_tmp1__target = _data23_->next_target;
		_tmp2_ = _tmp1_ (_tmp1__target, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == VALUM_INFORMATIONAL) {
				goto __catch11_valum_informational;
			}
			if (_inner_error_->domain == VALUM_SUCCESS) {
				goto __catch11_valum_success;
			}
			if (_inner_error_->domain == VALUM_REDIRECTION) {
				goto __catch11_valum_redirection;
			}
			if (_inner_error_->domain == VALUM_CLIENT_ERROR) {
				goto __catch11_valum_client_error;
			}
			if (_inner_error_->domain == VALUM_SERVER_ERROR) {
				goto __catch11_valum_server_error;
			}
			goto __catch11_g_error;
		}
		result = _tmp0_;
		return result;
	}
	goto __finally11;
	__catch11_valum_informational:
	{
		GError* i = NULL;
		GError* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		i = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = i;
		_tmp4_ = _g_error_copy0 (_tmp3_);
		_inner_error_ = _tmp4_;
		_g_error_free0 (i);
		goto __finally11;
	}
	goto __finally11;
	__catch11_valum_success:
	{
		GError* s = NULL;
		GError* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		s = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = s;
		_tmp6_ = _g_error_copy0 (_tmp5_);
		_inner_error_ = _tmp6_;
		_g_error_free0 (s);
		goto __finally11;
	}
	goto __finally11;
	__catch11_valum_redirection:
	{
		GError* r = NULL;
		GError* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		r = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = r;
		_tmp8_ = _g_error_copy0 (_tmp7_);
		_inner_error_ = _tmp8_;
		_g_error_free0 (r);
		goto __finally11;
	}
	goto __finally11;
	__catch11_valum_client_error:
	{
		GError* c = NULL;
		GError* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		c = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = c;
		_tmp10_ = _g_error_copy0 (_tmp9_);
		_inner_error_ = _tmp10_;
		_g_error_free0 (c);
		goto __finally11;
	}
	goto __finally11;
	__catch11_valum_server_error:
	{
		GError* s = NULL;
		GError* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
		s = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = s;
		_tmp12_ = _g_error_copy0 (_tmp11_);
		_inner_error_ = _tmp12_;
		_g_error_free0 (s);
		goto __finally11;
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* _err = NULL;
		GError* _tmp13_ = NULL;
		_err = _inner_error_;
		_inner_error_ = NULL;
		_tmp13_ = _err;
		_err = NULL;
		_g_error_free0 (_data23_->err);
		_data23_->err = _tmp13_;
		result = FALSE;
		_g_error_free0 (_err);
		return result;
	}
	__finally11:
	if (((((_inner_error_->domain == VALUM_INFORMATIONAL) || (_inner_error_->domain == VALUM_SUCCESS)) || (_inner_error_->domain == VALUM_REDIRECTION)) || (_inner_error_->domain == VALUM_CLIENT_ERROR)) || (_inner_error_->domain == VALUM_SERVER_ERROR)) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


static gboolean ___lambda33__valum_safe_next_callback (gpointer self, GError** error) {
	gboolean result;
	result = __lambda33_ (self, error);
	return result;
}


static gboolean __lambda32_ (Block22Data* _data22_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	gboolean result = FALSE;
	Block23Data* _data23_;
	ValumNextCallback _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	gboolean ret = FALSE;
	ValumSafeHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	ValumContext* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GError* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_data23_ = g_slice_new0 (Block23Data);
	_data23_->_ref_count_ = 1;
	_data23_->_data22_ = block22_data_ref (_data22_);
	_tmp0_ = next;
	_tmp0__target = next_target;
	_data23_->next = _tmp0_;
	_data23_->next_target = _tmp0__target;
	_data23_->err = NULL;
	_tmp1_ = _data22_->forward;
	_tmp1__target = _data22_->forward_target;
	_tmp2_ = req;
	_tmp3_ = res;
	_tmp4_ = ctx;
	_tmp5_ = _tmp1_ (_tmp2_, _tmp3_, ___lambda33__valum_safe_next_callback, _data23_, _tmp4_, _tmp1__target, &_inner_error_);
	ret = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		block23_data_unref (_data23_);
		_data23_ = NULL;
		return FALSE;
	}
	_tmp6_ = _data23_->err;
	if (_tmp6_ != NULL) {
		GError* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		_tmp7_ = _data23_->err;
		_tmp8_ = _g_error_copy0 (_tmp7_);
		_inner_error_ = _tmp8_;
		g_propagate_error (error, _inner_error_);
		block23_data_unref (_data23_);
		_data23_ = NULL;
		return FALSE;
	}
	result = ret;
	block23_data_unref (_data23_);
	_data23_ = NULL;
	return result;
}


static gboolean ___lambda32__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda32_ (self, req, res, next, next_target, context, error);
	return result;
}


ValumHandlerCallback valum_safely (ValumSafeHandlerCallback forward, void* forward_target, GDestroyNotify forward_target_destroy_notify, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block22Data* _data22_;
	ValumSafeHandlerCallback _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	ValumHandlerCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	GDestroyNotify _tmp1__target_destroy_notify = NULL;
	_data22_ = g_slice_new0 (Block22Data);
	_data22_->_ref_count_ = 1;
	_tmp0_ = forward;
	_tmp0__target = forward_target;
	(_data22_->forward_target_destroy_notify == NULL) ? NULL : (_data22_->forward_target_destroy_notify (_data22_->forward_target), NULL);
	_data22_->forward = NULL;
	_data22_->forward_target = NULL;
	_data22_->forward_target_destroy_notify = NULL;
	_data22_->forward = _tmp0_;
	_data22_->forward_target = _tmp0__target;
	_data22_->forward_target_destroy_notify = forward_target_destroy_notify;
	_tmp1_ = ___lambda32__valum_handler_callback;
	_tmp1__target = block22_data_ref (_data22_);
	_tmp1__target_destroy_notify = block22_data_unref;
	*result_target = _tmp1__target;
	*result_target_destroy_notify = _tmp1__target_destroy_notify;
	result = _tmp1_;
	block22_data_unref (_data22_);
	_data22_ = NULL;
	return result;
}



