/* valum-server-sent-events.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-server-sent-events.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include "vsgi.h"
#include <libsoup/soup.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _Block26Data Block26Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block27Data Block27Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _Block26Data {
	int _ref_count_;
	ValumServerSentEventsEventStreamCallback context;
	gpointer context_target;
	GDestroyNotify context_target_destroy_notify;
};

struct _Block27Data {
	int _ref_count_;
	Block26Data * _data26_;
	VSGIResponse* res;
};



static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static gboolean __lambda36_ (Block26Data* _data26_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* _context, GError** error);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static gboolean __lambda37_ (Block27Data* _data27_);
static gboolean ___lambda37__gsource_func (gpointer self);
static void __lambda38_ (Block27Data* _data27_, const gchar* event, const gchar* data, const gchar* id, GTimeSpan* retry, GError** error);
static void ___lambda38__valum_server_sent_events_send_event_callback (const gchar* event, const gchar* data, const gchar* id, GTimeSpan* retry, gpointer self, GError** error);
static gboolean ___lambda36__valum_forward_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gconstpointer value, gpointer self, GError** error);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Middleware that create a context for sending Server-Sent Events.
 *
 * The {@link VSGI.Response} cannot be manipulated directly, but through a
 * {@link Valum.ServerSentEvents.SendEventCallback} callback instead.
 *
 * The stream is explicitly flushed the ensure that the user agent receives
 * the message.
 *
 * Messages are send directly with the {@link Soup.Encoding.EOF} encoding
 * as recommended by the W3C.
 *
 * The middleware automatically send a keep-alive every 15 seconds to ensure
 * that unaware clients keep the connection opened.
 *
 * @param context context for sending events
 */
static Block26Data* block26_data_ref (Block26Data* _data26_) {
	g_atomic_int_inc (&_data26_->_ref_count_);
	return _data26_;
}


static void block26_data_unref (void * _userdata_) {
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
		(_data26_->context_target_destroy_notify == NULL) ? NULL : (_data26_->context_target_destroy_notify (_data26_->context_target), NULL);
		_data26_->context = NULL;
		_data26_->context_target = NULL;
		_data26_->context_target_destroy_notify = NULL;
		g_slice_free (Block26Data, _data26_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block27Data* block27_data_ref (Block27Data* _data27_) {
	g_atomic_int_inc (&_data27_->_ref_count_);
	return _data27_;
}


static void block27_data_unref (void * _userdata_) {
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
		_g_object_unref0 (_data27_->res);
		block26_data_unref (_data27_->_data26_);
		_data27_->_data26_ = NULL;
		g_slice_free (Block27Data, _data27_);
	}
}


static gboolean __lambda37_ (Block27Data* _data27_) {
	Block26Data* _data26_;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	_data26_ = _data27_->_data26_;
	{
		gboolean _tmp0_ = FALSE;
		VSGIResponse* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		_tmp1_ = _data27_->res;
		_tmp2_ = ((GObject*) _tmp1_)->ref_count;
		if (_tmp2_ > ((guint) 1)) {
			gboolean _tmp3_ = FALSE;
			VSGIResponse* _tmp4_ = NULL;
			gboolean _tmp5_ = FALSE;
			_tmp4_ = _data27_->res;
			_tmp5_ = vsgi_response_append_utf8 (_tmp4_, ":\n", NULL, &_inner_error_);
			_tmp3_ = _tmp5_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch12_g_error;
			}
			_tmp0_ = _tmp3_;
		} else {
			_tmp0_ = FALSE;
		}
		result = _tmp0_;
		return result;
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		GQuark _tmp9_ = 0U;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = err;
		_tmp7_ = _tmp6_->message;
		_tmp8_ = err;
		_tmp9_ = _tmp8_->domain;
		_tmp10_ = g_quark_to_string (_tmp9_);
		_tmp11_ = err;
		_tmp12_ = _tmp11_->code;
		g_critical ("valum-server-sent-events.vala:101: %s (%s, %d)", _tmp7_, _tmp10_, _tmp12_);
		result = FALSE;
		_g_error_free0 (err);
		return result;
	}
	__finally12:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return FALSE;
}


static gboolean ___lambda37__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda37_ (self);
	return result;
}


static void __lambda38_ (Block27Data* _data27_, const gchar* event, const gchar* data, const gchar* id, GTimeSpan* retry, GError** error) {
	Block26Data* _data26_;
	GString* message = NULL;
	GString* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp4_ = NULL;
	GTimeSpan* _tmp7_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar** _tmp11_ = NULL;
	gchar** _tmp12_ = NULL;
	GString* _tmp16_ = NULL;
	VSGIResponse* _tmp17_ = NULL;
	GString* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	GError * _inner_error_ = NULL;
	_data26_ = _data27_->_data26_;
	g_return_if_fail (data != NULL);
	_tmp0_ = g_string_new ("");
	message = _tmp0_;
	_tmp1_ = event;
	if (_tmp1_ != NULL) {
		GString* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		_tmp2_ = message;
		_tmp3_ = event;
		g_string_append_printf (_tmp2_, "event: %s\n", _tmp3_);
	}
	_tmp4_ = id;
	if (_tmp4_ != NULL) {
		GString* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		_tmp5_ = message;
		_tmp6_ = id;
		g_string_append_printf (_tmp5_, "id: %s\n", _tmp6_);
	}
	_tmp7_ = retry;
	if (_tmp7_ != NULL) {
		GString* _tmp8_ = NULL;
		GTimeSpan* _tmp9_ = NULL;
		_tmp8_ = message;
		_tmp9_ = retry;
		g_string_append_printf (_tmp8_, "retry: %" G_GINT64_FORMAT "\n", (*_tmp9_) / 1000);
	}
	_tmp10_ = data;
	_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, "\n", 0);
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
		line_collection = _tmp12_;
		line_collection_length1 = _vala_array_length (_tmp11_);
		for (line_it = 0; line_it < _vala_array_length (_tmp11_); line_it = line_it + 1) {
			gchar* _tmp13_ = NULL;
			gchar* line = NULL;
			_tmp13_ = g_strdup (line_collection[line_it]);
			line = _tmp13_;
			{
				GString* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				_tmp14_ = message;
				_tmp15_ = line;
				g_string_append_printf (_tmp14_, "data: %s\n", _tmp15_);
				_g_free0 (line);
			}
		}
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp16_ = message;
	g_string_append_c (_tmp16_, '\n');
	_tmp17_ = _data27_->res;
	_tmp18_ = message;
	_tmp19_ = _tmp18_->str;
	vsgi_response_append_utf8 (_tmp17_, _tmp19_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_string_free0 (message);
		return;
	}
	_g_string_free0 (message);
}


static void ___lambda38__valum_server_sent_events_send_event_callback (const gchar* event, const gchar* data, const gchar* id, GTimeSpan* retry, gpointer self, GError** error) {
	__lambda38_ (self, event, data, id, retry, error);
}


static gboolean __lambda36_ (Block26Data* _data26_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* _context, GError** error) {
	gboolean result = FALSE;
	Block27Data* _data27_;
	VSGIResponse* _tmp0_ = NULL;
	VSGIResponse* _tmp1_ = NULL;
	VSGIResponse* _tmp2_ = NULL;
	SoupMessageHeaders* _tmp3_ = NULL;
	SoupMessageHeaders* _tmp4_ = NULL;
	gsize bytes_size = 0UL;
	VSGIResponse* _tmp5_ = NULL;
	gsize _tmp6_ = 0UL;
	VSGIRequest* _tmp7_ = NULL;
	VSGIConnection* _tmp8_ = NULL;
	VSGIConnection* _tmp9_ = NULL;
	GOutputStream* _tmp10_ = NULL;
	GOutputStream* _tmp11_ = NULL;
	VSGIRequest* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gboolean _tmp16_ = FALSE;
	ValumServerSentEventsEventStreamCallback _tmp20_ = NULL;
	void* _tmp20__target = NULL;
	VSGIRequest* _tmp21_ = NULL;
	ValumContext* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (_context != NULL, FALSE);
	_data27_ = g_slice_new0 (Block27Data);
	_data27_->_ref_count_ = 1;
	_data27_->_data26_ = block26_data_ref (_data26_);
	_tmp0_ = res;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data27_->res);
	_data27_->res = _tmp1_;
	_tmp2_ = _data27_->res;
	_tmp3_ = vsgi_response_get_headers (_tmp2_);
	_tmp4_ = _tmp3_;
	soup_message_headers_set_encoding (_tmp4_, SOUP_ENCODING_EOF);
	_tmp5_ = _data27_->res;
	vsgi_response_write_head (_tmp5_, &_tmp6_, NULL, &_inner_error_);
	bytes_size = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		block27_data_unref (_data27_);
		_data27_ = NULL;
		return FALSE;
	}
	_tmp7_ = req;
	_tmp8_ = vsgi_request_get_connection (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_io_stream_get_output_stream ((GIOStream*) _tmp9_);
	_tmp11_ = _tmp10_;
	g_output_stream_flush (_tmp11_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		block27_data_unref (_data27_);
		_data27_ = NULL;
		return FALSE;
	}
	_tmp12_ = req;
	_tmp13_ = vsgi_request_get_method (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strcmp0 (_tmp15_, VSGI_REQUEST_HEAD) == 0;
	_g_free0 (_tmp15_);
	if (_tmp16_) {
		gboolean _tmp17_ = FALSE;
		VSGIResponse* _tmp18_ = NULL;
		gboolean _tmp19_ = FALSE;
		_tmp18_ = _data27_->res;
		_tmp19_ = vsgi_response_end (_tmp18_, NULL, &_inner_error_);
		_tmp17_ = _tmp19_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			block27_data_unref (_data27_);
			_data27_ = NULL;
			return FALSE;
		}
		result = _tmp17_;
		block27_data_unref (_data27_);
		_data27_ = NULL;
		return result;
	}
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 15, ___lambda37__gsource_func, block27_data_ref (_data27_), block27_data_unref);
	_tmp20_ = _data26_->context;
	_tmp20__target = _data26_->context_target;
	_tmp21_ = req;
	_tmp22_ = _context;
	_tmp20_ (_tmp21_, ___lambda38__valum_server_sent_events_send_event_callback, block27_data_ref (_data27_), block27_data_unref, _tmp22_, _tmp20__target, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		block27_data_unref (_data27_);
		_data27_ = NULL;
		return FALSE;
	}
	result = TRUE;
	block27_data_unref (_data27_);
	_data27_ = NULL;
	return result;
}


static gboolean ___lambda36__valum_forward_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gconstpointer value, gpointer self, GError** error) {
	gboolean result;
	result = __lambda36_ (self, req, res, next, next_target, context, error);
	return result;
}


ValumHandlerCallback valum_server_sent_events_stream_events (ValumServerSentEventsEventStreamCallback context, void* context_target, GDestroyNotify context_target_destroy_notify, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block26Data* _data26_;
	ValumServerSentEventsEventStreamCallback _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	void* _tmp1_ = NULL;
	GDestroyNotify _tmp2_ = NULL;
	ValumHandlerCallback _tmp3_ = NULL;
	ValumHandlerCallback _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	GDestroyNotify _tmp4__target_destroy_notify = NULL;
	_data26_ = g_slice_new0 (Block26Data);
	_data26_->_ref_count_ = 1;
	_tmp0_ = context;
	_tmp0__target = context_target;
	(_data26_->context_target_destroy_notify == NULL) ? NULL : (_data26_->context_target_destroy_notify (_data26_->context_target), NULL);
	_data26_->context = NULL;
	_data26_->context_target = NULL;
	_data26_->context_target_destroy_notify = NULL;
	_data26_->context = _tmp0_;
	_data26_->context_target = _tmp0__target;
	_data26_->context_target_destroy_notify = context_target_destroy_notify;
	_tmp3_ = valum_content_negotiation_accept ("text/event-stream", ___lambda36__valum_forward_callback, block26_data_ref (_data26_), block26_data_unref, &_tmp1_, &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp4__target = _tmp1_;
	_tmp4__target_destroy_notify = _tmp2_;
	*result_target = _tmp4__target;
	*result_target_destroy_notify = _tmp4__target_destroy_notify;
	result = _tmp4_;
	block26_data_unref (_data26_);
	_data26_ = NULL;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



