/* valum-status.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-status.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include <libsoup/soup.h>
#include "vsgi.h"

typedef struct _Block33Data Block33Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

/**
 * Informational status corresponding to the 1xx HTTP status codes.
 *
 * @see   Soup.Status
 */
/**
 * Success corresponding to the 2xx HTTP status codes.
 *
 * @see   Soup.Status
 */
/**
 * Redirection corresponding to the 3xx HTTP status codes.
 *
 * The error message will be used in the 'Location' header.
 *
 * @see   Soup.Status
 */
/**
 * Client errors corresponding to the 4xx HTTP status codes.
 *
 * @see   Soup.Status
 */
/**
 * Server errors corresponding to the 5xx HTTP status codes.
 *
 * @see   Soup.Status
 */
struct _Block33Data {
	int _ref_count_;
	guint status;
	ValumForwardCallback forward;
	gpointer forward_target;
	GDestroyNotify forward_target_destroy_notify;
};



gboolean valum_is_status (GError* err);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static gboolean __lambda43_ (Block33Data* _data33_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error);
static gboolean ___lambda43__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);


/**
 * Determine if a {@link GLib.Error} represent a status.
 */
inline gboolean valum_is_status (GError* err) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GError* _tmp4_ = NULL;
	_tmp4_ = err;
	if (_tmp4_->domain == VALUM_INFORMATIONAL) {
		_tmp3_ = TRUE;
	} else {
		GError* _tmp5_ = NULL;
		_tmp5_ = err;
		_tmp3_ = _tmp5_->domain == VALUM_SUCCESS;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		GError* _tmp6_ = NULL;
		_tmp6_ = err;
		_tmp2_ = _tmp6_->domain == VALUM_REDIRECTION;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		GError* _tmp7_ = NULL;
		_tmp7_ = err;
		_tmp1_ = _tmp7_->domain == VALUM_CLIENT_ERROR;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		GError* _tmp8_ = NULL;
		_tmp8_ = err;
		_tmp0_ = _tmp8_->domain == VALUM_SERVER_ERROR;
	}
	result = _tmp0_;
	return result;
}


GQuark valum_informational_quark (void) {
	return g_quark_from_static_string ("valum_informational-quark");
}


GQuark valum_success_quark (void) {
	return g_quark_from_static_string ("valum_success-quark");
}


GQuark valum_redirection_quark (void) {
	return g_quark_from_static_string ("valum_redirection-quark");
}


GQuark valum_client_error_quark (void) {
	return g_quark_from_static_string ("valum_client_error-quark");
}


GQuark valum_server_error_quark (void) {
	return g_quark_from_static_string ("valum_server_error-quark");
}


/**
 * Handle any corresponding error thrown by the following handler.
 *
 * If {@link Soup.Status.INTERNAL_SERVER_ERROR} is specified, other errors
 * will be forwarded as well.
 */
static Block33Data* block33_data_ref (Block33Data* _data33_) {
	g_atomic_int_inc (&_data33_->_ref_count_);
	return _data33_;
}


static void block33_data_unref (void * _userdata_) {
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
		(_data33_->forward_target_destroy_notify == NULL) ? NULL : (_data33_->forward_target_destroy_notify (_data33_->forward_target), NULL);
		_data33_->forward = NULL;
		_data33_->forward_target = NULL;
		_data33_->forward_target_destroy_notify = NULL;
		g_slice_free (Block33Data, _data33_);
	}
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static gboolean __lambda43_ (Block33Data* _data33_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* ctx, GError** error) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		ValumNextCallback _tmp1_ = NULL;
		void* _tmp1__target = NULL;
		gboolean _tmp2_ = FALSE;
		_tmp1_ = next;
		_tmp1__target = next_target;
		_tmp2_ = _tmp1_ (_tmp1__target, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch15_g_error;
		}
		result = _tmp0_;
		return result;
	}
	goto __finally15;
	__catch15_g_error:
	{
		GError* err = NULL;
		gboolean _tmp3_ = FALSE;
		GError* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = err;
		_tmp5_ = valum_is_status (_tmp4_);
		if (_tmp5_) {
			GError* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			guint _tmp8_ = 0U;
			_tmp6_ = err;
			_tmp7_ = _tmp6_->code;
			_tmp8_ = _data33_->status;
			_tmp3_ = ((guint) _tmp7_) == _tmp8_;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			GError* _err = NULL;
			GError* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			ValumForwardCallback _tmp11_ = NULL;
			void* _tmp11__target = NULL;
			VSGIRequest* _tmp12_ = NULL;
			VSGIResponse* _tmp13_ = NULL;
			ValumNextCallback _tmp14_ = NULL;
			void* _tmp14__target = NULL;
			ValumContext* _tmp15_ = NULL;
			GError* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
			_tmp9_ = err;
			err = NULL;
			_err = _tmp9_;
			_tmp11_ = _data33_->forward;
			_tmp11__target = _data33_->forward_target;
			_tmp12_ = req;
			_tmp13_ = res;
			_tmp14_ = next;
			_tmp14__target = next_target;
			_tmp15_ = ctx;
			_tmp16_ = _err;
			_tmp17_ = _tmp11_ (_tmp12_, _tmp13_, _tmp14_, _tmp14__target, _tmp15_, _tmp16_, _tmp11__target, &_inner_error_);
			_tmp10_ = _tmp17_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_error_free0 (_err);
				_g_error_free0 (err);
				goto __finally15;
			}
			result = _tmp10_;
			_g_error_free0 (_err);
			_g_error_free0 (err);
			return result;
		} else {
			GError* _tmp18_ = NULL;
			gint _tmp19_ = 0;
			_tmp18_ = err;
			_tmp19_ = _tmp18_->code;
			if (_tmp19_ == ((gint) SOUP_STATUS_INTERNAL_SERVER_ERROR)) {
				GError* _err = NULL;
				GError* _tmp20_ = NULL;
				gboolean _tmp21_ = FALSE;
				ValumForwardCallback _tmp22_ = NULL;
				void* _tmp22__target = NULL;
				VSGIRequest* _tmp23_ = NULL;
				VSGIResponse* _tmp24_ = NULL;
				ValumNextCallback _tmp25_ = NULL;
				void* _tmp25__target = NULL;
				ValumContext* _tmp26_ = NULL;
				GError* _tmp27_ = NULL;
				gboolean _tmp28_ = FALSE;
				_tmp20_ = err;
				err = NULL;
				_err = _tmp20_;
				_tmp22_ = _data33_->forward;
				_tmp22__target = _data33_->forward_target;
				_tmp23_ = req;
				_tmp24_ = res;
				_tmp25_ = next;
				_tmp25__target = next_target;
				_tmp26_ = ctx;
				_tmp27_ = _err;
				_tmp28_ = _tmp22_ (_tmp23_, _tmp24_, _tmp25_, _tmp25__target, _tmp26_, _tmp27_, _tmp22__target, &_inner_error_);
				_tmp21_ = _tmp28_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_error_free0 (_err);
					_g_error_free0 (err);
					goto __finally15;
				}
				result = _tmp21_;
				_g_error_free0 (_err);
				_g_error_free0 (err);
				return result;
			} else {
				GError* _tmp29_ = NULL;
				GError* _tmp30_ = NULL;
				_tmp29_ = err;
				_tmp30_ = _g_error_copy0 (_tmp29_);
				_inner_error_ = _tmp30_;
				_g_error_free0 (err);
				goto __finally15;
			}
		}
		_g_error_free0 (err);
	}
	__finally15:
	g_propagate_error (error, _inner_error_);
	return FALSE;
}


static gboolean ___lambda43__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda43_ (self, req, res, next, next_target, context, error);
	return result;
}


ValumHandlerCallback valum_status (guint status, ValumForwardCallback forward, void* forward_target, GDestroyNotify forward_target_destroy_notify, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block33Data* _data33_;
	guint _tmp0_ = 0U;
	ValumForwardCallback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	ValumHandlerCallback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	GDestroyNotify _tmp2__target_destroy_notify = NULL;
	_data33_ = g_slice_new0 (Block33Data);
	_data33_->_ref_count_ = 1;
	_tmp0_ = status;
	_data33_->status = _tmp0_;
	_tmp1_ = forward;
	_tmp1__target = forward_target;
	(_data33_->forward_target_destroy_notify == NULL) ? NULL : (_data33_->forward_target_destroy_notify (_data33_->forward_target), NULL);
	_data33_->forward = NULL;
	_data33_->forward_target = NULL;
	_data33_->forward_target_destroy_notify = NULL;
	_data33_->forward = _tmp1_;
	_data33_->forward_target = _tmp1__target;
	_data33_->forward_target_destroy_notify = forward_target_destroy_notify;
	_tmp2_ = ___lambda43__valum_handler_callback;
	_tmp2__target = block33_data_ref (_data33_);
	_tmp2__target_destroy_notify = block33_data_unref;
	*result_target = _tmp2__target;
	*result_target_destroy_notify = _tmp2__target_destroy_notify;
	result = _tmp2_;
	block33_data_unref (_data33_);
	_data33_ = NULL;
	return result;
}



