/* valum-subdomain.c generated by valac 0.26.1, the Vala compiler
 * generated from valum-subdomain.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "valum.h"
#include <stdlib.h>
#include <string.h>
#include "vsgi.h"
#include <libsoup/soup.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block34Data Block34Data;

struct _Block34Data {
	int _ref_count_;
	gchar* expected_subdomain;
	ValumForwardCallback forward;
	gpointer forward_target;
	GDestroyNotify forward_target_destroy_notify;
	gboolean strict;
	guint skip;
};



static gchar** _vala_array_dup1 (gchar** self, int length);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static gboolean __lambda44_ (Block34Data* _data34_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* stack, GError** error);
static gboolean ___lambda44__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Extract subdomains from a domain name excluding the top and second level
 * domain.
 *
 * @param domain domain from which subdomains will be extracted
 * @param skip   number of labels to skip, which defaults to 2 (eg. 'example'
 *               and 'com')
 * @return a list of subdomains in their left-to-right order of appearance
 *         in the domain excluding the two top-most levels
 */
static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


gchar** valum_extract_subdomains (const gchar* domain, guint skip, int* result_length1) {
	gchar** result = NULL;
	gchar** labels = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint labels_length1 = 0;
	gint _labels_size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint _tmp4_ = 0U;
	gchar** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gchar** _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	guint _tmp9_ = 0U;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	gchar** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	g_return_val_if_fail (domain != NULL, NULL);
	_tmp0_ = domain;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ".", 0);
	labels = _tmp2_;
	labels_length1 = _vala_array_length (_tmp1_);
	_labels_size_ = labels_length1;
	_tmp3_ = labels;
	_tmp3__length1 = labels_length1;
	_tmp4_ = skip;
	if (((guint) _tmp3__length1) <= _tmp4_) {
		gchar** _tmp5_ = NULL;
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		_tmp5_ = g_new0 (gchar*, 0 + 1);
		_tmp6_ = _tmp5_;
		_tmp6__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp6__length1;
		}
		result = _tmp6_;
		labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp7_ = labels;
	_tmp7__length1 = labels_length1;
	_tmp8_ = labels;
	_tmp8__length1 = labels_length1;
	_tmp9_ = skip;
	_tmp10_ = ((_tmp7_ + 0) != NULL) ? _vala_array_dup1 (_tmp7_ + 0, ((gint) (_tmp8__length1 - _tmp9_)) - 0) : ((gpointer) (_tmp7_ + 0));
	_tmp10__length1 = ((gint) (_tmp8__length1 - _tmp9_)) - 0;
	_tmp11_ = _tmp10_;
	_tmp11__length1 = _tmp10__length1;
	if (result_length1) {
		*result_length1 = _tmp11__length1;
	}
	result = _tmp11_;
	labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


/**
 * Produce a matching middleware that accepts request which subdomain is
 * consistent with the expectation.
 *
 * If the expected subdomain is 'api', then 'api.example.com' and
 * '*.api.example.com' will be accepted.
 *
 * The joker '*' can be used to fuzzy-match a label.
 *
 * @param expected_subdomain expected subdomain pattern
 * @param forward            invoked if the subdomain matches
 * @param strict             strictly match the subdomains to have the
 *                           exactly same amount of labels
 * @param skip               see {@link Valum.extract_subdomains}
 */
static Block34Data* block34_data_ref (Block34Data* _data34_) {
	g_atomic_int_inc (&_data34_->_ref_count_);
	return _data34_;
}


static void block34_data_unref (void * _userdata_) {
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
		_g_free0 (_data34_->expected_subdomain);
		(_data34_->forward_target_destroy_notify == NULL) ? NULL : (_data34_->forward_target_destroy_notify (_data34_->forward_target), NULL);
		_data34_->forward = NULL;
		_data34_->forward_target = NULL;
		_data34_->forward_target_destroy_notify = NULL;
		g_slice_free (Block34Data, _data34_);
	}
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	_tmp0_ = separator;
	if (_tmp0_ == NULL) {
		separator = "";
	}
	_tmp3_ = str_array;
	_tmp3__length1 = str_array_length1;
	if (_tmp3_ != NULL) {
		_tmp2_ = TRUE;
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp4_ = str_array;
		_tmp4__length1 = str_array_length1;
		_tmp2_ = _tmp4__length1 > 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		_tmp6_ = str_array;
		_tmp6__length1 = str_array_length1;
		if (_tmp6__length1 == (-1)) {
			gchar** _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			const gchar* _tmp8_ = NULL;
			_tmp7_ = str_array;
			_tmp7__length1 = str_array_length1;
			_tmp8_ = _tmp7_[0];
			_tmp5_ = _tmp8_ != NULL;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_ = 0;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		gsize _tmp35_ = 0UL;
		const gchar* _tmp36_ = NULL;
		gint _tmp37_ = 0;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		const gchar* res = NULL;
		gsize _tmp40_ = 0UL;
		void* _tmp41_ = NULL;
		void* ptr = NULL;
		const gchar* _tmp42_ = NULL;
		gchar** _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		const gchar* _tmp44_ = NULL;
		void* _tmp45_ = NULL;
		const gchar* _tmp62_ = NULL;
		len = (gsize) 1;
		{
			gboolean _tmp9_ = FALSE;
			i = 0;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp21_ = 0;
				gchar** _tmp22_ = NULL;
				gint _tmp22__length1 = 0;
				gint _tmp23_ = 0;
				const gchar* _tmp24_ = NULL;
				gsize _tmp30_ = 0UL;
				if (!_tmp9_) {
					gint _tmp10_ = 0;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp13_ = str_array;
				_tmp13__length1 = str_array_length1;
				if (_tmp13__length1 != (-1)) {
					gint _tmp14_ = 0;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
					_tmp14_ = i;
					_tmp15_ = str_array;
					_tmp15__length1 = str_array_length1;
					_tmp12_ = _tmp14_ < _tmp15__length1;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					_tmp11_ = TRUE;
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_ = NULL;
					gint _tmp17__length1 = 0;
					_tmp17_ = str_array;
					_tmp17__length1 = str_array_length1;
					if (_tmp17__length1 == (-1)) {
						gchar** _tmp18_ = NULL;
						gint _tmp18__length1 = 0;
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
						_tmp18_ = str_array;
						_tmp18__length1 = str_array_length1;
						_tmp19_ = i;
						_tmp20_ = _tmp18_[_tmp19_];
						_tmp16_ = _tmp20_ != NULL;
					} else {
						_tmp16_ = FALSE;
					}
					_tmp11_ = _tmp16_;
				}
				if (!_tmp11_) {
					break;
				}
				_tmp22_ = str_array;
				_tmp22__length1 = str_array_length1;
				_tmp23_ = i;
				_tmp24_ = _tmp22_[_tmp23_];
				if (_tmp24_ != NULL) {
					gchar** _tmp25_ = NULL;
					gint _tmp25__length1 = 0;
					gint _tmp26_ = 0;
					const gchar* _tmp27_ = NULL;
					gint _tmp28_ = 0;
					gint _tmp29_ = 0;
					_tmp25_ = str_array;
					_tmp25__length1 = str_array_length1;
					_tmp26_ = i;
					_tmp27_ = _tmp25_[_tmp26_];
					_tmp28_ = strlen ((const gchar*) _tmp27_);
					_tmp29_ = _tmp28_;
					_tmp21_ = _tmp29_;
				} else {
					_tmp21_ = 0;
				}
				_tmp30_ = len;
				len = _tmp30_ + _tmp21_;
			}
		}
		_tmp31_ = i;
		if (_tmp31_ == 0) {
			gchar* _tmp32_ = NULL;
			_tmp32_ = g_strdup ("");
			result = _tmp32_;
			return result;
		}
		_tmp33_ = i;
		str_array_length1 = _tmp33_;
		_tmp34_ = str_array_length1;
		_tmp35_ = len;
		_tmp36_ = separator;
		_tmp37_ = strlen ((const gchar*) _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = i;
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
		_tmp40_ = len;
		_tmp41_ = g_malloc (_tmp40_);
		res = _tmp41_;
		_tmp42_ = res;
		_tmp43_ = str_array;
		_tmp43__length1 = str_array_length1;
		_tmp44_ = _tmp43_[0];
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
		ptr = _tmp45_;
		{
			gboolean _tmp46_ = FALSE;
			i = 1;
			_tmp46_ = TRUE;
			while (TRUE) {
				gint _tmp48_ = 0;
				gchar** _tmp49_ = NULL;
				gint _tmp49__length1 = 0;
				void* _tmp50_ = NULL;
				const gchar* _tmp51_ = NULL;
				void* _tmp52_ = NULL;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_ = NULL;
				gint _tmp54__length1 = 0;
				gint _tmp55_ = 0;
				const gchar* _tmp56_ = NULL;
				void* _tmp60_ = NULL;
				void* _tmp61_ = NULL;
				if (!_tmp46_) {
					gint _tmp47_ = 0;
					_tmp47_ = i;
					i = _tmp47_ + 1;
				}
				_tmp46_ = FALSE;
				_tmp48_ = i;
				_tmp49_ = str_array;
				_tmp49__length1 = str_array_length1;
				if (!(_tmp48_ < _tmp49__length1)) {
					break;
				}
				_tmp50_ = ptr;
				_tmp51_ = separator;
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
				ptr = _tmp52_;
				_tmp54_ = str_array;
				_tmp54__length1 = str_array_length1;
				_tmp55_ = i;
				_tmp56_ = _tmp54_[_tmp55_];
				if (_tmp56_ != NULL) {
					gchar** _tmp57_ = NULL;
					gint _tmp57__length1 = 0;
					gint _tmp58_ = 0;
					const gchar* _tmp59_ = NULL;
					_tmp57_ = str_array;
					_tmp57__length1 = str_array_length1;
					_tmp58_ = i;
					_tmp59_ = _tmp57_[_tmp58_];
					_tmp53_ = (const gchar*) _tmp59_;
				} else {
					_tmp53_ = "";
				}
				_tmp60_ = ptr;
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
				ptr = _tmp61_;
			}
		}
		_tmp62_ = res;
		res = NULL;
		result = (gchar*) _tmp62_;
		return result;
	} else {
		gchar* _tmp63_ = NULL;
		_tmp63_ = g_strdup ("");
		result = _tmp63_;
		return result;
	}
}


static gboolean __lambda44_ (Block34Data* _data34_, VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* stack, GError** error) {
	gboolean result = FALSE;
	gchar** expected_labels = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint expected_labels_length1 = 0;
	gint _expected_labels_size_ = 0;
	gchar** labels = NULL;
	VSGIRequest* _tmp3_ = NULL;
	SoupURI* _tmp4_ = NULL;
	SoupURI* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	gint _tmp8_ = 0;
	gchar** _tmp9_ = NULL;
	gint labels_length1 = 0;
	gint _labels_size_ = 0;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	gchar** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp42_ = FALSE;
	ValumForwardCallback _tmp43_ = NULL;
	void* _tmp43__target = NULL;
	VSGIRequest* _tmp44_ = NULL;
	VSGIResponse* _tmp45_ = NULL;
	ValumNextCallback _tmp46_ = NULL;
	void* _tmp46__target = NULL;
	ValumContext* _tmp47_ = NULL;
	gchar** _tmp48_ = NULL;
	gint _tmp48__length1 = 0;
	gchar* _tmp49_ = NULL;
	gchar* _tmp50_ = NULL;
	gboolean _tmp51_ = FALSE;
	gboolean _tmp52_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (req != NULL, FALSE);
	g_return_val_if_fail (res != NULL, FALSE);
	g_return_val_if_fail (stack != NULL, FALSE);
	_tmp0_ = _data34_->expected_subdomain;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ".", 0);
	expected_labels = _tmp2_;
	expected_labels_length1 = _vala_array_length (_tmp1_);
	_expected_labels_size_ = expected_labels_length1;
	_tmp3_ = req;
	_tmp4_ = vsgi_request_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_->host;
	_tmp7_ = _data34_->skip;
	_tmp9_ = valum_extract_subdomains (_tmp6_, _tmp7_, &_tmp8_);
	labels = _tmp9_;
	labels_length1 = _tmp8_;
	_labels_size_ = labels_length1;
	_tmp10_ = expected_labels;
	_tmp10__length1 = expected_labels_length1;
	_tmp11_ = labels;
	_tmp11__length1 = labels_length1;
	if (_tmp10__length1 > _tmp11__length1) {
		gboolean _tmp12_ = FALSE;
		ValumNextCallback _tmp13_ = NULL;
		void* _tmp13__target = NULL;
		gboolean _tmp14_ = FALSE;
		_tmp13_ = next;
		_tmp13__target = next_target;
		_tmp14_ = _tmp13_ (_tmp13__target, &_inner_error_);
		_tmp12_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
			expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
			return FALSE;
		}
		result = _tmp12_;
		labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
		expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp16_ = _data34_->strict;
	if (_tmp16_) {
		gchar** _tmp17_ = NULL;
		gint _tmp17__length1 = 0;
		gchar** _tmp18_ = NULL;
		gint _tmp18__length1 = 0;
		_tmp17_ = expected_labels;
		_tmp17__length1 = expected_labels_length1;
		_tmp18_ = labels;
		_tmp18__length1 = labels_length1;
		_tmp15_ = _tmp17__length1 != _tmp18__length1;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		gboolean _tmp19_ = FALSE;
		ValumNextCallback _tmp20_ = NULL;
		void* _tmp20__target = NULL;
		gboolean _tmp21_ = FALSE;
		_tmp20_ = next;
		_tmp20__target = next_target;
		_tmp21_ = _tmp20_ (_tmp20__target, &_inner_error_);
		_tmp19_ = _tmp21_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
			expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
			return FALSE;
		}
		result = _tmp19_;
		labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
		expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				gint _tmp24_ = 0;
				gchar** _tmp25_ = NULL;
				gint _tmp25__length1 = 0;
				gboolean _tmp26_ = FALSE;
				gchar** _tmp27_ = NULL;
				gint _tmp27__length1 = 0;
				gchar** _tmp28_ = NULL;
				gint _tmp28__length1 = 0;
				gint _tmp29_ = 0;
				const gchar* _tmp30_ = NULL;
				if (!_tmp22_) {
					gint _tmp23_ = 0;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = i;
				_tmp25_ = expected_labels;
				_tmp25__length1 = expected_labels_length1;
				if (!(_tmp24_ <= _tmp25__length1)) {
					break;
				}
				_tmp27_ = expected_labels;
				_tmp27__length1 = expected_labels_length1;
				_tmp28_ = expected_labels;
				_tmp28__length1 = expected_labels_length1;
				_tmp29_ = i;
				_tmp30_ = _tmp27_[_tmp28__length1 - _tmp29_];
				if (g_strcmp0 (_tmp30_, "*") != 0) {
					gchar** _tmp31_ = NULL;
					gint _tmp31__length1 = 0;
					gchar** _tmp32_ = NULL;
					gint _tmp32__length1 = 0;
					gint _tmp33_ = 0;
					const gchar* _tmp34_ = NULL;
					gchar** _tmp35_ = NULL;
					gint _tmp35__length1 = 0;
					gchar** _tmp36_ = NULL;
					gint _tmp36__length1 = 0;
					gint _tmp37_ = 0;
					const gchar* _tmp38_ = NULL;
					_tmp31_ = expected_labels;
					_tmp31__length1 = expected_labels_length1;
					_tmp32_ = expected_labels;
					_tmp32__length1 = expected_labels_length1;
					_tmp33_ = i;
					_tmp34_ = _tmp31_[_tmp32__length1 - _tmp33_];
					_tmp35_ = labels;
					_tmp35__length1 = labels_length1;
					_tmp36_ = labels;
					_tmp36__length1 = labels_length1;
					_tmp37_ = i;
					_tmp38_ = _tmp35_[_tmp36__length1 - _tmp37_];
					_tmp26_ = g_strcmp0 (_tmp34_, _tmp38_) != 0;
				} else {
					_tmp26_ = FALSE;
				}
				if (_tmp26_) {
					gboolean _tmp39_ = FALSE;
					ValumNextCallback _tmp40_ = NULL;
					void* _tmp40__target = NULL;
					gboolean _tmp41_ = FALSE;
					_tmp40_ = next;
					_tmp40__target = next_target;
					_tmp41_ = _tmp40_ (_tmp40__target, &_inner_error_);
					_tmp39_ = _tmp41_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						g_propagate_error (error, _inner_error_);
						labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
						expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
						return FALSE;
					}
					result = _tmp39_;
					labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
					expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
			}
		}
	}
	_tmp43_ = _data34_->forward;
	_tmp43__target = _data34_->forward_target;
	_tmp44_ = req;
	_tmp45_ = res;
	_tmp46_ = next;
	_tmp46__target = next_target;
	_tmp47_ = stack;
	_tmp48_ = labels;
	_tmp48__length1 = labels_length1;
	_tmp49_ = _vala_g_strjoinv (".", _tmp48_, _tmp48__length1);
	_tmp50_ = _tmp49_;
	_tmp51_ = _tmp43_ (_tmp44_, _tmp45_, _tmp46_, _tmp46__target, _tmp47_, _tmp50_, _tmp43__target, &_inner_error_);
	_tmp52_ = _tmp51_;
	_g_free0 (_tmp50_);
	_tmp42_ = _tmp52_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
		expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
		return FALSE;
	}
	result = _tmp42_;
	labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
	expected_labels = (_vala_array_free (expected_labels, expected_labels_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static gboolean ___lambda44__valum_handler_callback (VSGIRequest* req, VSGIResponse* res, ValumNextCallback next, void* next_target, ValumContext* context, gpointer self, GError** error) {
	gboolean result;
	result = __lambda44_ (self, req, res, next, next_target, context, error);
	return result;
}


ValumHandlerCallback valum_subdomain (const gchar* expected_subdomain, ValumForwardCallback forward, void* forward_target, GDestroyNotify forward_target_destroy_notify, gboolean strict, guint skip, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	ValumHandlerCallback result = NULL;
	Block34Data* _data34_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	ValumForwardCallback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	gboolean _tmp3_ = FALSE;
	guint _tmp4_ = 0U;
	ValumHandlerCallback _tmp5_ = NULL;
	void* _tmp5__target = NULL;
	GDestroyNotify _tmp5__target_destroy_notify = NULL;
	g_return_val_if_fail (expected_subdomain != NULL, NULL);
	_data34_ = g_slice_new0 (Block34Data);
	_data34_->_ref_count_ = 1;
	_tmp0_ = expected_subdomain;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data34_->expected_subdomain);
	_data34_->expected_subdomain = _tmp1_;
	_tmp2_ = forward;
	_tmp2__target = forward_target;
	(_data34_->forward_target_destroy_notify == NULL) ? NULL : (_data34_->forward_target_destroy_notify (_data34_->forward_target), NULL);
	_data34_->forward = NULL;
	_data34_->forward_target = NULL;
	_data34_->forward_target_destroy_notify = NULL;
	_data34_->forward = _tmp2_;
	_data34_->forward_target = _tmp2__target;
	_data34_->forward_target_destroy_notify = forward_target_destroy_notify;
	_tmp3_ = strict;
	_data34_->strict = _tmp3_;
	_tmp4_ = skip;
	_data34_->skip = _tmp4_;
	_tmp5_ = ___lambda44__valum_handler_callback;
	_tmp5__target = block34_data_ref (_data34_);
	_tmp5__target_destroy_notify = block34_data_unref;
	*result_target = _tmp5__target;
	*result_target_destroy_notify = _tmp5__target_destroy_notify;
	result = _tmp5_;
	block34_data_unref (_data34_);
	_data34_ = NULL;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



