/* vsgi-cgi.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-cgi.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi-cgi.h"
#include "vsgi.h"
#include <gio/gio.h>
#include <stdio.h>
#include <gio/gunixinputstream.h>
#include <gio/gunixoutputstream.h>
#include <stdlib.h>
#include <string.h>


#define VSGI_CGI_TYPE_CONNECTION (vsgi_cgi_connection_get_type ())
#define VSGI_CGI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSGI_CGI_TYPE_CONNECTION, VSGICGIConnection))
#define VSGI_CGI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSGI_CGI_TYPE_CONNECTION, VSGICGIConnectionClass))
#define VSGI_CGI_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSGI_CGI_TYPE_CONNECTION))
#define VSGI_CGI_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSGI_CGI_TYPE_CONNECTION))
#define VSGI_CGI_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSGI_CGI_TYPE_CONNECTION, VSGICGIConnectionClass))

typedef struct _VSGICGIConnection VSGICGIConnection;
typedef struct _VSGICGIConnectionClass VSGICGIConnectionClass;
typedef struct _VSGICGIConnectionPrivate VSGICGIConnectionPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _VSGICGIConnection {
	VSGIConnection parent_instance;
	VSGICGIConnectionPrivate * priv;
};

struct _VSGICGIConnectionClass {
	VSGIConnectionClass parent_class;
};

struct _VSGICGIConnectionPrivate {
	GInputStream* _input_stream;
	GOutputStream* _output_stream;
};


static gpointer vsgi_cgi_connection_parent_class = NULL;
static GType vsgi_cgi_connection_type_id = 0;
static gpointer vsgi_cgi_server_parent_class = NULL;
static GType vsgi_cgi_server_type_id = 0;

GType vsgi_cgi_connection_get_type (void) G_GNUC_CONST;
GType vsgi_cgi_connection_register_type (GTypeModule * module);
#define VSGI_CGI_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_CGI_TYPE_CONNECTION, VSGICGIConnectionPrivate))
enum  {
	VSGI_CGI_CONNECTION_DUMMY_PROPERTY,
	VSGI_CGI_CONNECTION_INPUT_STREAM,
	VSGI_CGI_CONNECTION_OUTPUT_STREAM
};
VSGICGIConnection* vsgi_cgi_connection_new (VSGICGIServer* server, GInputStream* input_stream, GOutputStream* output_stream);
VSGICGIConnection* vsgi_cgi_connection_construct (GType object_type, VSGICGIServer* server, GInputStream* input_stream, GOutputStream* output_stream);
static void vsgi_cgi_connection_finalize (GObject* obj);
static void _vala_vsgi_cgi_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
enum  {
	VSGI_CGI_SERVER_DUMMY_PROPERTY,
	VSGI_CGI_SERVER_URIS
};
static void vsgi_cgi_server_real_listen (VSGIServer* base, GSocketAddress* address, GError** error);
static void __lambda4_ (VSGICGIServer* self, GObject* obj, GAsyncResult* _result_);
static void ___lambda4__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void vsgi_cgi_server_real_listen_socket (VSGIServer* base, GSocket* socket, GError** error);
static void vsgi_cgi_server_real_stop (VSGIServer* base);
static GPid vsgi_cgi_server_real_fork (VSGIServer* base, GError** error);
static void _vala_vsgi_cgi_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType server_init (GTypeModule* type_module) {
	GType result = 0UL;
	g_return_val_if_fail (type_module != NULL, 0UL);
	vsgi_cgi_connection_register_type (type_module);
	vsgi_cgi_server_register_type (type_module);
	result = VSGI_CGI_TYPE_SERVER;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


VSGICGIConnection* vsgi_cgi_connection_construct (GType object_type, VSGICGIServer* server, GInputStream* input_stream, GOutputStream* output_stream) {
	VSGICGIConnection * self = NULL;
	VSGICGIServer* _tmp0_ = NULL;
	GInputStream* _tmp1_ = NULL;
	GInputStream* _tmp2_ = NULL;
	GOutputStream* _tmp3_ = NULL;
	GOutputStream* _tmp4_ = NULL;
	g_return_val_if_fail (server != NULL, NULL);
	g_return_val_if_fail (input_stream != NULL, NULL);
	g_return_val_if_fail (output_stream != NULL, NULL);
	_tmp0_ = server;
	self = (VSGICGIConnection*) g_object_new (object_type, "server", _tmp0_, NULL);
	_tmp1_ = input_stream;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->_input_stream);
	self->priv->_input_stream = _tmp2_;
	_tmp3_ = output_stream;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->_output_stream);
	self->priv->_output_stream = _tmp4_;
	return self;
}


VSGICGIConnection* vsgi_cgi_connection_new (VSGICGIServer* server, GInputStream* input_stream, GOutputStream* output_stream) {
	return vsgi_cgi_connection_construct (VSGI_CGI_TYPE_CONNECTION, server, input_stream, output_stream);
}


static GInputStream* vsgi_cgi_connection_real_get_input_stream (GIOStream* base) {
	GInputStream* result;
	VSGICGIConnection* self;
	GInputStream* _tmp0_ = NULL;
	self = (VSGICGIConnection*) base;
	_tmp0_ = self->priv->_input_stream;
	result = _tmp0_;
	return result;
}


static GOutputStream* vsgi_cgi_connection_real_get_output_stream (GIOStream* base) {
	GOutputStream* result;
	VSGICGIConnection* self;
	GOutputStream* _tmp0_ = NULL;
	self = (VSGICGIConnection*) base;
	_tmp0_ = self->priv->_output_stream;
	result = _tmp0_;
	return result;
}


static void vsgi_cgi_connection_class_init (VSGICGIConnectionClass * klass) {
	vsgi_cgi_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGICGIConnectionPrivate));
	G_IO_STREAM_CLASS (klass)->get_input_stream = vsgi_cgi_connection_real_get_input_stream;
	G_IO_STREAM_CLASS (klass)->get_output_stream = vsgi_cgi_connection_real_get_output_stream;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_cgi_connection_get_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_cgi_connection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_CONNECTION_INPUT_STREAM, g_param_spec_object ("input-stream", "input-stream", "input-stream", G_TYPE_INPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_CONNECTION_OUTPUT_STREAM, g_param_spec_object ("output-stream", "output-stream", "output-stream", G_TYPE_OUTPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_cgi_connection_instance_init (VSGICGIConnection * self) {
	self->priv = VSGI_CGI_CONNECTION_GET_PRIVATE (self);
}


static void vsgi_cgi_connection_finalize (GObject* obj) {
	VSGICGIConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_CGI_TYPE_CONNECTION, VSGICGIConnection);
	_g_object_unref0 (self->priv->_input_stream);
	_g_object_unref0 (self->priv->_output_stream);
	G_OBJECT_CLASS (vsgi_cgi_connection_parent_class)->finalize (obj);
}


GType vsgi_cgi_connection_get_type (void) {
	return vsgi_cgi_connection_type_id;
}


GType vsgi_cgi_connection_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (VSGICGIConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_cgi_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGICGIConnection), 0, (GInstanceInitFunc) vsgi_cgi_connection_instance_init, NULL };
	vsgi_cgi_connection_type_id = g_type_module_register_type (module, VSGI_TYPE_CONNECTION, "VSGICGIConnection", &g_define_type_info, 0);
	return vsgi_cgi_connection_type_id;
}


static void _vala_vsgi_cgi_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGICGIConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_CGI_TYPE_CONNECTION, VSGICGIConnection);
	switch (property_id) {
		case VSGI_CGI_CONNECTION_INPUT_STREAM:
		g_value_set_object (value, g_io_stream_get_input_stream ((GIOStream*) self));
		break;
		case VSGI_CGI_CONNECTION_OUTPUT_STREAM:
		g_value_set_object (value, g_io_stream_get_output_stream ((GIOStream*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void __lambda4_ (VSGICGIServer* self, GObject* obj, GAsyncResult* _result_) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (_result_ != NULL);
	{
		GAsyncResult* _tmp0_ = NULL;
		_tmp0_ = _result_;
		vsgi_server_dispatch_finish ((VSGIServer*) self, _tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = err;
		_tmp2_ = _tmp1_->message;
		g_critical ("vsgi-cgi.vala:84: %s", _tmp2_);
		_g_error_free0 (err);
	}
	__finally0:
	{
		exit (0);
	}
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda4__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	__lambda4_ ((VSGICGIServer*) self, source_object, res);
	g_object_unref (self);
}


static void vsgi_cgi_server_real_listen (VSGIServer* base, GSocketAddress* address, GError** error) {
	VSGICGIServer * self;
	GSocketAddress* _tmp0_ = NULL;
	VSGICGIConnection* connection = NULL;
	FILE* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	GUnixInputStream* _tmp4_ = NULL;
	GUnixInputStream* _tmp5_ = NULL;
	FILE* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	GUnixOutputStream* _tmp8_ = NULL;
	GUnixOutputStream* _tmp9_ = NULL;
	VSGICGIConnection* _tmp10_ = NULL;
	VSGICGIConnection* _tmp11_ = NULL;
	VSGICGIRequest* req = NULL;
	gchar** _tmp12_ = NULL;
	gchar** _tmp13_ = NULL;
	gchar** _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	VSGICGIRequest* _tmp15_ = NULL;
	VSGICGIRequest* _tmp16_ = NULL;
	VSGICGIResponse* res = NULL;
	VSGICGIResponse* _tmp17_ = NULL;
	GError * _inner_error_ = NULL;
	self = (VSGICGIServer*) base;
	_tmp0_ = address;
	if (_tmp0_ != NULL) {
		GError* _tmp1_ = NULL;
		_tmp1_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "The CGI server only support listening from standard streams.");
		_inner_error_ = _tmp1_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp2_ = stdin;
	_tmp3_ = fileno (_tmp2_);
	_tmp4_ = (GUnixInputStream*) g_unix_input_stream_new (_tmp3_, TRUE);
	_tmp5_ = _tmp4_;
	_tmp6_ = stdout;
	_tmp7_ = fileno (_tmp6_);
	_tmp8_ = (GUnixOutputStream*) g_unix_output_stream_new (_tmp7_, TRUE);
	_tmp9_ = _tmp8_;
	_tmp10_ = vsgi_cgi_connection_new (self, (GInputStream*) _tmp5_, (GOutputStream*) _tmp9_);
	_tmp11_ = _tmp10_;
	_g_object_unref0 (_tmp9_);
	_g_object_unref0 (_tmp5_);
	connection = _tmp11_;
	_tmp13_ = _tmp12_ = g_get_environ ();
	_tmp14_ = _tmp13_;
	_tmp14__length1 = _vala_array_length (_tmp12_);
	_tmp15_ = vsgi_cgi_request_new ((VSGIConnection*) connection, _tmp14_, _vala_array_length (_tmp12_));
	_tmp16_ = _tmp15_;
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
	req = _tmp16_;
	_tmp17_ = vsgi_cgi_response_new (req);
	res = _tmp17_;
	vsgi_server_dispatch_async ((VSGIServer*) self, (VSGIRequest*) req, (VSGIResponse*) res, G_PRIORITY_DEFAULT, ___lambda4__gasync_ready_callback, g_object_ref (self));
	_g_object_unref0 (res);
	_g_object_unref0 (req);
	_g_object_unref0 (connection);
}


static void vsgi_cgi_server_real_listen_socket (VSGIServer* base, GSocket* socket, GError** error) {
	VSGICGIServer * self;
	GError* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	self = (VSGICGIServer*) base;
	g_return_if_fail (socket != NULL);
	_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "The CGI server only support listening from standard streams.");
	_inner_error_ = _tmp0_;
	g_propagate_error (error, _inner_error_);
	return;
}


static void vsgi_cgi_server_real_stop (VSGIServer* base) {
	VSGICGIServer * self;
	self = (VSGICGIServer*) base;
}


/**
 * Forking does not make sense for CGI.
 */
static GPid vsgi_cgi_server_real_fork (VSGIServer* base, GError** error) {
	VSGICGIServer * self;
	GPid result = 0;
	self = (VSGICGIServer*) base;
	result = (GPid) 0;
	return result;
}


VSGICGIServer* vsgi_cgi_server_construct (GType object_type) {
	VSGICGIServer * self = NULL;
	self = (VSGICGIServer*) vsgi_server_construct (object_type);
	return self;
}


VSGICGIServer* vsgi_cgi_server_new (void) {
	return vsgi_cgi_server_construct (VSGI_CGI_TYPE_SERVER);
}


static GSList* vsgi_cgi_server_real_get_uris (VSGIServer* base) {
	GSList* result;
	VSGICGIServer* self;
	self = (VSGICGIServer*) base;
	result = NULL;
	return result;
}


static void vsgi_cgi_server_class_init (VSGICGIServerClass * klass) {
	vsgi_cgi_server_parent_class = g_type_class_peek_parent (klass);
	((VSGIServerClass *) klass)->listen = vsgi_cgi_server_real_listen;
	((VSGIServerClass *) klass)->listen_socket = vsgi_cgi_server_real_listen_socket;
	((VSGIServerClass *) klass)->stop = vsgi_cgi_server_real_stop;
	((VSGIServerClass *) klass)->fork = vsgi_cgi_server_real_fork;
	VSGI_SERVER_CLASS (klass)->get_uris = vsgi_cgi_server_real_get_uris;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_cgi_server_get_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_SERVER_URIS, g_param_spec_pointer ("uris", "uris", "uris", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_cgi_server_instance_init (VSGICGIServer * self) {
}


/**
 * {@inheritDoc}
 *
 * Unlike other VSGI implementations, which are actively awaiting upon
 * requests, CGI handles a single request and then wait until the underlying
 * {@link GLib.Application} quits. Longstanding operations can invoke
 * {@link GLib.Application.hold} and {@link GLib.Application.release} to
 * keep the server alive as long as necessary.
 */
GType vsgi_cgi_server_get_type (void) {
	return vsgi_cgi_server_type_id;
}


GType vsgi_cgi_server_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (VSGICGIServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_cgi_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGICGIServer), 0, (GInstanceInitFunc) vsgi_cgi_server_instance_init, NULL };
	vsgi_cgi_server_type_id = g_type_module_register_type (module, VSGI_TYPE_SERVER, "VSGICGIServer", &g_define_type_info, 0);
	return vsgi_cgi_server_type_id;
}


static void _vala_vsgi_cgi_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGICGIServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_CGI_TYPE_SERVER, VSGICGIServer);
	switch (property_id) {
		case VSGI_CGI_SERVER_URIS:
		g_value_set_pointer (value, vsgi_server_get_uris ((VSGIServer*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



