/* vsgi-authentication.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-authentication.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))

struct _VSGIAuthenticationPrivate {
	gchar* _realm;
	gchar* _charset;
};


static gpointer vsgi_authentication_parent_class = NULL;

#define VSGI_AUTHENTICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_TYPE_AUTHENTICATION, VSGIAuthenticationPrivate))
enum  {
	VSGI_AUTHENTICATION_DUMMY_PROPERTY,
	VSGI_AUTHENTICATION_REALM,
	VSGI_AUTHENTICATION_CHARSET
};
static gboolean vsgi_authentication_real_parse_authorization_header (VSGIAuthentication* self, const gchar* authorization_header, VSGIAuthorization** authorization);
static gchar* vsgi_authentication_real_to_authenticate_header (VSGIAuthentication* self);
static void vsgi_authentication_finalize (GObject* obj);
static void _vala_vsgi_authentication_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_authentication_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Check and extract the fields from an 'Authorization' header.
 *
 * @param authorization_header 'Authorization' header value
 * @param authorization        extracted {@link VSGI.Authorization} object
 *                             containing the fields from the header
 *
 * @return 'true' on success, otherwise 'false' and 'authorization' is set
 *         to 'null'
 */
static gboolean vsgi_authentication_real_parse_authorization_header (VSGIAuthentication* self, const gchar* authorization_header, VSGIAuthorization** authorization) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_authentication_parse_authorization_header'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean vsgi_authentication_parse_authorization_header (VSGIAuthentication* self, const gchar* authorization_header, VSGIAuthorization** authorization) {
	g_return_val_if_fail (self != NULL, FALSE);
	return VSGI_AUTHENTICATION_GET_CLASS (self)->parse_authorization_header (self, authorization_header, authorization);
}


/**
 * Produce a 'WWW-Authenticate' (or 'Proxy-Authenticate') header for this.
 */
static gchar* vsgi_authentication_real_to_authenticate_header (VSGIAuthentication* self) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_authentication_to_authenticate_header'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* vsgi_authentication_to_authenticate_header (VSGIAuthentication* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return VSGI_AUTHENTICATION_GET_CLASS (self)->to_authenticate_header (self);
}


VSGIAuthentication* vsgi_authentication_construct (GType object_type) {
	VSGIAuthentication * self = NULL;
	self = (VSGIAuthentication*) g_object_new (object_type, NULL);
	return self;
}


const gchar* vsgi_authentication_get_realm (VSGIAuthentication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_realm;
	result = _tmp0_;
	return result;
}


void vsgi_authentication_set_realm (VSGIAuthentication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_realm);
	self->priv->_realm = _tmp1_;
	g_object_notify ((GObject *) self, "realm");
}


const gchar* vsgi_authentication_get_charset (VSGIAuthentication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_charset;
	result = _tmp0_;
	return result;
}


static void vsgi_authentication_set_charset (VSGIAuthentication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_charset);
	self->priv->_charset = _tmp1_;
	g_object_notify ((GObject *) self, "charset");
}


static void vsgi_authentication_class_init (VSGIAuthenticationClass * klass) {
	vsgi_authentication_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGIAuthenticationPrivate));
	((VSGIAuthenticationClass *) klass)->parse_authorization_header = vsgi_authentication_real_parse_authorization_header;
	((VSGIAuthenticationClass *) klass)->to_authenticate_header = vsgi_authentication_real_to_authenticate_header;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_authentication_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_authentication_set_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_authentication_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_AUTHENTICATION_REALM, g_param_spec_string ("realm", "realm", "realm", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	 * Indicate the expected charset to use by the user agent to encode username
	 * and password.
	 *
	 * If not specified, 'UTF-8' is assumed.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_AUTHENTICATION_CHARSET, g_param_spec_string ("charset", "charset", "charset", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void vsgi_authentication_instance_init (VSGIAuthentication * self) {
	self->priv = VSGI_AUTHENTICATION_GET_PRIVATE (self);
	self->priv->_charset = NULL;
}


static void vsgi_authentication_finalize (GObject* obj) {
	VSGIAuthentication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_AUTHENTICATION, VSGIAuthentication);
	_g_free0 (self->priv->_realm);
	_g_free0 (self->priv->_charset);
	G_OBJECT_CLASS (vsgi_authentication_parent_class)->finalize (obj);
}


/**
 * Hold the necessary state to challenge and emit authentication headers.
 */
GType vsgi_authentication_get_type (void) {
	static volatile gsize vsgi_authentication_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_authentication_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIAuthenticationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_authentication_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIAuthentication), 0, (GInstanceInitFunc) vsgi_authentication_instance_init, NULL };
		GType vsgi_authentication_type_id;
		vsgi_authentication_type_id = g_type_register_static (G_TYPE_OBJECT, "VSGIAuthentication", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&vsgi_authentication_type_id__volatile, vsgi_authentication_type_id);
	}
	return vsgi_authentication_type_id__volatile;
}


static void _vala_vsgi_authentication_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIAuthentication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_AUTHENTICATION, VSGIAuthentication);
	switch (property_id) {
		case VSGI_AUTHENTICATION_REALM:
		g_value_set_string (value, vsgi_authentication_get_realm (self));
		break;
		case VSGI_AUTHENTICATION_CHARSET:
		g_value_set_string (value, vsgi_authentication_get_charset (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_authentication_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGIAuthentication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_AUTHENTICATION, VSGIAuthentication);
	switch (property_id) {
		case VSGI_AUTHENTICATION_REALM:
		vsgi_authentication_set_realm (self, g_value_get_string (value));
		break;
		case VSGI_AUTHENTICATION_CHARSET:
		vsgi_authentication_set_charset (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



