/* vsgi-authorization.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-authorization.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))

struct _VSGIAuthorizationPrivate {
	gchar* _username;
};


static gpointer vsgi_authorization_parent_class = NULL;

#define VSGI_AUTHORIZATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_TYPE_AUTHORIZATION, VSGIAuthorizationPrivate))
enum  {
	VSGI_AUTHORIZATION_DUMMY_PROPERTY,
	VSGI_AUTHORIZATION_USERNAME
};
static gboolean vsgi_authorization_real_challenge_with_password (VSGIAuthorization* self, const gchar* password);
static gchar* vsgi_authorization_real_to_authorization_header (VSGIAuthorization* self);
static void vsgi_authorization_finalize (GObject* obj);
static void _vala_vsgi_authorization_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_authorization_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Challenge the credentials against a provided password.
 *
 * @return 'true' if the password corresponds, 'false' otherwise
 */
static gboolean vsgi_authorization_real_challenge_with_password (VSGIAuthorization* self, const gchar* password) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_authorization_challenge_with_password'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean vsgi_authorization_challenge_with_password (VSGIAuthorization* self, const gchar* password) {
	g_return_val_if_fail (self != NULL, FALSE);
	return VSGI_AUTHORIZATION_GET_CLASS (self)->challenge_with_password (self, password);
}


/**
 * Produce a 'Authorization' header for this.
 *
 * @return an 'Authorization' header value
 */
static gchar* vsgi_authorization_real_to_authorization_header (VSGIAuthorization* self) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_authorization_to_authorization_header'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* vsgi_authorization_to_authorization_header (VSGIAuthorization* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return VSGI_AUTHORIZATION_GET_CLASS (self)->to_authorization_header (self);
}


VSGIAuthorization* vsgi_authorization_construct (GType object_type) {
	VSGIAuthorization * self = NULL;
	self = (VSGIAuthorization*) g_object_new (object_type, NULL);
	return self;
}


const gchar* vsgi_authorization_get_username (VSGIAuthorization* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_username;
	result = _tmp0_;
	return result;
}


static void vsgi_authorization_set_username (VSGIAuthorization* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_username);
	self->priv->_username = _tmp1_;
	g_object_notify ((GObject *) self, "username");
}


static void vsgi_authorization_class_init (VSGIAuthorizationClass * klass) {
	vsgi_authorization_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGIAuthorizationPrivate));
	((VSGIAuthorizationClass *) klass)->challenge_with_password = vsgi_authorization_real_challenge_with_password;
	((VSGIAuthorizationClass *) klass)->to_authorization_header = vsgi_authorization_real_to_authorization_header;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_authorization_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_authorization_set_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_authorization_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_AUTHORIZATION_USERNAME, g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void vsgi_authorization_instance_init (VSGIAuthorization * self) {
	self->priv = VSGI_AUTHORIZATION_GET_PRIVATE (self);
}


static void vsgi_authorization_finalize (GObject* obj) {
	VSGIAuthorization * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_AUTHORIZATION, VSGIAuthorization);
	_g_free0 (self->priv->_username);
	G_OBJECT_CLASS (vsgi_authorization_parent_class)->finalize (obj);
}


/**
 * Hold the state of an 'Authorization' header and provide means to challenge
 * it against a password.
 */
GType vsgi_authorization_get_type (void) {
	static volatile gsize vsgi_authorization_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_authorization_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIAuthorizationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_authorization_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIAuthorization), 0, (GInstanceInitFunc) vsgi_authorization_instance_init, NULL };
		GType vsgi_authorization_type_id;
		vsgi_authorization_type_id = g_type_register_static (G_TYPE_OBJECT, "VSGIAuthorization", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&vsgi_authorization_type_id__volatile, vsgi_authorization_type_id);
	}
	return vsgi_authorization_type_id__volatile;
}


static void _vala_vsgi_authorization_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIAuthorization * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_AUTHORIZATION, VSGIAuthorization);
	switch (property_id) {
		case VSGI_AUTHORIZATION_USERNAME:
		g_value_set_string (value, vsgi_authorization_get_username (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_authorization_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGIAuthorization * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_AUTHORIZATION, VSGIAuthorization);
	switch (property_id) {
		case VSGI_AUTHORIZATION_USERNAME:
		vsgi_authorization_set_username (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



