/* vsgi-basic-authorization.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-basic-authorization.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))

struct _VSGIBasicAuthorizationPrivate {
	gchar* _password;
};


static gpointer vsgi_basic_authorization_parent_class = NULL;

#define VSGI_BASIC_AUTHORIZATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_TYPE_BASIC_AUTHORIZATION, VSGIBasicAuthorizationPrivate))
enum  {
	VSGI_BASIC_AUTHORIZATION_DUMMY_PROPERTY,
	VSGI_BASIC_AUTHORIZATION_PASSWORD
};
static gboolean vsgi_basic_authorization_real_challenge_with_password (VSGIAuthorization* base, const gchar* password);
gboolean vsgi_str_const_equal (const gchar* a, const gchar* b);
static gchar* vsgi_basic_authorization_real_to_authorization_header (VSGIAuthorization* base);
static void vsgi_basic_authorization_finalize (GObject* obj);
static void _vala_vsgi_basic_authorization_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_basic_authorization_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


VSGIBasicAuthorization* vsgi_basic_authorization_construct (GType object_type, const gchar* username, const gchar* password) {
	VSGIBasicAuthorization * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (username != NULL, NULL);
	g_return_val_if_fail (password != NULL, NULL);
	_tmp0_ = username;
	_tmp1_ = password;
	self = (VSGIBasicAuthorization*) g_object_new (object_type, "username", _tmp0_, "password", _tmp1_, NULL);
	return self;
}


VSGIBasicAuthorization* vsgi_basic_authorization_new (const gchar* username, const gchar* password) {
	return vsgi_basic_authorization_construct (VSGI_TYPE_BASIC_AUTHORIZATION, username, password);
}


static gboolean vsgi_basic_authorization_real_challenge_with_password (VSGIAuthorization* base, const gchar* password) {
	VSGIBasicAuthorization * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	self = (VSGIBasicAuthorization*) base;
	g_return_val_if_fail (password != NULL, FALSE);
	_tmp0_ = password;
	_tmp1_ = self->priv->_password;
	_tmp2_ = vsgi_str_const_equal (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static gchar* string_to_utf8 (const gchar* self, int* result_length1) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gint _result__length1 = 0;
	gint __result__size_ = 0;
	gint _tmp3_ = 0;
	gchar* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gchar* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_new0 (gchar, _tmp1_ + 1);
	_result_ = _tmp2_;
	_result__length1 = _tmp1_ + 1;
	__result__size_ = _result__length1;
	_tmp3_ = _result__length1;
	_result__length1 = _tmp3_ - 1;
	_tmp4_ = _result_;
	_tmp4__length1 = _result__length1;
	_tmp5_ = strlen (self);
	_tmp6_ = _tmp5_;
	memcpy (_tmp4_, self, (gsize) _tmp6_);
	_tmp7_ = _result_;
	_tmp7__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}


static gchar* vsgi_basic_authorization_real_to_authorization_header (VSGIAuthorization* base) {
	VSGIBasicAuthorization * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gchar* _tmp6_ = NULL;
	guchar* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	self = (VSGIBasicAuthorization*) base;
	_tmp0_ = vsgi_authorization_get_username ((VSGIAuthorization*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_password;
	_tmp3_ = g_strdup_printf ("%s:%s", _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp6_ = string_to_utf8 (_tmp4_, &_tmp5_);
	_tmp7_ = (guchar*) _tmp6_;
	_tmp7__length1 = (_tmp5_ * sizeof (gchar)) / sizeof (guchar);
	_tmp8_ = g_base64_encode (_tmp7_, (_tmp5_ * sizeof (gchar)) / sizeof (guchar));
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strdup_printf ("Basic %s", _tmp9_);
	_tmp11_ = _tmp10_;
	_g_free0 (_tmp9_);
	_tmp7_ = (g_free (_tmp7_), NULL);
	_g_free0 (_tmp4_);
	result = _tmp11_;
	return result;
}


const gchar* vsgi_basic_authorization_get_password (VSGIBasicAuthorization* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_password;
	result = _tmp0_;
	return result;
}


static void vsgi_basic_authorization_set_password (VSGIBasicAuthorization* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_password);
	self->priv->_password = _tmp1_;
	g_object_notify ((GObject *) self, "password");
}


static void vsgi_basic_authorization_class_init (VSGIBasicAuthorizationClass * klass) {
	vsgi_basic_authorization_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGIBasicAuthorizationPrivate));
	((VSGIAuthorizationClass *) klass)->challenge_with_password = vsgi_basic_authorization_real_challenge_with_password;
	((VSGIAuthorizationClass *) klass)->to_authorization_header = vsgi_basic_authorization_real_to_authorization_header;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_basic_authorization_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_basic_authorization_set_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_basic_authorization_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_BASIC_AUTHORIZATION_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void vsgi_basic_authorization_instance_init (VSGIBasicAuthorization * self) {
	self->priv = VSGI_BASIC_AUTHORIZATION_GET_PRIVATE (self);
}


static void vsgi_basic_authorization_finalize (GObject* obj) {
	VSGIBasicAuthorization * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_BASIC_AUTHORIZATION, VSGIBasicAuthorization);
	_g_free0 (self->priv->_password);
	G_OBJECT_CLASS (vsgi_basic_authorization_parent_class)->finalize (obj);
}


/**
 * Hold the state of a basic 'Authorization' header.
 */
GType vsgi_basic_authorization_get_type (void) {
	static volatile gsize vsgi_basic_authorization_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_basic_authorization_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIBasicAuthorizationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_basic_authorization_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIBasicAuthorization), 0, (GInstanceInitFunc) vsgi_basic_authorization_instance_init, NULL };
		GType vsgi_basic_authorization_type_id;
		vsgi_basic_authorization_type_id = g_type_register_static (VSGI_TYPE_AUTHORIZATION, "VSGIBasicAuthorization", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_basic_authorization_type_id__volatile, vsgi_basic_authorization_type_id);
	}
	return vsgi_basic_authorization_type_id__volatile;
}


static void _vala_vsgi_basic_authorization_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIBasicAuthorization * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_BASIC_AUTHORIZATION, VSGIBasicAuthorization);
	switch (property_id) {
		case VSGI_BASIC_AUTHORIZATION_PASSWORD:
		g_value_set_string (value, vsgi_basic_authorization_get_password (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_basic_authorization_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGIBasicAuthorization * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_BASIC_AUTHORIZATION, VSGIBasicAuthorization);
	switch (property_id) {
		case VSGI_BASIC_AUTHORIZATION_PASSWORD:
		vsgi_basic_authorization_set_password (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



