/* vsgi-bounded-input-stream.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-bounded-input-stream.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <gio/gio.h>


struct _VSGIBoundedInputStreamPrivate {
	gint64 bytes_read;
	gint64 _content_length;
};


static gpointer vsgi_bounded_input_stream_parent_class = NULL;

#define VSGI_BOUNDED_INPUT_STREAM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_TYPE_BOUNDED_INPUT_STREAM, VSGIBoundedInputStreamPrivate))
enum  {
	VSGI_BOUNDED_INPUT_STREAM_DUMMY_PROPERTY,
	VSGI_BOUNDED_INPUT_STREAM_CONTENT_LENGTH
};
static gssize vsgi_bounded_input_stream_real_read (GInputStream* base, guint8* buffer, int buffer_length1, GCancellable* cancellable, GError** error);
static gboolean vsgi_bounded_input_stream_real_close (GInputStream* base, GCancellable* cancellable, GError** error);
static void vsgi_bounded_input_stream_finalize (GObject* obj);
static void _vala_vsgi_bounded_input_stream_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_bounded_input_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * {@inheritDoc}
 *
 * @param content_length number of bytes that can be read from the base
 *                       stream
 */
VSGIBoundedInputStream* vsgi_bounded_input_stream_construct (GType object_type, GInputStream* base_stream, gint64 content_length) {
	VSGIBoundedInputStream * self = NULL;
	GInputStream* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	g_return_val_if_fail (base_stream != NULL, NULL);
	_tmp0_ = base_stream;
	_tmp1_ = content_length;
	self = (VSGIBoundedInputStream*) g_object_new (object_type, "base-stream", _tmp0_, "content-length", _tmp1_, NULL);
	return self;
}


VSGIBoundedInputStream* vsgi_bounded_input_stream_new (GInputStream* base_stream, gint64 content_length) {
	return vsgi_bounded_input_stream_construct (VSGI_TYPE_BOUNDED_INPUT_STREAM, base_stream, content_length);
}


/**
 * {@inheritDoc}
 *
 * Ensures that the read buffer is smaller than the remaining bytes to
 * read from the base stream. If no more data is available, it produces
 * an artificial EOF.
 */
static gssize vsgi_bounded_input_stream_real_read (GInputStream* base, guint8* buffer, int buffer_length1, GCancellable* cancellable, GError** error) {
	VSGIBoundedInputStream * self;
	gssize result = 0L;
	gint64 _tmp0_ = 0LL;
	gint64 _tmp1_ = 0LL;
	guint8* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint64 _tmp3_ = 0LL;
	gint64 _tmp4_ = 0LL;
	gssize ret = 0L;
	GInputStream* _tmp8_ = NULL;
	GInputStream* _tmp9_ = NULL;
	guint8* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	GCancellable* _tmp11_ = NULL;
	gssize _tmp12_ = 0L;
	gssize _tmp13_ = 0L;
	GError * _inner_error_ = NULL;
	self = (VSGIBoundedInputStream*) base;
	_tmp0_ = self->priv->bytes_read;
	_tmp1_ = self->priv->_content_length;
	if (_tmp0_ >= _tmp1_) {
		result = (gssize) 0;
		return result;
	}
	_tmp2_ = buffer;
	_tmp2__length1 = buffer_length1;
	_tmp3_ = self->priv->_content_length;
	_tmp4_ = self->priv->bytes_read;
	if (((gint64) _tmp2__length1) > (_tmp3_ - _tmp4_)) {
		gint64 _tmp5_ = 0LL;
		gint64 _tmp6_ = 0LL;
		gint _tmp7_ = 0;
		_tmp5_ = self->priv->_content_length;
		_tmp6_ = self->priv->bytes_read;
		buffer_length1 = (gint) (_tmp5_ - _tmp6_);
		_tmp7_ = buffer_length1;
	}
	_tmp8_ = g_filter_input_stream_get_base_stream ((GFilterInputStream*) self);
	_tmp9_ = _tmp8_;
	_tmp10_ = buffer;
	_tmp10__length1 = buffer_length1;
	_tmp11_ = cancellable;
	_tmp12_ = g_input_stream_read (_tmp9_, _tmp10_, (gsize) _tmp10__length1, _tmp11_, &_inner_error_);
	ret = _tmp12_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return 0L;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0L;
		}
	}
	_tmp13_ = ret;
	if (_tmp13_ > ((gssize) 0)) {
		gint64 _tmp14_ = 0LL;
		gssize _tmp15_ = 0L;
		_tmp14_ = self->priv->bytes_read;
		_tmp15_ = ret;
		self->priv->bytes_read = _tmp14_ + _tmp15_;
	}
	result = ret;
	return result;
}


/**
 * {@inheritDoc}
 */
static gboolean vsgi_bounded_input_stream_real_close (GInputStream* base, GCancellable* cancellable, GError** error) {
	VSGIBoundedInputStream * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GInputStream* _tmp1_ = NULL;
	GInputStream* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (VSGIBoundedInputStream*) base;
	_tmp1_ = g_filter_input_stream_get_base_stream ((GFilterInputStream*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = cancellable;
	_tmp4_ = g_input_stream_close (_tmp2_, _tmp3_, &_inner_error_);
	_tmp0_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = _tmp0_;
	return result;
}


gint64 vsgi_bounded_input_stream_get_content_length (VSGIBoundedInputStream* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_content_length;
	result = _tmp0_;
	return result;
}


static void vsgi_bounded_input_stream_set_content_length (VSGIBoundedInputStream* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_content_length = _tmp0_;
	g_object_notify ((GObject *) self, "content-length");
}


static void vsgi_bounded_input_stream_class_init (VSGIBoundedInputStreamClass * klass) {
	vsgi_bounded_input_stream_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGIBoundedInputStreamPrivate));
	((GInputStreamClass *) klass)->read_fn = vsgi_bounded_input_stream_real_read;
	((GInputStreamClass *) klass)->close_fn = vsgi_bounded_input_stream_real_close;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_bounded_input_stream_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_bounded_input_stream_set_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_bounded_input_stream_finalize;
	/**
	 * The {@link int64} type is used to remain consistent with
	 * {@link Soup.MessageHeaders.get_content_length}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_BOUNDED_INPUT_STREAM_CONTENT_LENGTH, g_param_spec_int64 ("content-length", "content-length", "content-length", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void vsgi_bounded_input_stream_instance_init (VSGIBoundedInputStream * self) {
	self->priv = VSGI_BOUNDED_INPUT_STREAM_GET_PRIVATE (self);
	self->priv->bytes_read = (gint64) 0;
}


static void vsgi_bounded_input_stream_finalize (GObject* obj) {
	VSGIBoundedInputStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_BOUNDED_INPUT_STREAM, VSGIBoundedInputStream);
	G_OBJECT_CLASS (vsgi_bounded_input_stream_parent_class)->finalize (obj);
}


/**
 * Bounded input stream that provide a end-of-file behaviour when a a certain
 * number of bytes has been read from the base stream.
 */
GType vsgi_bounded_input_stream_get_type (void) {
	static volatile gsize vsgi_bounded_input_stream_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_bounded_input_stream_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIBoundedInputStreamClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_bounded_input_stream_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIBoundedInputStream), 0, (GInstanceInitFunc) vsgi_bounded_input_stream_instance_init, NULL };
		GType vsgi_bounded_input_stream_type_id;
		vsgi_bounded_input_stream_type_id = g_type_register_static (g_filter_input_stream_get_type (), "VSGIBoundedInputStream", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_bounded_input_stream_type_id__volatile, vsgi_bounded_input_stream_type_id);
	}
	return vsgi_bounded_input_stream_type_id__volatile;
}


static void _vala_vsgi_bounded_input_stream_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIBoundedInputStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_BOUNDED_INPUT_STREAM, VSGIBoundedInputStream);
	switch (property_id) {
		case VSGI_BOUNDED_INPUT_STREAM_CONTENT_LENGTH:
		g_value_set_int64 (value, vsgi_bounded_input_stream_get_content_length (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_bounded_input_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGIBoundedInputStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_BOUNDED_INPUT_STREAM, VSGIBoundedInputStream);
	switch (property_id) {
		case VSGI_BOUNDED_INPUT_STREAM_CONTENT_LENGTH:
		vsgi_bounded_input_stream_set_content_length (self, g_value_get_int64 (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



