/* vsgi-cgi.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-cgi.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>
#include <gio/gio.h>

#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupMessageHeaders_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupMessageHeaders_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _VSGICGIRequestPrivate {
	gchar** _environment;
	gint _environment_length1;
	gint __environment_size_;
	SoupURI* _uri;
	GHashTable* _query;
};

struct _Block1Data {
	int _ref_count_;
	VSGICGIResponse* self;
	GString* head;
};


static gpointer vsgi_cgi_request_parent_class = NULL;
static gpointer vsgi_cgi_response_parent_class = NULL;

#define VSGI_CGI_REQUEST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_CGI_TYPE_REQUEST, VSGICGIRequestPrivate))
enum  {
	VSGI_CGI_REQUEST_DUMMY_PROPERTY,
	VSGI_CGI_REQUEST_ENVIRONMENT,
	VSGI_CGI_REQUEST_HTTP_VERSION,
	VSGI_CGI_REQUEST_GATEWAY_INTERFACE,
	VSGI_CGI_REQUEST_METHOD,
	VSGI_CGI_REQUEST_URI,
	VSGI_CGI_REQUEST_QUERY
};
static void _vala_SoupURI_free (SoupURI* self);
static gchar** _vala_array_dup1 (gchar** self, int length);
static GObject * vsgi_cgi_request_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _vala_SoupMessageHeaders_free (SoupMessageHeaders* self);
static void vsgi_cgi_request_finalize (GObject* obj);
static void _vala_vsgi_cgi_request_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_cgi_request_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
enum  {
	VSGI_CGI_RESPONSE_DUMMY_PROPERTY,
	VSGI_CGI_RESPONSE_BODY
};
static gboolean vsgi_cgi_response_real_write_status_line (VSGIResponse* base, SoupHTTPVersion http_version, guint status, const gchar* reason_phrase, gsize* bytes_written, GCancellable* cancellable, GError** error);
static gboolean vsgi_cgi_response_real_write_headers (VSGIResponse* base, SoupMessageHeaders* headers, gsize* bytes_written, GCancellable* cancellable, GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda9_ (Block1Data* _data1_, const gchar* name, const gchar* header);
static void ___lambda9__soup_message_headers_foreach_func (const gchar* name, const gchar* value, gpointer self);
static GObject * vsgi_cgi_response_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _vala_vsgi_cgi_response_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _vala_SoupURI_free (SoupURI* self) {
	g_boxed_free (soup_uri_get_type (), self);
}


/**
 * Create a request from the provided environment variables.
 *
 * Although not part of CGI/1.1 specification, the 'REQUEST_URI' and
 * 'HTTPS' environment variables are reckognized.
 *
 * {@inheritDoc}
 *
 * @param environment environment variables
 */
VSGICGIRequest* vsgi_cgi_request_construct (GType object_type, VSGIConnection* connection, gchar** environment, int environment_length1) {
	VSGICGIRequest * self = NULL;
	VSGIConnection* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	g_return_val_if_fail (connection != NULL, NULL);
	_tmp0_ = connection;
	_tmp1_ = environment;
	_tmp1__length1 = environment_length1;
	self = (VSGICGIRequest*) g_object_new (object_type, "connection", _tmp0_, "environment", _tmp1_, NULL);
	return self;
}


VSGICGIRequest* vsgi_cgi_request_new (VSGIConnection* connection, gchar** environment, int environment_length1) {
	return vsgi_cgi_request_construct (VSGI_CGI_TYPE_REQUEST, connection, environment, environment_length1);
}


gchar** vsgi_cgi_request_get_environment (VSGICGIRequest* self, int* result_length1) {
	gchar** result;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_environment;
	_tmp0__length1 = self->priv->_environment_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static void vsgi_cgi_request_set_environment (VSGICGIRequest* self, gchar** value, int value_length1) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__length1 = value_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	self->priv->_environment = (_vala_array_free (self->priv->_environment, self->priv->_environment_length1, (GDestroyNotify) g_free), NULL);
	self->priv->_environment = _tmp1_;
	self->priv->_environment_length1 = _tmp1__length1;
	self->priv->__environment_size_ = self->priv->_environment_length1;
	g_object_notify ((GObject *) self, "environment");
}


static SoupHTTPVersion vsgi_cgi_request_real_get_http_version (VSGIRequest* base) {
	SoupHTTPVersion result;
	VSGICGIRequest* self;
	SoupHTTPVersion _tmp0_ = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const gchar* _tmp3_ = NULL;
	self = (VSGICGIRequest*) base;
	_tmp1_ = vsgi_cgi_request_get_environment (self, &_tmp1__length1);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	_tmp3_ = g_environ_getenv (_tmp2_, "SERVER_PROTOCOL");
	if (g_strcmp0 (_tmp3_, "HTTP/1.1") == 0) {
		_tmp0_ = SOUP_HTTP_1_1;
	} else {
		_tmp0_ = SOUP_HTTP_1_0;
	}
	result = _tmp0_;
	return result;
}


static gchar* vsgi_cgi_request_real_get_gateway_interface (VSGIRequest* base) {
	gchar* result;
	VSGICGIRequest* self;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	self = (VSGICGIRequest*) base;
	_tmp1_ = vsgi_cgi_request_get_environment (self, &_tmp1__length1);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	_tmp3_ = g_environ_getenv (_tmp2_, "GATEWAY_INTERFACE");
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "CGI/1.1";
	}
	_tmp4_ = g_strdup (_tmp0_);
	result = _tmp4_;
	return result;
}


static gchar* vsgi_cgi_request_real_get_method (VSGIRequest* base) {
	gchar* result;
	VSGICGIRequest* self;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	self = (VSGICGIRequest*) base;
	_tmp1_ = vsgi_cgi_request_get_environment (self, &_tmp1__length1);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	_tmp3_ = g_environ_getenv (_tmp2_, "REQUEST_METHOD");
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "GET";
	}
	_tmp4_ = g_strdup (_tmp0_);
	result = _tmp4_;
	return result;
}


static SoupURI* vsgi_cgi_request_real_get_uri (VSGIRequest* base) {
	SoupURI* result;
	VSGICGIRequest* self;
	SoupURI* _tmp0_ = NULL;
	self = (VSGICGIRequest*) base;
	_tmp0_ = self->priv->_uri;
	result = _tmp0_;
	return result;
}


static GHashTable* vsgi_cgi_request_real_get_query (VSGIRequest* base) {
	GHashTable* result;
	VSGICGIRequest* self;
	GHashTable* _tmp0_ = NULL;
	self = (VSGICGIRequest*) base;
	_tmp0_ = self->priv->_query;
	result = _tmp0_;
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static void _vala_SoupMessageHeaders_free (SoupMessageHeaders* self) {
	g_boxed_free (soup_message_headers_get_type (), self);
}


static gboolean int64_try_parse (const gchar* str, gint64* _result_) {
	gint64 _vala_result = 0LL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint64 _tmp2_ = 0LL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp0_ = str;
	_tmp2_ = g_ascii_strtoll (_tmp0_, &_tmp1_, (guint) 0);
	endptr = _tmp1_;
	_vala_result = _tmp2_;
	_tmp3_ = endptr;
	_tmp4_ = str;
	_tmp5_ = str;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp3_ == (((gchar*) _tmp4_) + _tmp7_)) {
		result = TRUE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	} else {
		result = FALSE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	}
	if (_result_) {
		*_result_ = _vala_result;
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static GObject * vsgi_cgi_request_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	VSGICGIRequest * self;
	gchar* https = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* path_translated = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_ = NULL;
	SoupURI* _tmp20_ = NULL;
	gchar** _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	gchar** _tmp22_ = NULL;
	gint _tmp22__length1 = 0;
	const gchar* _tmp23_ = NULL;
	SoupURI* _tmp24_ = NULL;
	gchar** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	gchar** _tmp26_ = NULL;
	gint _tmp26__length1 = 0;
	const gchar* _tmp27_ = NULL;
	gchar* port = NULL;
	gchar** _tmp28_ = NULL;
	gint _tmp28__length1 = 0;
	gchar** _tmp29_ = NULL;
	gint _tmp29__length1 = 0;
	const gchar* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	const gchar* _tmp32_ = NULL;
	gchar* path_info = NULL;
	gchar** _tmp36_ = NULL;
	gint _tmp36__length1 = 0;
	gchar** _tmp37_ = NULL;
	gint _tmp37__length1 = 0;
	const gchar* _tmp38_ = NULL;
	gchar* _tmp39_ = NULL;
	gchar* request_uri = NULL;
	gchar** _tmp40_ = NULL;
	gint _tmp40__length1 = 0;
	gchar** _tmp41_ = NULL;
	gint _tmp41__length1 = 0;
	const gchar* _tmp42_ = NULL;
	gchar* _tmp43_ = NULL;
	gboolean _tmp44_ = FALSE;
	const gchar* _tmp45_ = NULL;
	gchar* query_string = NULL;
	gchar** _tmp67_ = NULL;
	gint _tmp67__length1 = 0;
	gchar** _tmp68_ = NULL;
	gint _tmp68__length1 = 0;
	const gchar* _tmp69_ = NULL;
	gchar* _tmp70_ = NULL;
	gboolean _tmp71_ = FALSE;
	const gchar* _tmp72_ = NULL;
	SoupMessageHeaders* _tmp112_ = NULL;
	SoupMessageHeaders* _tmp113_ = NULL;
	const gchar* _tmp114_ = NULL;
	gchar** _tmp115_ = NULL;
	gint _tmp115__length1 = 0;
	gchar** _tmp116_ = NULL;
	gint _tmp116__length1 = 0;
	const gchar* _tmp117_ = NULL;
	gchar* content_type = NULL;
	gchar* _tmp118_ = NULL;
	GHashTable* params = NULL;
	const gchar* _tmp119_ = NULL;
	GHashTable* _tmp120_ = NULL;
	SoupMessageHeaders* _tmp121_ = NULL;
	SoupMessageHeaders* _tmp122_ = NULL;
	const gchar* _tmp123_ = NULL;
	gchar** _tmp124_ = NULL;
	gchar** _tmp125_ = NULL;
	gchar** _tmp126_ = NULL;
	gint _tmp126__length1 = 0;
	const gchar* _tmp127_ = NULL;
	GHashTable* _tmp128_ = NULL;
	gint64 content_length = 0LL;
	const gchar* _tmp129_ = NULL;
	gchar** _tmp130_ = NULL;
	gint _tmp130__length1 = 0;
	gchar** _tmp131_ = NULL;
	gint _tmp131__length1 = 0;
	const gchar* _tmp132_ = NULL;
	gint64 _tmp133_ = 0LL;
	gboolean _tmp134_ = FALSE;
	gchar** _tmp138_ = NULL;
	gint _tmp138__length1 = 0;
	gchar** _tmp139_ = NULL;
	gint _tmp139__length1 = 0;
	parent_class = G_OBJECT_CLASS (vsgi_cgi_request_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_CGI_TYPE_REQUEST, VSGICGIRequest);
	_tmp0_ = vsgi_cgi_request_get_environment (self, &_tmp0__length1);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	_tmp2_ = g_environ_getenv (_tmp1_, "HTTPS");
	_tmp3_ = g_strdup (_tmp2_);
	https = _tmp3_;
	_tmp4_ = vsgi_cgi_request_get_environment (self, &_tmp4__length1);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	_tmp6_ = g_environ_getenv (_tmp5_, "PATH_TRANSLATED");
	_tmp7_ = g_strdup (_tmp6_);
	path_translated = _tmp7_;
	_tmp10_ = https;
	if (_tmp10_ != NULL) {
		const gchar* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		_tmp11_ = https;
		_tmp12_ = strlen (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp9_ = _tmp13_ > 0;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		_tmp8_ = TRUE;
	} else {
		gboolean _tmp14_ = FALSE;
		const gchar* _tmp15_ = NULL;
		_tmp15_ = path_translated;
		if (_tmp15_ != NULL) {
			const gchar* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
			_tmp16_ = path_translated;
			_tmp17_ = g_str_has_prefix (_tmp16_, "https://");
			_tmp14_ = _tmp17_;
		} else {
			_tmp14_ = FALSE;
		}
		_tmp8_ = _tmp14_;
	}
	if (_tmp8_) {
		SoupURI* _tmp18_ = NULL;
		_tmp18_ = self->priv->_uri;
		soup_uri_set_scheme (_tmp18_, "https");
	} else {
		SoupURI* _tmp19_ = NULL;
		_tmp19_ = self->priv->_uri;
		soup_uri_set_scheme (_tmp19_, "http");
	}
	_tmp20_ = self->priv->_uri;
	_tmp21_ = vsgi_cgi_request_get_environment (self, &_tmp21__length1);
	_tmp22_ = _tmp21_;
	_tmp22__length1 = _tmp21__length1;
	_tmp23_ = g_environ_getenv (_tmp22_, "REMOTE_USER");
	soup_uri_set_user (_tmp20_, _tmp23_);
	_tmp24_ = self->priv->_uri;
	_tmp25_ = vsgi_cgi_request_get_environment (self, &_tmp25__length1);
	_tmp26_ = _tmp25_;
	_tmp26__length1 = _tmp25__length1;
	_tmp27_ = g_environ_getenv (_tmp26_, "SERVER_NAME");
	soup_uri_set_host (_tmp24_, _tmp27_);
	_tmp28_ = vsgi_cgi_request_get_environment (self, &_tmp28__length1);
	_tmp29_ = _tmp28_;
	_tmp29__length1 = _tmp28__length1;
	_tmp30_ = g_environ_getenv (_tmp29_, "SERVER_PORT");
	_tmp31_ = g_strdup (_tmp30_);
	port = _tmp31_;
	_tmp32_ = port;
	if (_tmp32_ != NULL) {
		SoupURI* _tmp33_ = NULL;
		const gchar* _tmp34_ = NULL;
		gint _tmp35_ = 0;
		_tmp33_ = self->priv->_uri;
		_tmp34_ = port;
		_tmp35_ = atoi (_tmp34_);
		soup_uri_set_port (_tmp33_, (guint) _tmp35_);
	}
	_tmp36_ = vsgi_cgi_request_get_environment (self, &_tmp36__length1);
	_tmp37_ = _tmp36_;
	_tmp37__length1 = _tmp36__length1;
	_tmp38_ = g_environ_getenv (_tmp37_, "PATH_INFO");
	_tmp39_ = g_strdup (_tmp38_);
	path_info = _tmp39_;
	_tmp40_ = vsgi_cgi_request_get_environment (self, &_tmp40__length1);
	_tmp41_ = _tmp40_;
	_tmp41__length1 = _tmp40__length1;
	_tmp42_ = g_environ_getenv (_tmp41_, "REQUEST_URI");
	_tmp43_ = g_strdup (_tmp42_);
	request_uri = _tmp43_;
	_tmp45_ = path_info;
	if (_tmp45_ != NULL) {
		const gchar* _tmp46_ = NULL;
		gint _tmp47_ = 0;
		gint _tmp48_ = 0;
		_tmp46_ = path_info;
		_tmp47_ = strlen (_tmp46_);
		_tmp48_ = _tmp47_;
		_tmp44_ = _tmp48_ > 0;
	} else {
		_tmp44_ = FALSE;
	}
	if (_tmp44_) {
		SoupURI* _tmp49_ = NULL;
		const gchar* _tmp50_ = NULL;
		gchar* _tmp51_ = NULL;
		gchar* _tmp52_ = NULL;
		_tmp49_ = self->priv->_uri;
		_tmp50_ = path_info;
		_tmp51_ = soup_uri_decode (_tmp50_);
		_tmp52_ = _tmp51_;
		soup_uri_set_path (_tmp49_, _tmp52_);
		_g_free0 (_tmp52_);
	} else {
		gboolean _tmp53_ = FALSE;
		const gchar* _tmp54_ = NULL;
		_tmp54_ = request_uri;
		if (_tmp54_ != NULL) {
			const gchar* _tmp55_ = NULL;
			gint _tmp56_ = 0;
			gint _tmp57_ = 0;
			_tmp55_ = request_uri;
			_tmp56_ = strlen (_tmp55_);
			_tmp57_ = _tmp56_;
			_tmp53_ = _tmp57_ > 0;
		} else {
			_tmp53_ = FALSE;
		}
		if (_tmp53_) {
			SoupURI* _tmp58_ = NULL;
			const gchar* _tmp59_ = NULL;
			gchar** _tmp60_ = NULL;
			gchar** _tmp61_ = NULL;
			gchar** _tmp62_ = NULL;
			gint _tmp62__length1 = 0;
			const gchar* _tmp63_ = NULL;
			gchar* _tmp64_ = NULL;
			gchar* _tmp65_ = NULL;
			_tmp58_ = self->priv->_uri;
			_tmp59_ = request_uri;
			_tmp61_ = _tmp60_ = g_strsplit (_tmp59_, "?", 2);
			_tmp62_ = _tmp61_;
			_tmp62__length1 = _vala_array_length (_tmp60_);
			_tmp63_ = _tmp62_[0];
			_tmp64_ = soup_uri_decode (_tmp63_);
			_tmp65_ = _tmp64_;
			soup_uri_set_path (_tmp58_, _tmp65_);
			_g_free0 (_tmp65_);
			_tmp62_ = (_vala_array_free (_tmp62_, _tmp62__length1, (GDestroyNotify) g_free), NULL);
		} else {
			SoupURI* _tmp66_ = NULL;
			_tmp66_ = self->priv->_uri;
			soup_uri_set_path (_tmp66_, "/");
		}
	}
	_tmp67_ = vsgi_cgi_request_get_environment (self, &_tmp67__length1);
	_tmp68_ = _tmp67_;
	_tmp68__length1 = _tmp67__length1;
	_tmp69_ = g_environ_getenv (_tmp68_, "QUERY_STRING");
	_tmp70_ = g_strdup (_tmp69_);
	query_string = _tmp70_;
	_tmp72_ = query_string;
	if (_tmp72_ != NULL) {
		const gchar* _tmp73_ = NULL;
		gint _tmp74_ = 0;
		gint _tmp75_ = 0;
		_tmp73_ = query_string;
		_tmp74_ = strlen (_tmp73_);
		_tmp75_ = _tmp74_;
		_tmp71_ = _tmp75_ > 0;
	} else {
		_tmp71_ = FALSE;
	}
	if (_tmp71_) {
		SoupURI* _tmp76_ = NULL;
		const gchar* _tmp77_ = NULL;
		const gchar* _tmp78_ = NULL;
		GHashTable* _tmp79_ = NULL;
		_tmp76_ = self->priv->_uri;
		_tmp77_ = query_string;
		soup_uri_set_query (_tmp76_, _tmp77_);
		_tmp78_ = query_string;
		_tmp79_ = soup_form_decode (_tmp78_);
		_g_hash_table_unref0 (self->priv->_query);
		self->priv->_query = _tmp79_;
	} else {
		gboolean _tmp80_ = FALSE;
		const gchar* _tmp81_ = NULL;
		_tmp81_ = path_translated;
		if (_tmp81_ != NULL) {
			const gchar* _tmp82_ = NULL;
			gboolean _tmp83_ = FALSE;
			_tmp82_ = path_translated;
			_tmp83_ = string_contains (_tmp82_, "?");
			_tmp80_ = _tmp83_;
		} else {
			_tmp80_ = FALSE;
		}
		if (_tmp80_) {
			SoupURI* _tmp84_ = NULL;
			const gchar* _tmp85_ = NULL;
			gchar** _tmp86_ = NULL;
			gchar** _tmp87_ = NULL;
			gchar** _tmp88_ = NULL;
			gint _tmp88__length1 = 0;
			const gchar* _tmp89_ = NULL;
			const gchar* _tmp90_ = NULL;
			gchar** _tmp91_ = NULL;
			gchar** _tmp92_ = NULL;
			gchar** _tmp93_ = NULL;
			gint _tmp93__length1 = 0;
			const gchar* _tmp94_ = NULL;
			GHashTable* _tmp95_ = NULL;
			_tmp84_ = self->priv->_uri;
			_tmp85_ = path_translated;
			_tmp87_ = _tmp86_ = g_strsplit (_tmp85_, "?", 2);
			_tmp88_ = _tmp87_;
			_tmp88__length1 = _vala_array_length (_tmp86_);
			_tmp89_ = _tmp88_[1];
			soup_uri_set_query (_tmp84_, _tmp89_);
			_tmp88_ = (_vala_array_free (_tmp88_, _tmp88__length1, (GDestroyNotify) g_free), NULL);
			_tmp90_ = path_translated;
			_tmp92_ = _tmp91_ = g_strsplit (_tmp90_, "?", 2);
			_tmp93_ = _tmp92_;
			_tmp93__length1 = _vala_array_length (_tmp91_);
			_tmp94_ = _tmp93_[1];
			_tmp95_ = soup_form_decode (_tmp94_);
			_g_hash_table_unref0 (self->priv->_query);
			self->priv->_query = _tmp95_;
			_tmp93_ = (_vala_array_free (_tmp93_, _tmp93__length1, (GDestroyNotify) g_free), NULL);
		} else {
			gboolean _tmp96_ = FALSE;
			const gchar* _tmp97_ = NULL;
			_tmp97_ = request_uri;
			if (_tmp97_ != NULL) {
				const gchar* _tmp98_ = NULL;
				gboolean _tmp99_ = FALSE;
				_tmp98_ = request_uri;
				_tmp99_ = string_contains (_tmp98_, "?");
				_tmp96_ = _tmp99_;
			} else {
				_tmp96_ = FALSE;
			}
			if (_tmp96_) {
				SoupURI* _tmp100_ = NULL;
				const gchar* _tmp101_ = NULL;
				gchar** _tmp102_ = NULL;
				gchar** _tmp103_ = NULL;
				gchar** _tmp104_ = NULL;
				gint _tmp104__length1 = 0;
				const gchar* _tmp105_ = NULL;
				const gchar* _tmp106_ = NULL;
				gchar** _tmp107_ = NULL;
				gchar** _tmp108_ = NULL;
				gchar** _tmp109_ = NULL;
				gint _tmp109__length1 = 0;
				const gchar* _tmp110_ = NULL;
				GHashTable* _tmp111_ = NULL;
				_tmp100_ = self->priv->_uri;
				_tmp101_ = request_uri;
				_tmp103_ = _tmp102_ = g_strsplit (_tmp101_, "?", 2);
				_tmp104_ = _tmp103_;
				_tmp104__length1 = _vala_array_length (_tmp102_);
				_tmp105_ = _tmp104_[1];
				soup_uri_set_query (_tmp100_, _tmp105_);
				_tmp104_ = (_vala_array_free (_tmp104_, _tmp104__length1, (GDestroyNotify) g_free), NULL);
				_tmp106_ = request_uri;
				_tmp108_ = _tmp107_ = g_strsplit (_tmp106_, "?", 2);
				_tmp109_ = _tmp108_;
				_tmp109__length1 = _vala_array_length (_tmp107_);
				_tmp110_ = _tmp109_[1];
				_tmp111_ = soup_form_decode (_tmp110_);
				_g_hash_table_unref0 (self->priv->_query);
				self->priv->_query = _tmp111_;
				_tmp109_ = (_vala_array_free (_tmp109_, _tmp109__length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
	_tmp112_ = soup_message_headers_new (SOUP_MESSAGE_HEADERS_REQUEST);
	_tmp113_ = _tmp112_;
	vsgi_request_set_headers ((VSGIRequest*) self, _tmp113_);
	__vala_SoupMessageHeaders_free0 (_tmp113_);
	_tmp115_ = vsgi_cgi_request_get_environment (self, &_tmp115__length1);
	_tmp116_ = _tmp115_;
	_tmp116__length1 = _tmp115__length1;
	_tmp117_ = g_environ_getenv (_tmp116_, "CONTENT_TYPE");
	_tmp114_ = _tmp117_;
	if (_tmp114_ == NULL) {
		_tmp114_ = "application/octet-stream";
	}
	_tmp118_ = g_strdup (_tmp114_);
	content_type = _tmp118_;
	_tmp119_ = content_type;
	_tmp120_ = soup_header_parse_param_list (_tmp119_);
	params = _tmp120_;
	_tmp121_ = vsgi_request_get_headers ((VSGIRequest*) self);
	_tmp122_ = _tmp121_;
	_tmp123_ = content_type;
	_tmp125_ = _tmp124_ = g_strsplit (_tmp123_, ";", 2);
	_tmp126_ = _tmp125_;
	_tmp126__length1 = _vala_array_length (_tmp124_);
	_tmp127_ = _tmp126_[0];
	_tmp128_ = params;
	soup_message_headers_set_content_type (_tmp122_, _tmp127_, _tmp128_);
	_tmp126_ = (_vala_array_free (_tmp126_, _tmp126__length1, (GDestroyNotify) g_free), NULL);
	_tmp130_ = vsgi_cgi_request_get_environment (self, &_tmp130__length1);
	_tmp131_ = _tmp130_;
	_tmp131__length1 = _tmp130__length1;
	_tmp132_ = g_environ_getenv (_tmp131_, "CONTENT_LENGTH");
	_tmp129_ = _tmp132_;
	if (_tmp129_ == NULL) {
		_tmp129_ = "0";
	}
	_tmp134_ = int64_try_parse (_tmp129_, &_tmp133_);
	content_length = _tmp133_;
	if (_tmp134_) {
		SoupMessageHeaders* _tmp135_ = NULL;
		SoupMessageHeaders* _tmp136_ = NULL;
		gint64 _tmp137_ = 0LL;
		_tmp135_ = vsgi_request_get_headers ((VSGIRequest*) self);
		_tmp136_ = _tmp135_;
		_tmp137_ = content_length;
		soup_message_headers_set_content_length (_tmp136_, _tmp137_);
	}
	_tmp138_ = vsgi_cgi_request_get_environment (self, &_tmp138__length1);
	_tmp139_ = _tmp138_;
	_tmp139__length1 = _tmp138__length1;
	{
		gchar** variable_collection = NULL;
		gint variable_collection_length1 = 0;
		gint _variable_collection_size_ = 0;
		gint variable_it = 0;
		variable_collection = _tmp139_;
		variable_collection_length1 = _tmp139__length1;
		for (variable_it = 0; variable_it < _tmp139__length1; variable_it = variable_it + 1) {
			gchar* _tmp140_ = NULL;
			gchar* variable = NULL;
			_tmp140_ = g_strdup (variable_collection[variable_it]);
			variable = _tmp140_;
			{
				gchar** parts = NULL;
				const gchar* _tmp141_ = NULL;
				gchar** _tmp142_ = NULL;
				gchar** _tmp143_ = NULL;
				gint parts_length1 = 0;
				gint _parts_size_ = 0;
				gchar** _tmp144_ = NULL;
				gint _tmp144__length1 = 0;
				const gchar* _tmp145_ = NULL;
				gboolean _tmp146_ = FALSE;
				_tmp141_ = variable;
				_tmp143_ = _tmp142_ = g_strsplit (_tmp141_, "=", 2);
				parts = _tmp143_;
				parts_length1 = _vala_array_length (_tmp142_);
				_parts_size_ = parts_length1;
				_tmp144_ = parts;
				_tmp144__length1 = parts_length1;
				_tmp145_ = _tmp144_[0];
				_tmp146_ = g_str_has_prefix (_tmp145_, "HTTP_");
				if (_tmp146_) {
					SoupMessageHeaders* _tmp147_ = NULL;
					SoupMessageHeaders* _tmp148_ = NULL;
					gchar** _tmp149_ = NULL;
					gint _tmp149__length1 = 0;
					const gchar* _tmp150_ = NULL;
					gchar* _tmp151_ = NULL;
					gchar* _tmp152_ = NULL;
					gchar* _tmp153_ = NULL;
					gchar* _tmp154_ = NULL;
					gchar* _tmp155_ = NULL;
					gchar* _tmp156_ = NULL;
					gchar** _tmp157_ = NULL;
					gint _tmp157__length1 = 0;
					const gchar* _tmp158_ = NULL;
					_tmp147_ = vsgi_request_get_headers ((VSGIRequest*) self);
					_tmp148_ = _tmp147_;
					_tmp149_ = parts;
					_tmp149__length1 = parts_length1;
					_tmp150_ = _tmp149_[0];
					_tmp151_ = string_substring (_tmp150_, (glong) 5, (glong) (-1));
					_tmp152_ = _tmp151_;
					_tmp153_ = string_replace (_tmp152_, "_", "-");
					_tmp154_ = _tmp153_;
					_tmp155_ = g_utf8_casefold (_tmp154_, (gssize) (-1));
					_tmp156_ = _tmp155_;
					_tmp157_ = parts;
					_tmp157__length1 = parts_length1;
					_tmp158_ = _tmp157_[1];
					soup_message_headers_append (_tmp148_, _tmp156_, _tmp158_);
					_g_free0 (_tmp156_);
					_g_free0 (_tmp154_);
					_g_free0 (_tmp152_);
				}
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (variable);
			}
		}
	}
	_g_hash_table_unref0 (params);
	_g_free0 (content_type);
	_g_free0 (query_string);
	_g_free0 (request_uri);
	_g_free0 (path_info);
	_g_free0 (port);
	_g_free0 (path_translated);
	_g_free0 (https);
	return obj;
}


static void vsgi_cgi_request_class_init (VSGICGIRequestClass * klass) {
	vsgi_cgi_request_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGICGIRequestPrivate));
	VSGI_REQUEST_CLASS (klass)->get_http_version = vsgi_cgi_request_real_get_http_version;
	VSGI_REQUEST_CLASS (klass)->get_gateway_interface = vsgi_cgi_request_real_get_gateway_interface;
	VSGI_REQUEST_CLASS (klass)->get_method = vsgi_cgi_request_real_get_method;
	VSGI_REQUEST_CLASS (klass)->get_uri = vsgi_cgi_request_real_get_uri;
	VSGI_REQUEST_CLASS (klass)->get_query = vsgi_cgi_request_real_get_query;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_cgi_request_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_cgi_request_set_property;
	G_OBJECT_CLASS (klass)->constructor = vsgi_cgi_request_constructor;
	G_OBJECT_CLASS (klass)->finalize = vsgi_cgi_request_finalize;
	/**
	 * CGI environment variables encoded in 'NAME=VALUE'.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_REQUEST_ENVIRONMENT, g_param_spec_boxed ("environment", "environment", "environment", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_REQUEST_HTTP_VERSION, g_param_spec_enum ("http-version", "http-version", "http-version", soup_http_version_get_type (), 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_REQUEST_GATEWAY_INTERFACE, g_param_spec_string ("gateway-interface", "gateway-interface", "gateway-interface", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_REQUEST_METHOD, g_param_spec_string ("method", "method", "method", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_REQUEST_URI, g_param_spec_boxed ("uri", "uri", "uri", soup_uri_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_REQUEST_QUERY, g_param_spec_boxed ("query", "query", "query", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_cgi_request_instance_init (VSGICGIRequest * self) {
	SoupURI* _tmp0_ = NULL;
	self->priv = VSGI_CGI_REQUEST_GET_PRIVATE (self);
	_tmp0_ = soup_uri_new (NULL);
	self->priv->_uri = _tmp0_;
	self->priv->_query = NULL;
}


static void vsgi_cgi_request_finalize (GObject* obj) {
	VSGICGIRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_CGI_TYPE_REQUEST, VSGICGIRequest);
	self->priv->_environment = (_vala_array_free (self->priv->_environment, self->priv->_environment_length1, (GDestroyNotify) g_free), NULL);
	__vala_SoupURI_free0 (self->priv->_uri);
	_g_hash_table_unref0 (self->priv->_query);
	G_OBJECT_CLASS (vsgi_cgi_request_parent_class)->finalize (obj);
}


/**
 * CGI request providing consistent environment behaviours.
 */
GType vsgi_cgi_request_get_type (void) {
	static volatile gsize vsgi_cgi_request_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_cgi_request_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGICGIRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_cgi_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGICGIRequest), 0, (GInstanceInitFunc) vsgi_cgi_request_instance_init, NULL };
		GType vsgi_cgi_request_type_id;
		vsgi_cgi_request_type_id = g_type_register_static (VSGI_TYPE_REQUEST, "VSGICGIRequest", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_cgi_request_type_id__volatile, vsgi_cgi_request_type_id);
	}
	return vsgi_cgi_request_type_id__volatile;
}


static void _vala_vsgi_cgi_request_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGICGIRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_CGI_TYPE_REQUEST, VSGICGIRequest);
	switch (property_id) {
		case VSGI_CGI_REQUEST_ENVIRONMENT:
		{
			int length;
			g_value_set_boxed (value, vsgi_cgi_request_get_environment (self, &length));
		}
		break;
		case VSGI_CGI_REQUEST_HTTP_VERSION:
		g_value_set_enum (value, vsgi_request_get_http_version ((VSGIRequest*) self));
		break;
		case VSGI_CGI_REQUEST_GATEWAY_INTERFACE:
		g_value_take_string (value, vsgi_request_get_gateway_interface ((VSGIRequest*) self));
		break;
		case VSGI_CGI_REQUEST_METHOD:
		g_value_take_string (value, vsgi_request_get_method ((VSGIRequest*) self));
		break;
		case VSGI_CGI_REQUEST_URI:
		g_value_set_boxed (value, vsgi_request_get_uri ((VSGIRequest*) self));
		break;
		case VSGI_CGI_REQUEST_QUERY:
		g_value_set_boxed (value, vsgi_request_get_query ((VSGIRequest*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_cgi_request_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGICGIRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_CGI_TYPE_REQUEST, VSGICGIRequest);
	switch (property_id) {
		case VSGI_CGI_REQUEST_ENVIRONMENT:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			vsgi_cgi_request_set_environment (self, boxed, g_strv_length (boxed));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


VSGICGIResponse* vsgi_cgi_response_construct (GType object_type, VSGICGIRequest* request) {
	VSGICGIResponse * self = NULL;
	VSGICGIRequest* _tmp0_ = NULL;
	g_return_val_if_fail (request != NULL, NULL);
	_tmp0_ = request;
	self = (VSGICGIResponse*) g_object_new (object_type, "request", _tmp0_, NULL);
	return self;
}


VSGICGIResponse* vsgi_cgi_response_new (VSGICGIRequest* request) {
	return vsgi_cgi_response_construct (VSGI_CGI_TYPE_RESPONSE, request);
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static gboolean vsgi_cgi_response_real_write_status_line (VSGIResponse* base, SoupHTTPVersion http_version, guint status, const gchar* reason_phrase, gsize* bytes_written, GCancellable* cancellable, GError** error) {
	VSGICGIResponse * self;
	gsize _vala_bytes_written = 0UL;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	VSGIRequest* _tmp1_ = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIConnection* _tmp3_ = NULL;
	VSGIConnection* _tmp4_ = NULL;
	GOutputStream* _tmp5_ = NULL;
	GOutputStream* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	guint8* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	guint8* _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	GCancellable* _tmp13_ = NULL;
	gsize _tmp14_ = 0UL;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (VSGICGIResponse*) base;
	g_return_val_if_fail (reason_phrase != NULL, FALSE);
	_tmp1_ = vsgi_response_get_request ((VSGIResponse*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vsgi_request_get_connection (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_io_stream_get_output_stream ((GIOStream*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = status;
	_tmp8_ = reason_phrase;
	_tmp9_ = g_strdup_printf ("Status: %u %s\r\n", _tmp7_, _tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = string_get_data (_tmp10_, &_tmp11__length1);
	_tmp12_ = _tmp11_;
	_tmp12__length1 = _tmp11__length1;
	_tmp13_ = cancellable;
	_tmp15_ = g_output_stream_write_all (_tmp6_, _tmp12_, (gsize) _tmp12__length1, &_tmp14_, _tmp13_, &_inner_error_);
	_vala_bytes_written = _tmp14_;
	_tmp16_ = _tmp15_;
	_g_free0 (_tmp10_);
	_tmp0_ = _tmp16_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = _tmp0_;
	if (bytes_written) {
		*bytes_written = _vala_bytes_written;
	}
	return result;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		VSGICGIResponse* self;
		self = _data1_->self;
		_g_string_free0 (_data1_->head);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static void __lambda9_ (Block1Data* _data1_, const gchar* name, const gchar* header) {
	VSGICGIResponse* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	self = _data1_->self;
	g_return_if_fail (name != NULL);
	g_return_if_fail (header != NULL);
	_tmp0_ = name;
	_tmp1_ = header;
	g_string_append_printf (_data1_->head, "%s: %s\r\n", _tmp0_, _tmp1_);
}


static void ___lambda9__soup_message_headers_foreach_func (const gchar* name, const gchar* value, gpointer self) {
	__lambda9_ (self, name, value);
}


static gboolean vsgi_cgi_response_real_write_headers (VSGIResponse* base, SoupMessageHeaders* headers, gsize* bytes_written, GCancellable* cancellable, GError** error) {
	VSGICGIResponse * self;
	gsize _vala_bytes_written = 0UL;
	gboolean result = FALSE;
	Block1Data* _data1_;
	GString* _tmp0_ = NULL;
	SoupMessageHeaders* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	VSGIRequest* _tmp3_ = NULL;
	VSGIRequest* _tmp4_ = NULL;
	VSGIConnection* _tmp5_ = NULL;
	VSGIConnection* _tmp6_ = NULL;
	GOutputStream* _tmp7_ = NULL;
	GOutputStream* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	guint8* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	guint8* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	GCancellable* _tmp12_ = NULL;
	gsize _tmp13_ = 0UL;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (VSGICGIResponse*) base;
	g_return_val_if_fail (headers != NULL, FALSE);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = g_string_new ("");
	_data1_->head = _tmp0_;
	_tmp1_ = headers;
	soup_message_headers_foreach (_tmp1_, ___lambda9__soup_message_headers_foreach_func, _data1_);
	g_string_append (_data1_->head, "\r\n");
	_tmp3_ = vsgi_response_get_request ((VSGIResponse*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = vsgi_request_get_connection (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_io_stream_get_output_stream ((GIOStream*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _data1_->head->str;
	_tmp10_ = string_get_data (_tmp9_, &_tmp10__length1);
	_tmp11_ = _tmp10_;
	_tmp11__length1 = _tmp10__length1;
	_tmp12_ = cancellable;
	_tmp14_ = g_output_stream_write_all (_tmp8_, _tmp11_, (gsize) _tmp11__length1, &_tmp13_, _tmp12_, &_inner_error_);
	_vala_bytes_written = _tmp13_;
	_tmp2_ = _tmp14_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block1_data_unref (_data1_);
			_data1_ = NULL;
			return FALSE;
		} else {
			block1_data_unref (_data1_);
			_data1_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = _tmp2_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	if (bytes_written) {
		*bytes_written = _vala_bytes_written;
	}
	return result;
}


static GOutputStream* vsgi_cgi_response_real_get_body (VSGIResponse* base) {
	GOutputStream* result;
	VSGICGIResponse* self;
	GOutputStream* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
	self = (VSGICGIResponse*) base;
	{
		gsize bytes_written = 0UL;
		gsize _tmp0_ = 0UL;
		vsgi_response_write_head ((VSGIResponse*) self, &_tmp0_, NULL, &_inner_error_);
		bytes_written = _tmp0_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch6_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally6;
	__catch6_g_io_error:
	{
		GError* err = NULL;
		GError* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		GError* _tmp3_ = NULL;
		GQuark _tmp4_ = 0U;
		const gchar* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = err;
		_tmp2_ = _tmp1_->message;
		_tmp3_ = err;
		_tmp4_ = _tmp3_->domain;
		_tmp5_ = g_quark_to_string (_tmp4_);
		_tmp6_ = err;
		_tmp7_ = _tmp6_->code;
		g_critical ("vsgi-cgi.vala:174: Could not write the head in the connection stream: " \
"%s (%s, %d).", _tmp2_, _tmp5_, _tmp7_);
		_g_error_free0 (err);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp8_ = VSGI_RESPONSE_CLASS (vsgi_cgi_response_parent_class)->get_body (G_TYPE_CHECK_INSTANCE_CAST (self, VSGI_TYPE_RESPONSE, VSGIResponse));
	result = _tmp8_;
	return result;
}


static GObject * vsgi_cgi_response_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	VSGICGIResponse * self;
	SoupMessageHeaders* _tmp0_ = NULL;
	SoupMessageHeaders* _tmp1_ = NULL;
	parent_class = G_OBJECT_CLASS (vsgi_cgi_response_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_CGI_TYPE_RESPONSE, VSGICGIResponse);
	_tmp0_ = soup_message_headers_new (SOUP_MESSAGE_HEADERS_RESPONSE);
	_tmp1_ = _tmp0_;
	vsgi_response_set_headers ((VSGIResponse*) self, _tmp1_);
	__vala_SoupMessageHeaders_free0 (_tmp1_);
	return obj;
}


static void vsgi_cgi_response_class_init (VSGICGIResponseClass * klass) {
	vsgi_cgi_response_parent_class = g_type_class_peek_parent (klass);
	((VSGIResponseClass *) klass)->write_status_line = vsgi_cgi_response_real_write_status_line;
	((VSGIResponseClass *) klass)->write_headers = vsgi_cgi_response_real_write_headers;
	VSGI_RESPONSE_CLASS (klass)->get_body = vsgi_cgi_response_real_get_body;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_cgi_response_get_property;
	G_OBJECT_CLASS (klass)->constructor = vsgi_cgi_response_constructor;
	/**
	 * On the first attempt to access the response body stream, the status
	 * line and headers will be written synchronously in the response
	 * stream. 'write_head_async' have to be used explicitly to perform a
	 * non-blocking operation.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_CGI_RESPONSE_BODY, g_param_spec_object ("body", "body", "body", G_TYPE_OUTPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_cgi_response_instance_init (VSGICGIResponse * self) {
}


/**
 * CGI response producing expected headers format.
 */
GType vsgi_cgi_response_get_type (void) {
	static volatile gsize vsgi_cgi_response_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_cgi_response_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGICGIResponseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_cgi_response_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGICGIResponse), 0, (GInstanceInitFunc) vsgi_cgi_response_instance_init, NULL };
		GType vsgi_cgi_response_type_id;
		vsgi_cgi_response_type_id = g_type_register_static (VSGI_TYPE_RESPONSE, "VSGICGIResponse", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_cgi_response_type_id__volatile, vsgi_cgi_response_type_id);
	}
	return vsgi_cgi_response_type_id__volatile;
}


static void _vala_vsgi_cgi_response_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGICGIResponse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_CGI_TYPE_RESPONSE, VSGICGIResponse);
	switch (property_id) {
		case VSGI_CGI_RESPONSE_BODY:
		g_value_set_object (value, vsgi_response_get_body ((VSGIResponse*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



