/* vsgi-handler.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-handler.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"



static gpointer vsgi_handler_parent_class = NULL;

enum  {
	VSGI_HANDLER_DUMMY_PROPERTY
};
static gboolean vsgi_handler_real_handle (VSGIHandler* self, VSGIRequest* req, VSGIResponse* res, GError** error);


/**
 * Process a pair of {@link VSGI.Request} and {@link VSGI.Response}.
 *
 * It is passed to a {@link VSGI.Server} in order to receive request to
 * process.
 *
 * @throws Error unrecoverable error condition can be raised and will be
 *               handled by the implementation
 *
 * @param req a resource being requested
 * @param res the response to that request
 *
 * @return 'true' if the request has been or will eventually be handled,
 *         otherwise 'false'
 */
static gboolean vsgi_handler_real_handle (VSGIHandler* self, VSGIRequest* req, VSGIResponse* res, GError** error) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_handler_handle'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean vsgi_handler_handle (VSGIHandler* self, VSGIRequest* req, VSGIResponse* res, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return VSGI_HANDLER_GET_CLASS (self)->handle (self, req, res, error);
}


VSGIHandler* vsgi_handler_construct (GType object_type) {
	VSGIHandler * self = NULL;
	self = (VSGIHandler*) g_object_new (object_type, NULL);
	return self;
}


static void vsgi_handler_class_init (VSGIHandlerClass * klass) {
	vsgi_handler_parent_class = g_type_class_peek_parent (klass);
	((VSGIHandlerClass *) klass)->handle = vsgi_handler_real_handle;
}


static void vsgi_handler_instance_init (VSGIHandler * self) {
}


GType vsgi_handler_get_type (void) {
	static volatile gsize vsgi_handler_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_handler_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIHandler), 0, (GInstanceInitFunc) vsgi_handler_instance_init, NULL };
		GType vsgi_handler_type_id;
		vsgi_handler_type_id = g_type_register_static (G_TYPE_OBJECT, "VSGIHandler", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&vsgi_handler_type_id__volatile, vsgi_handler_type_id);
	}
	return vsgi_handler_type_id__volatile;
}



