/* vsgi-mock.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-mock.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define __vala_SoupMessageHeaders_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupMessageHeaders_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _VSGIMockConnectionPrivate {
	GMemoryInputStream* _memory_input_stream;
	GMemoryOutputStream* _memory_output_stream;
};

struct _VSGIMockRequestPrivate {
	SoupHTTPVersion _http_version;
	gchar* _method;
	SoupURI* _uri;
	GHashTable* _query;
};

struct _Block2Data {
	int _ref_count_;
	VSGIMockResponse* self;
	GString* head;
};


static gpointer vsgi_mock_connection_parent_class = NULL;
static gpointer vsgi_mock_request_parent_class = NULL;
static gpointer vsgi_mock_response_parent_class = NULL;
static gpointer vsgi_mock_server_parent_class = NULL;

#define VSGI_MOCK_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_MOCK_TYPE_CONNECTION, VSGIMockConnectionPrivate))
enum  {
	VSGI_MOCK_CONNECTION_DUMMY_PROPERTY,
	VSGI_MOCK_CONNECTION_INPUT_STREAM,
	VSGI_MOCK_CONNECTION_OUTPUT_STREAM
};
static void* _g_realloc_grealloc_func (void* data, gsize size);
static void _g_free_gdestroy_notify (void* data);
static void vsgi_mock_connection_finalize (GObject* obj);
static void _vala_vsgi_mock_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
#define VSGI_MOCK_REQUEST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_MOCK_TYPE_REQUEST, VSGIMockRequestPrivate))
enum  {
	VSGI_MOCK_REQUEST_DUMMY_PROPERTY,
	VSGI_MOCK_REQUEST_HTTP_VERSION,
	VSGI_MOCK_REQUEST_GATEWAY_INTERFACE,
	VSGI_MOCK_REQUEST_METHOD,
	VSGI_MOCK_REQUEST_URI,
	VSGI_MOCK_REQUEST_QUERY
};
static void _vala_SoupURI_free (SoupURI* self);
static void _vala_SoupMessageHeaders_free (SoupMessageHeaders* self);
static SoupURI* _vala_SoupURI_copy (SoupURI* self);
static void vsgi_mock_request_finalize (GObject* obj);
static void _vala_vsgi_mock_request_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
enum  {
	VSGI_MOCK_RESPONSE_DUMMY_PROPERTY
};
static gboolean vsgi_mock_response_real_write_status_line (VSGIResponse* base, SoupHTTPVersion http_version, guint status, const gchar* reason_phrase, gsize* bytes_written, GCancellable* cancellable, GError** error);
static gboolean vsgi_mock_response_real_write_headers (VSGIResponse* base, SoupMessageHeaders* headers, gsize* bytes_written, GCancellable* cancellable, GError** error);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda10_ (Block2Data* _data2_, const gchar* name, const gchar* header);
static void ___lambda10__soup_message_headers_foreach_func (const gchar* name, const gchar* value, gpointer self);
enum  {
	VSGI_MOCK_SERVER_DUMMY_PROPERTY,
	VSGI_MOCK_SERVER_URIS
};
static void vsgi_mock_server_real_listen (VSGIServer* base, GSocketAddress* address, GError** error);
static void vsgi_mock_server_real_listen_socket (VSGIServer* base, GSocket* socket, GError** error);
static void vsgi_mock_server_real_stop (VSGIServer* base);
static void _vala_vsgi_mock_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


static void* _g_realloc_grealloc_func (void* data, gsize size) {
	void* result;
	result = g_realloc (data, size);
	return result;
}


static void _g_free_gdestroy_notify (void* data) {
	g_free (data);
}


VSGIMockConnection* vsgi_mock_connection_construct (GType object_type, VSGIMockServer* server) {
	VSGIMockConnection * self = NULL;
	VSGIMockServer* _tmp0_ = NULL;
	g_return_val_if_fail (server != NULL, NULL);
	_tmp0_ = server;
	self = (VSGIMockConnection*) g_object_new (object_type, "server", _tmp0_, NULL);
	return self;
}


VSGIMockConnection* vsgi_mock_connection_new (VSGIMockServer* server) {
	return vsgi_mock_connection_construct (VSGI_MOCK_TYPE_CONNECTION, server);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GMemoryInputStream* vsgi_mock_connection_get_memory_input_stream (VSGIMockConnection* self) {
	GMemoryInputStream* result = NULL;
	GMemoryInputStream* _tmp0_ = NULL;
	GMemoryInputStream* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_memory_input_stream;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


GMemoryOutputStream* vsgi_mock_connection_get_memory_output_stream (VSGIMockConnection* self) {
	GMemoryOutputStream* result = NULL;
	GMemoryOutputStream* _tmp0_ = NULL;
	GMemoryOutputStream* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_memory_output_stream;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static GInputStream* vsgi_mock_connection_real_get_input_stream (GIOStream* base) {
	GInputStream* result;
	VSGIMockConnection* self;
	GMemoryInputStream* _tmp0_ = NULL;
	self = (VSGIMockConnection*) base;
	_tmp0_ = self->priv->_memory_input_stream;
	result = (GInputStream*) _tmp0_;
	return result;
}


static GOutputStream* vsgi_mock_connection_real_get_output_stream (GIOStream* base) {
	GOutputStream* result;
	VSGIMockConnection* self;
	GMemoryOutputStream* _tmp0_ = NULL;
	self = (VSGIMockConnection*) base;
	_tmp0_ = self->priv->_memory_output_stream;
	result = (GOutputStream*) _tmp0_;
	return result;
}


static void vsgi_mock_connection_class_init (VSGIMockConnectionClass * klass) {
	vsgi_mock_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGIMockConnectionPrivate));
	G_IO_STREAM_CLASS (klass)->get_input_stream = vsgi_mock_connection_real_get_input_stream;
	G_IO_STREAM_CLASS (klass)->get_output_stream = vsgi_mock_connection_real_get_output_stream;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_mock_connection_get_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_mock_connection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_CONNECTION_INPUT_STREAM, g_param_spec_object ("input-stream", "input-stream", "input-stream", G_TYPE_INPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_CONNECTION_OUTPUT_STREAM, g_param_spec_object ("output-stream", "output-stream", "output-stream", G_TYPE_OUTPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_mock_connection_instance_init (VSGIMockConnection * self) {
	GMemoryInputStream* _tmp0_ = NULL;
	GMemoryOutputStream* _tmp1_ = NULL;
	self->priv = VSGI_MOCK_CONNECTION_GET_PRIVATE (self);
	_tmp0_ = (GMemoryInputStream*) g_memory_input_stream_new ();
	self->priv->_memory_input_stream = _tmp0_;
	_tmp1_ = (GMemoryOutputStream*) g_memory_output_stream_new (NULL, 0, _g_realloc_grealloc_func, _g_free_gdestroy_notify);
	self->priv->_memory_output_stream = _tmp1_;
}


static void vsgi_mock_connection_finalize (GObject* obj) {
	VSGIMockConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_MOCK_TYPE_CONNECTION, VSGIMockConnection);
	_g_object_unref0 (self->priv->_memory_input_stream);
	_g_object_unref0 (self->priv->_memory_output_stream);
	G_OBJECT_CLASS (vsgi_mock_connection_parent_class)->finalize (obj);
}


/**
 * Stubbed connection with in-memory streams.
 *
 * The typical use case is to create a {@link VSGI.Mock.Request} with a
 * stubbed connection so that the produced and consumed messages can be
 * easily inspected.
 */
GType vsgi_mock_connection_get_type (void) {
	static volatile gsize vsgi_mock_connection_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_mock_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIMockConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_mock_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIMockConnection), 0, (GInstanceInitFunc) vsgi_mock_connection_instance_init, NULL };
		GType vsgi_mock_connection_type_id;
		vsgi_mock_connection_type_id = g_type_register_static (VSGI_TYPE_CONNECTION, "VSGIMockConnection", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_mock_connection_type_id__volatile, vsgi_mock_connection_type_id);
	}
	return vsgi_mock_connection_type_id__volatile;
}


static void _vala_vsgi_mock_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIMockConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_MOCK_TYPE_CONNECTION, VSGIMockConnection);
	switch (property_id) {
		case VSGI_MOCK_CONNECTION_INPUT_STREAM:
		g_value_set_object (value, g_io_stream_get_input_stream ((GIOStream*) self));
		break;
		case VSGI_MOCK_CONNECTION_OUTPUT_STREAM:
		g_value_set_object (value, g_io_stream_get_output_stream ((GIOStream*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_SoupURI_free (SoupURI* self) {
	g_boxed_free (soup_uri_get_type (), self);
}


static void _vala_SoupMessageHeaders_free (SoupMessageHeaders* self) {
	g_boxed_free (soup_message_headers_get_type (), self);
}


static SoupURI* _vala_SoupURI_copy (SoupURI* self) {
	return g_boxed_copy (soup_uri_get_type (), self);
}


static gpointer __vala_SoupURI_copy0 (gpointer self) {
	return self ? _vala_SoupURI_copy (self) : NULL;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


VSGIMockRequest* vsgi_mock_request_construct (GType object_type, VSGIMockConnection* connection, const gchar* method, SoupURI* uri, GHashTable* query) {
	VSGIMockRequest * self = NULL;
	VSGIMockConnection* _tmp0_ = NULL;
	SoupMessageHeaders* _tmp1_ = NULL;
	SoupMessageHeaders* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	SoupURI* _tmp5_ = NULL;
	SoupURI* _tmp6_ = NULL;
	GHashTable* _tmp7_ = NULL;
	GHashTable* _tmp8_ = NULL;
	g_return_val_if_fail (connection != NULL, NULL);
	g_return_val_if_fail (method != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = connection;
	_tmp1_ = soup_message_headers_new (SOUP_MESSAGE_HEADERS_REQUEST);
	_tmp2_ = _tmp1_;
	self = (VSGIMockRequest*) g_object_new (object_type, "connection", _tmp0_, "headers", _tmp2_, NULL);
	__vala_SoupMessageHeaders_free0 (_tmp2_);
	_tmp3_ = method;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (self->priv->_method);
	self->priv->_method = _tmp4_;
	_tmp5_ = uri;
	_tmp6_ = __vala_SoupURI_copy0 (_tmp5_);
	__vala_SoupURI_free0 (self->priv->_uri);
	self->priv->_uri = _tmp6_;
	_tmp7_ = query;
	_tmp8_ = _g_hash_table_ref0 (_tmp7_);
	_g_hash_table_unref0 (self->priv->_query);
	self->priv->_query = _tmp8_;
	return self;
}


VSGIMockRequest* vsgi_mock_request_new (VSGIMockConnection* connection, const gchar* method, SoupURI* uri, GHashTable* query) {
	return vsgi_mock_request_construct (VSGI_MOCK_TYPE_REQUEST, connection, method, uri, query);
}


VSGIMockRequest* vsgi_mock_request_construct_with_method (GType object_type, const gchar* method, SoupURI* uri, GHashTable* query) {
	VSGIMockRequest * self = NULL;
	VSGIMockServer* _tmp0_ = NULL;
	VSGIMockServer* _tmp1_ = NULL;
	VSGIMockConnection* _tmp2_ = NULL;
	VSGIMockConnection* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	SoupURI* _tmp5_ = NULL;
	GHashTable* _tmp6_ = NULL;
	g_return_val_if_fail (method != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = vsgi_mock_server_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = vsgi_mock_connection_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = method;
	_tmp5_ = uri;
	_tmp6_ = query;
	self = (VSGIMockRequest*) vsgi_mock_request_construct (object_type, _tmp3_, _tmp4_, _tmp5_, _tmp6_);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
	return self;
}


VSGIMockRequest* vsgi_mock_request_new_with_method (const gchar* method, SoupURI* uri, GHashTable* query) {
	return vsgi_mock_request_construct_with_method (VSGI_MOCK_TYPE_REQUEST, method, uri, query);
}


VSGIMockRequest* vsgi_mock_request_construct_with_uri (GType object_type, SoupURI* uri, GHashTable* query) {
	VSGIMockRequest * self = NULL;
	VSGIMockServer* _tmp0_ = NULL;
	VSGIMockServer* _tmp1_ = NULL;
	VSGIMockConnection* _tmp2_ = NULL;
	VSGIMockConnection* _tmp3_ = NULL;
	SoupURI* _tmp4_ = NULL;
	GHashTable* _tmp5_ = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = vsgi_mock_server_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = vsgi_mock_connection_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = uri;
	_tmp5_ = query;
	self = (VSGIMockRequest*) vsgi_mock_request_construct (object_type, _tmp3_, "GET", _tmp4_, _tmp5_);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
	return self;
}


VSGIMockRequest* vsgi_mock_request_new_with_uri (SoupURI* uri, GHashTable* query) {
	return vsgi_mock_request_construct_with_uri (VSGI_MOCK_TYPE_REQUEST, uri, query);
}


VSGIMockRequest* vsgi_mock_request_construct_with_query (GType object_type, GHashTable* query) {
	VSGIMockRequest * self = NULL;
	VSGIMockServer* _tmp0_ = NULL;
	VSGIMockServer* _tmp1_ = NULL;
	VSGIMockConnection* _tmp2_ = NULL;
	VSGIMockConnection* _tmp3_ = NULL;
	SoupURI* _tmp4_ = NULL;
	SoupURI* _tmp5_ = NULL;
	GHashTable* _tmp6_ = NULL;
	_tmp0_ = vsgi_mock_server_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = vsgi_mock_connection_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = soup_uri_new ("http://localhost/");
	_tmp5_ = _tmp4_;
	_tmp6_ = query;
	self = (VSGIMockRequest*) vsgi_mock_request_construct (object_type, _tmp3_, "GET", _tmp5_, _tmp6_);
	__vala_SoupURI_free0 (_tmp5_);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
	return self;
}


VSGIMockRequest* vsgi_mock_request_new_with_query (GHashTable* query) {
	return vsgi_mock_request_construct_with_query (VSGI_MOCK_TYPE_REQUEST, query);
}


static SoupHTTPVersion vsgi_mock_request_real_get_http_version (VSGIRequest* base) {
	SoupHTTPVersion result;
	VSGIMockRequest* self;
	SoupHTTPVersion _tmp0_ = 0;
	self = (VSGIMockRequest*) base;
	_tmp0_ = self->priv->_http_version;
	result = _tmp0_;
	return result;
}


static gchar* vsgi_mock_request_real_get_gateway_interface (VSGIRequest* base) {
	gchar* result;
	VSGIMockRequest* self;
	gchar* _tmp0_ = NULL;
	self = (VSGIMockRequest*) base;
	_tmp0_ = g_strdup ("Mock/0.3");
	result = _tmp0_;
	return result;
}


static gchar* vsgi_mock_request_real_get_method (VSGIRequest* base) {
	gchar* result;
	VSGIMockRequest* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (VSGIMockRequest*) base;
	_tmp0_ = self->priv->_method;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


static SoupURI* vsgi_mock_request_real_get_uri (VSGIRequest* base) {
	SoupURI* result;
	VSGIMockRequest* self;
	SoupURI* _tmp0_ = NULL;
	self = (VSGIMockRequest*) base;
	_tmp0_ = self->priv->_uri;
	result = _tmp0_;
	return result;
}


static GHashTable* vsgi_mock_request_real_get_query (VSGIRequest* base) {
	GHashTable* result;
	VSGIMockRequest* self;
	GHashTable* _tmp0_ = NULL;
	self = (VSGIMockRequest*) base;
	_tmp0_ = self->priv->_query;
	result = _tmp0_;
	return result;
}


static void vsgi_mock_request_class_init (VSGIMockRequestClass * klass) {
	vsgi_mock_request_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGIMockRequestPrivate));
	VSGI_REQUEST_CLASS (klass)->get_http_version = vsgi_mock_request_real_get_http_version;
	VSGI_REQUEST_CLASS (klass)->get_gateway_interface = vsgi_mock_request_real_get_gateway_interface;
	VSGI_REQUEST_CLASS (klass)->get_method = vsgi_mock_request_real_get_method;
	VSGI_REQUEST_CLASS (klass)->get_uri = vsgi_mock_request_real_get_uri;
	VSGI_REQUEST_CLASS (klass)->get_query = vsgi_mock_request_real_get_query;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_mock_request_get_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_mock_request_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_REQUEST_HTTP_VERSION, g_param_spec_enum ("http-version", "http-version", "http-version", soup_http_version_get_type (), 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_REQUEST_GATEWAY_INTERFACE, g_param_spec_string ("gateway-interface", "gateway-interface", "gateway-interface", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_REQUEST_METHOD, g_param_spec_string ("method", "method", "method", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_REQUEST_URI, g_param_spec_boxed ("uri", "uri", "uri", soup_uri_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_REQUEST_QUERY, g_param_spec_boxed ("query", "query", "query", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_mock_request_instance_init (VSGIMockRequest * self) {
	gchar* _tmp0_ = NULL;
	SoupURI* _tmp1_ = NULL;
	self->priv = VSGI_MOCK_REQUEST_GET_PRIVATE (self);
	self->priv->_http_version = SOUP_HTTP_1_1;
	_tmp0_ = g_strdup (VSGI_REQUEST_GET);
	self->priv->_method = _tmp0_;
	_tmp1_ = soup_uri_new (NULL);
	self->priv->_uri = _tmp1_;
	self->priv->_query = NULL;
}


static void vsgi_mock_request_finalize (GObject* obj) {
	VSGIMockRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_MOCK_TYPE_REQUEST, VSGIMockRequest);
	_g_free0 (self->priv->_method);
	__vala_SoupURI_free0 (self->priv->_uri);
	_g_hash_table_unref0 (self->priv->_query);
	G_OBJECT_CLASS (vsgi_mock_request_parent_class)->finalize (obj);
}


/**
 * Test implementation of Request used to stub a request.
 */
GType vsgi_mock_request_get_type (void) {
	static volatile gsize vsgi_mock_request_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_mock_request_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIMockRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_mock_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIMockRequest), 0, (GInstanceInitFunc) vsgi_mock_request_instance_init, NULL };
		GType vsgi_mock_request_type_id;
		vsgi_mock_request_type_id = g_type_register_static (VSGI_TYPE_REQUEST, "VSGIMockRequest", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_mock_request_type_id__volatile, vsgi_mock_request_type_id);
	}
	return vsgi_mock_request_type_id__volatile;
}


static void _vala_vsgi_mock_request_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIMockRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_MOCK_TYPE_REQUEST, VSGIMockRequest);
	switch (property_id) {
		case VSGI_MOCK_REQUEST_HTTP_VERSION:
		g_value_set_enum (value, vsgi_request_get_http_version ((VSGIRequest*) self));
		break;
		case VSGI_MOCK_REQUEST_GATEWAY_INTERFACE:
		g_value_take_string (value, vsgi_request_get_gateway_interface ((VSGIRequest*) self));
		break;
		case VSGI_MOCK_REQUEST_METHOD:
		g_value_take_string (value, vsgi_request_get_method ((VSGIRequest*) self));
		break;
		case VSGI_MOCK_REQUEST_URI:
		g_value_set_boxed (value, vsgi_request_get_uri ((VSGIRequest*) self));
		break;
		case VSGI_MOCK_REQUEST_QUERY:
		g_value_set_boxed (value, vsgi_request_get_query ((VSGIRequest*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


VSGIMockResponse* vsgi_mock_response_construct (GType object_type, VSGIMockRequest* req) {
	VSGIMockResponse * self = NULL;
	VSGIMockRequest* _tmp0_ = NULL;
	SoupMessageHeaders* _tmp1_ = NULL;
	SoupMessageHeaders* _tmp2_ = NULL;
	g_return_val_if_fail (req != NULL, NULL);
	_tmp0_ = req;
	_tmp1_ = soup_message_headers_new (SOUP_MESSAGE_HEADERS_RESPONSE);
	_tmp2_ = _tmp1_;
	self = (VSGIMockResponse*) g_object_new (object_type, "request", _tmp0_, "headers", _tmp2_, NULL);
	__vala_SoupMessageHeaders_free0 (_tmp2_);
	return self;
}


VSGIMockResponse* vsgi_mock_response_new (VSGIMockRequest* req) {
	return vsgi_mock_response_construct (VSGI_MOCK_TYPE_RESPONSE, req);
}


VSGIMockResponse* vsgi_mock_response_construct_with_status (GType object_type, VSGIMockRequest* req, guint status) {
	VSGIMockResponse * self = NULL;
	VSGIMockRequest* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	SoupMessageHeaders* _tmp2_ = NULL;
	SoupMessageHeaders* _tmp3_ = NULL;
	g_return_val_if_fail (req != NULL, NULL);
	_tmp0_ = req;
	_tmp1_ = status;
	_tmp2_ = soup_message_headers_new (SOUP_MESSAGE_HEADERS_RESPONSE);
	_tmp3_ = _tmp2_;
	self = (VSGIMockResponse*) g_object_new (object_type, "request", _tmp0_, "status", _tmp1_, "headers", _tmp3_, NULL);
	__vala_SoupMessageHeaders_free0 (_tmp3_);
	return self;
}


VSGIMockResponse* vsgi_mock_response_new_with_status (VSGIMockRequest* req, guint status) {
	return vsgi_mock_response_construct_with_status (VSGI_MOCK_TYPE_RESPONSE, req, status);
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static gboolean vsgi_mock_response_real_write_status_line (VSGIResponse* base, SoupHTTPVersion http_version, guint status, const gchar* reason_phrase, gsize* bytes_written, GCancellable* cancellable, GError** error) {
	VSGIMockResponse * self;
	gsize _vala_bytes_written = 0UL;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	SoupHTTPVersion _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	VSGIRequest* _tmp3_ = NULL;
	VSGIRequest* _tmp4_ = NULL;
	VSGIConnection* _tmp5_ = NULL;
	VSGIConnection* _tmp6_ = NULL;
	GOutputStream* _tmp7_ = NULL;
	GOutputStream* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	guint8* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	guint8* _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	GCancellable* _tmp15_ = NULL;
	gsize _tmp16_ = 0UL;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (VSGIMockResponse*) base;
	g_return_val_if_fail (reason_phrase != NULL, FALSE);
	_tmp1_ = http_version;
	if (_tmp1_ == SOUP_HTTP_1_0) {
		_tmp0_ = "1.0";
	} else {
		_tmp0_ = "1.1";
	}
	_tmp3_ = vsgi_response_get_request ((VSGIResponse*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = vsgi_request_get_connection (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_io_stream_get_output_stream ((GIOStream*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = status;
	_tmp10_ = reason_phrase;
	_tmp11_ = g_strdup_printf ("HTTP/%s %u %s\r\n", _tmp0_, _tmp9_, _tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = string_get_data (_tmp12_, &_tmp13__length1);
	_tmp14_ = _tmp13_;
	_tmp14__length1 = _tmp13__length1;
	_tmp15_ = cancellable;
	_tmp17_ = g_output_stream_write_all (_tmp8_, _tmp14_, (gsize) _tmp14__length1, &_tmp16_, _tmp15_, &_inner_error_);
	_vala_bytes_written = _tmp16_;
	_tmp18_ = _tmp17_;
	_g_free0 (_tmp12_);
	_tmp2_ = _tmp18_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = _tmp2_;
	if (bytes_written) {
		*bytes_written = _vala_bytes_written;
	}
	return result;
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		VSGIMockResponse* self;
		self = _data2_->self;
		_g_string_free0 (_data2_->head);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static void __lambda10_ (Block2Data* _data2_, const gchar* name, const gchar* header) {
	VSGIMockResponse* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	self = _data2_->self;
	g_return_if_fail (name != NULL);
	g_return_if_fail (header != NULL);
	_tmp0_ = name;
	_tmp1_ = header;
	g_string_append_printf (_data2_->head, "%s: %s\r\n", _tmp0_, _tmp1_);
}


static void ___lambda10__soup_message_headers_foreach_func (const gchar* name, const gchar* value, gpointer self) {
	__lambda10_ (self, name, value);
}


static gboolean vsgi_mock_response_real_write_headers (VSGIResponse* base, SoupMessageHeaders* headers, gsize* bytes_written, GCancellable* cancellable, GError** error) {
	VSGIMockResponse * self;
	gsize _vala_bytes_written = 0UL;
	gboolean result = FALSE;
	Block2Data* _data2_;
	GString* _tmp0_ = NULL;
	SoupMessageHeaders* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	VSGIRequest* _tmp3_ = NULL;
	VSGIRequest* _tmp4_ = NULL;
	VSGIConnection* _tmp5_ = NULL;
	VSGIConnection* _tmp6_ = NULL;
	GOutputStream* _tmp7_ = NULL;
	GOutputStream* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	guint8* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	guint8* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	GCancellable* _tmp12_ = NULL;
	gsize _tmp13_ = 0UL;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (VSGIMockResponse*) base;
	g_return_val_if_fail (headers != NULL, FALSE);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = g_string_new ("");
	_data2_->head = _tmp0_;
	_tmp1_ = headers;
	soup_message_headers_foreach (_tmp1_, ___lambda10__soup_message_headers_foreach_func, _data2_);
	g_string_append (_data2_->head, "\r\n");
	_tmp3_ = vsgi_response_get_request ((VSGIResponse*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = vsgi_request_get_connection (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_io_stream_get_output_stream ((GIOStream*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _data2_->head->str;
	_tmp10_ = string_get_data (_tmp9_, &_tmp10__length1);
	_tmp11_ = _tmp10_;
	_tmp11__length1 = _tmp10__length1;
	_tmp12_ = cancellable;
	_tmp14_ = g_output_stream_write_all (_tmp8_, _tmp11_, (gsize) _tmp11__length1, &_tmp13_, _tmp12_, &_inner_error_);
	_vala_bytes_written = _tmp13_;
	_tmp2_ = _tmp14_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block2_data_unref (_data2_);
			_data2_ = NULL;
			return FALSE;
		} else {
			block2_data_unref (_data2_);
			_data2_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = _tmp2_;
	block2_data_unref (_data2_);
	_data2_ = NULL;
	if (bytes_written) {
		*bytes_written = _vala_bytes_written;
	}
	return result;
}


static void vsgi_mock_response_class_init (VSGIMockResponseClass * klass) {
	vsgi_mock_response_parent_class = g_type_class_peek_parent (klass);
	((VSGIResponseClass *) klass)->write_status_line = vsgi_mock_response_real_write_status_line;
	((VSGIResponseClass *) klass)->write_headers = vsgi_mock_response_real_write_headers;
}


static void vsgi_mock_response_instance_init (VSGIMockResponse * self) {
}


/**
 * Test implementation of VSGI.Response to stub a response.
 */
GType vsgi_mock_response_get_type (void) {
	static volatile gsize vsgi_mock_response_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_mock_response_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIMockResponseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_mock_response_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIMockResponse), 0, (GInstanceInitFunc) vsgi_mock_response_instance_init, NULL };
		GType vsgi_mock_response_type_id;
		vsgi_mock_response_type_id = g_type_register_static (VSGI_TYPE_RESPONSE, "VSGIMockResponse", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_mock_response_type_id__volatile, vsgi_mock_response_type_id);
	}
	return vsgi_mock_response_type_id__volatile;
}


static void vsgi_mock_server_real_listen (VSGIServer* base, GSocketAddress* address, GError** error) {
	VSGIMockServer * self;
	self = (VSGIMockServer*) base;
}


static void vsgi_mock_server_real_listen_socket (VSGIServer* base, GSocket* socket, GError** error) {
	VSGIMockServer * self;
	self = (VSGIMockServer*) base;
	g_return_if_fail (socket != NULL);
}


static void vsgi_mock_server_real_stop (VSGIServer* base) {
	VSGIMockServer * self;
	self = (VSGIMockServer*) base;
}


VSGIMockServer* vsgi_mock_server_construct (GType object_type) {
	VSGIMockServer * self = NULL;
	self = (VSGIMockServer*) vsgi_server_construct (object_type);
	return self;
}


VSGIMockServer* vsgi_mock_server_new (void) {
	return vsgi_mock_server_construct (VSGI_MOCK_TYPE_SERVER);
}


static GSList* vsgi_mock_server_real_get_uris (VSGIServer* base) {
	GSList* result;
	VSGIMockServer* self;
	self = (VSGIMockServer*) base;
	result = NULL;
	return result;
}


static void vsgi_mock_server_class_init (VSGIMockServerClass * klass) {
	vsgi_mock_server_parent_class = g_type_class_peek_parent (klass);
	((VSGIServerClass *) klass)->listen = vsgi_mock_server_real_listen;
	((VSGIServerClass *) klass)->listen_socket = vsgi_mock_server_real_listen_socket;
	((VSGIServerClass *) klass)->stop = vsgi_mock_server_real_stop;
	VSGI_SERVER_CLASS (klass)->get_uris = vsgi_mock_server_real_get_uris;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_mock_server_get_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_MOCK_SERVER_URIS, g_param_spec_pointer ("uris", "uris", "uris", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_mock_server_instance_init (VSGIMockServer * self) {
}


GType vsgi_mock_server_get_type (void) {
	static volatile gsize vsgi_mock_server_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_mock_server_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIMockServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_mock_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIMockServer), 0, (GInstanceInitFunc) vsgi_mock_server_instance_init, NULL };
		GType vsgi_mock_server_type_id;
		vsgi_mock_server_type_id = g_type_register_static (VSGI_TYPE_SERVER, "VSGIMockServer", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_mock_server_type_id__volatile, vsgi_mock_server_type_id);
	}
	return vsgi_mock_server_type_id__volatile;
}


static void _vala_vsgi_mock_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIMockServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_MOCK_TYPE_SERVER, VSGIMockServer);
	switch (property_id) {
		case VSGI_MOCK_SERVER_URIS:
		g_value_set_pointer (value, vsgi_server_get_uris ((VSGIServer*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



