/* vsgi-server.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-server.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <gio/gio.h>
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _VsgiServerDispatchAsyncData VsgiServerDispatchAsyncData;

struct _VSGIServerPrivate {
	VSGIHandler* _handler;
};

struct _Block3Data {
	int _ref_count_;
	VSGIServer* self;
	gboolean _result_;
	GError* err;
	VSGIRequest* req;
	VSGIResponse* res;
	gpointer _async_data_;
};

struct _VsgiServerDispatchAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	VSGIServer* self;
	VSGIRequest* req;
	VSGIResponse* res;
	gint priority;
	gboolean result;
	Block3Data* _data3_;
	VSGIRequest* _tmp0_;
	VSGIResponse* _tmp1_;
	gint _tmp2_;
	GError* _tmp3_;
	gboolean _tmp4_;
	GError* _tmp5_;
	GError* _tmp6_;
	GError * _inner_error_;
};


static gpointer vsgi_server_parent_class = NULL;
static GHashTable* vsgi_server__server_modules;
static GHashTable* vsgi_server__server_modules = NULL;

#define VSGI_SERVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_TYPE_SERVER, VSGIServerPrivate))
enum  {
	VSGI_SERVER_DUMMY_PROPERTY,
	VSGI_SERVER_HANDLER,
	VSGI_SERVER_URIS
};
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void vsgi_server_real_listen (VSGIServer* self, GSocketAddress* address, GError** error);
static void vsgi_server_real_listen_socket (VSGIServer* self, GSocket* socket, GError** error);
static void vsgi_server_real_stop (VSGIServer* self);
static GPid vsgi_server_real_fork (VSGIServer* self, GError** error);
static void vsgi_server_dispatch_async_data_free (gpointer _data);
static gboolean vsgi_server_dispatch_async_co (VsgiServerDispatchAsyncData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block3Data* _data3_, GIOSchedulerJob* job);
static gboolean _vsgi_server_dispatch_async_co_gsource_func (gpointer self);
static gboolean ___lambda4__gio_scheduler_job_func (GIOSchedulerJob* job, GCancellable* cancellable, gpointer self);
static void vsgi_server_finalize (GObject* obj);
static void _vala_vsgi_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Instantiate a new {@link VSGI.Server} instance.
 *
 * If the 'VSGI_SERVER_PATH' environment variable is set, it will used
 * instead of the default system path.
 *
 * For a more fine-grained control, use {@link VSGI.ServerModule}.
 *
 * @param name name of the server implementation to load
 * @param list arguments to pass to {@link GLib.Object.new_valist}
 *
 * @return the server instance of loaded successfully, otherwise 'null'
 *         and a critical will be emitted
 */
static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


VSGIServer* vsgi_server_new_valist (const gchar* name, va_list list) {
	VSGIServer* result = NULL;
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gconstpointer _tmp6_ = NULL;
	VSGIServer* server = NULL;
	GHashTable* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	gconstpointer _tmp19_ = NULL;
	GType _tmp20_ = 0UL;
	GType _tmp21_ = 0UL;
	const gchar* _tmp22_ = NULL;
	GObject* _tmp23_ = NULL;
	VSGIServer* _tmp24_ = NULL;
	VSGIServer* _tmp25_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = vsgi_server__server_modules;
	if (_tmp0_ == NULL) {
		GHashFunc _tmp1_ = NULL;
		GEqualFunc _tmp2_ = NULL;
		GHashTable* _tmp3_ = NULL;
		_tmp1_ = g_str_hash;
		_tmp2_ = g_str_equal;
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
		_g_hash_table_unref0 (vsgi_server__server_modules);
		vsgi_server__server_modules = _tmp3_;
	}
	_tmp4_ = vsgi_server__server_modules;
	_tmp5_ = name;
	_tmp6_ = g_hash_table_lookup (_tmp4_, _tmp5_);
	if (((VSGIServerModule*) _tmp6_) == NULL) {
		VSGIServerModule* server_module = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		VSGIServerModule* _tmp9_ = NULL;
		VSGIServerModule* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		GHashTable* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		VSGIServerModule* _tmp15_ = NULL;
		VSGIServerModule* _tmp16_ = NULL;
		_tmp7_ = g_getenv ("VSGI_SERVER_PATH");
		_tmp8_ = name;
		_tmp9_ = vsgi_server_module_new (_tmp7_, _tmp8_);
		server_module = _tmp9_;
		_tmp10_ = server_module;
		_tmp11_ = G_TYPE_MODULE_GET_CLASS ((GTypeModule*) _tmp10_)->load ((GTypeModule*) _tmp10_);
		if (!_tmp11_) {
			result = NULL;
			_g_object_unref0 (server_module);
			return result;
		}
		_tmp12_ = vsgi_server__server_modules;
		_tmp13_ = name;
		_tmp14_ = g_strdup (_tmp13_);
		_tmp15_ = server_module;
		_tmp16_ = _g_object_ref0 (_tmp15_);
		g_hash_table_insert (_tmp12_, _tmp14_, _tmp16_);
		_g_object_unref0 (server_module);
	}
	_tmp17_ = vsgi_server__server_modules;
	_tmp18_ = name;
	_tmp19_ = g_hash_table_lookup (_tmp17_, _tmp18_);
	_tmp20_ = vsgi_server_module_get_server_type ((VSGIServerModule*) _tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = va_arg (list, gchar*);
	_tmp23_ = g_object_new_valist (_tmp21_, _tmp22_, list);
	_tmp24_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, VSGI_TYPE_SERVER) ? ((VSGIServer*) _tmp23_) : NULL;
	if (_tmp24_ == NULL) {
		_g_object_unref0 (_tmp23_);
	}
	server = _tmp24_;
	_tmp25_ = server;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp25_, G_TYPE_INITABLE)) {
		{
			VSGIServer* _tmp26_ = NULL;
			_tmp26_ = server;
			g_initable_init (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, G_TYPE_INITABLE, GInitable), NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch10_g_error;
			}
		}
		goto __finally10;
		__catch10_g_error:
		{
			GError* err = NULL;
			GError* _tmp27_ = NULL;
			const gchar* _tmp28_ = NULL;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp27_ = err;
			_tmp28_ = _tmp27_->message;
			g_critical ("vsgi-server.vala:66: %s", _tmp28_);
			result = NULL;
			_g_error_free0 (err);
			_g_object_unref0 (server);
			return result;
		}
		__finally10:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (server);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = server;
	return result;
}


/**
 * Instantiate a new {@link VSGI.Server} with varidic arguments.
 */
VSGIServer* vsgi_server_new (const gchar* name, ...) {
	VSGIServer* result = NULL;
	const gchar* _tmp0_ = NULL;
	va_list _tmp1_ = {0};
	VSGIServer* _tmp2_ = NULL;
	VSGIServer* _tmp3_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	va_start (_tmp1_, name);
	_tmp2_ = vsgi_server_new_valist (_tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	va_end (_tmp1_);
	result = _tmp3_;
	return result;
}


/**
 * Prepare the server for listening on the provided socket address.
 *
 * Once the {@link GLib.MainLoop} is started, the server should start
 * accepting incoming connections.
 *
 * @param address a {@link GLib.SocketAddress} or 'null' to listen on
 *                the default interface
 *
 * @throws GLib.IOError.NOT_SUPPORTED if the server does not support
 *                                    listening on the provided address
 */
static void vsgi_server_real_listen (VSGIServer* self, GSocketAddress* address, GError** error) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_server_listen'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void vsgi_server_listen (VSGIServer* self, GSocketAddress* address, GError** error) {
	g_return_if_fail (self != NULL);
	VSGI_SERVER_GET_CLASS (self)->listen (self, address, error);
}


/**
 * Prepare the server for listening on the provided socket.
 *
 * Once the {@link GLib.MainLoop} is started, the server should start
 * accepting incoming connections.
 *
 * @throws GLib.IOError.NOT_SUPPORTED if the server does not support
 *                                    listening on the provided address
 */
static void vsgi_server_real_listen_socket (VSGIServer* self, GSocket* socket, GError** error) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_server_listen_socket'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void vsgi_server_listen_socket (VSGIServer* self, GSocket* socket, GError** error) {
	g_return_if_fail (self != NULL);
	VSGI_SERVER_GET_CLASS (self)->listen_socket (self, socket, error);
}


/**
 * Stop accepting new connections.
 */
static void vsgi_server_real_stop (VSGIServer* self) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_server_stop'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void vsgi_server_stop (VSGIServer* self) {
	g_return_if_fail (self != NULL);
	VSGI_SERVER_GET_CLASS (self)->stop (self);
}


/**
 * Fork the execution.
 *
 * This is typically called after {@link VSGI.Server.listen} such that
 * workers can share listening interfaces and descriptors.
 *
 * The default implementation wraps {@link Posix.fork} and check its
 * return value. To disable forking, simply override this and return
 * '0'.
 *
 * Marked as experimental because we might change this for a more
 * sophisticated model based in {@link GLib.Subprocess} in the future.
 *
 * @throws GLib.SpawnError.FORK if the {@link Posix.fork} call fails
 *
 * @return the process pid if this is the parent process,
 *         otherwise '0'
 */
static GPid vsgi_server_real_fork (VSGIServer* self, GError** error) {
	GPid result = 0;
	pid_t pid = 0;
	pid_t _tmp0_ = 0;
	pid_t _tmp1_ = 0;
	GError * _inner_error_ = NULL;
	_tmp0_ = fork ();
	pid = _tmp0_;
	_tmp1_ = pid;
	if (_tmp1_ == ((pid_t) (-1))) {
		gint _tmp2_ = 0;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		_tmp2_ = errno;
		_tmp3_ = g_strerror (_tmp2_);
		_tmp4_ = g_error_new_literal (G_SPAWN_ERROR, G_SPAWN_ERROR_FORK, _tmp3_);
		_inner_error_ = _tmp4_;
		g_propagate_error (error, _inner_error_);
		return 0;
	}
	result = (GPid) pid;
	return result;
}


GPid vsgi_server_fork (VSGIServer* self, GError** error) {
	g_return_val_if_fail (self != NULL, 0);
	return VSGI_SERVER_GET_CLASS (self)->fork (self, error);
}


static void vsgi_server_dispatch_async_data_free (gpointer _data) {
	VsgiServerDispatchAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (VsgiServerDispatchAsyncData, _data_);
}


void vsgi_server_dispatch_async (VSGIServer* self, VSGIRequest* req, VSGIResponse* res, gint priority, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	VsgiServerDispatchAsyncData* _data_;
	VSGIServer* _tmp0_ = NULL;
	VSGIRequest* _tmp1_ = NULL;
	VSGIRequest* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	VSGIResponse* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	_data_ = g_slice_new0 (VsgiServerDispatchAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, vsgi_server_dispatch_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, vsgi_server_dispatch_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = req;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (_data_->req);
	_data_->req = _tmp2_;
	_tmp3_ = res;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (_data_->res);
	_data_->res = _tmp4_;
	_tmp5_ = priority;
	_data_->priority = _tmp5_;
	vsgi_server_dispatch_async_co (_data_);
}


gboolean vsgi_server_dispatch_finish (VSGIServer* self, GAsyncResult* _res_, GError** error) {
	gboolean result;
	VsgiServerDispatchAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return FALSE;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	return result;
}


/**
 * Dispatch the request to the application callback.
 *
 * The application must call {@link Response.write_head} at some point.
 *
 * Once dispatched, the {@link Response.head_written} property is
 * expected to be true unless its reference still held somewhere else
 * and the return value is 'true'.
 */
static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		VSGIServer* self;
		self = _data3_->self;
		_g_error_free0 (_data3_->err);
		_g_object_unref0 (_data3_->req);
		_g_object_unref0 (_data3_->res);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static gboolean _vsgi_server_dispatch_async_co_gsource_func (gpointer self) {
	gboolean result;
	result = vsgi_server_dispatch_async_co (self);
	return result;
}


static gboolean __lambda4_ (Block3Data* _data3_, GIOSchedulerJob* job) {
	VSGIServer* self;
	gboolean result = FALSE;
	VSGIRequest* _req = NULL;
	VSGIRequest* _tmp0_ = NULL;
	VSGIRequest* _tmp1_ = NULL;
	VSGIResponse* _res = NULL;
	VSGIResponse* _tmp2_ = NULL;
	VSGIResponse* _tmp3_ = NULL;
	GIOSchedulerJob* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	GError * _inner_error_ = NULL;
	self = _data3_->self;
	g_return_val_if_fail (job != NULL, FALSE);
	_tmp0_ = _data3_->req;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_req = _tmp1_;
	_tmp2_ = _data3_->res;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_res = _tmp3_;
	{
		gboolean _tmp4_ = FALSE;
		VSGIHandler* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		_tmp5_ = self->priv->_handler;
		_tmp6_ = vsgi_handler_handle (_tmp5_, _req, _res, &_inner_error_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch11_g_error;
		}
		_data3_->_result_ = _tmp4_;
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* _err = NULL;
		GError* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		_err = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = _err;
		_tmp8_ = _g_error_copy0 (_tmp7_);
		_g_error_free0 (_data3_->err);
		_data3_->err = _tmp8_;
		_g_error_free0 (_err);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (_res);
		_g_object_unref0 (_req);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp9_ = job;
	_tmp10_ = g_io_scheduler_job_send_to_mainloop (_tmp9_, _vsgi_server_dispatch_async_co_gsource_func, _data3_->_async_data_, NULL);
	result = _tmp10_;
	_g_object_unref0 (_res);
	_g_object_unref0 (_req);
	return result;
}


static gboolean ___lambda4__gio_scheduler_job_func (GIOSchedulerJob* job, GCancellable* cancellable, gpointer self) {
	gboolean result;
	result = __lambda4_ (self, job);
	return result;
}


static gboolean vsgi_server_dispatch_async_co (VsgiServerDispatchAsyncData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data3_ = g_slice_new0 (Block3Data);
	_data_->_data3_->_ref_count_ = 1;
	_data_->_data3_->self = g_object_ref (_data_->self);
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->req;
	_g_object_unref0 (_data_->_data3_->req);
	_data_->_data3_->req = _data_->_tmp0_;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = _data_->res;
	_g_object_unref0 (_data_->_data3_->res);
	_data_->_data3_->res = _data_->_tmp1_;
	_data_->_data3_->_async_data_ = _data_;
	_data_->_data3_->_result_ = FALSE;
	_data_->_data3_->err = NULL;
	_data_->_tmp2_ = 0;
	_data_->_tmp2_ = _data_->priority;
	g_io_scheduler_push_job (___lambda4__gio_scheduler_job_func, block3_data_ref (_data_->_data3_), block3_data_unref, _data_->_tmp2_, NULL);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = _data_->_data3_->err;
	if (_data_->_tmp3_ == NULL) {
		_data_->_tmp4_ = FALSE;
		_data_->_tmp4_ = _data_->_data3_->_result_;
		_data_->result = _data_->_tmp4_;
		block3_data_unref (_data_->_data3_);
		_data_->_data3_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = _data_->_data3_->err;
		_data_->_tmp6_ = NULL;
		_data_->_tmp6_ = _g_error_copy0 (_data_->_tmp5_);
		_data_->_inner_error_ = _data_->_tmp6_;
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		block3_data_unref (_data_->_data3_);
		_data_->_data3_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	block3_data_unref (_data_->_data3_);
	_data_->_data3_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


/**
 * Create a new {@link VSGI.Application} that cushion the execution of
 * this server.
 */
gint vsgi_server_run (VSGIServer* self, gchar** args, int args_length1) {
	gint result = 0;
	VSGIApplication* _tmp0_ = NULL;
	VSGIApplication* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = vsgi_application_new (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	_tmp3_ = g_application_run ((GApplication*) _tmp1_, _tmp2__length1, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}


VSGIServer* vsgi_server_construct (GType object_type) {
	VSGIServer * self = NULL;
	self = (VSGIServer*) g_object_new (object_type, NULL);
	return self;
}


VSGIHandler* vsgi_server_get_handler (VSGIServer* self) {
	VSGIHandler* result;
	VSGIHandler* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_handler;
	result = _tmp0_;
	return result;
}


void vsgi_server_set_handler (VSGIServer* self, VSGIHandler* value) {
	VSGIHandler* _tmp0_ = NULL;
	VSGIHandler* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_handler);
	self->priv->_handler = _tmp1_;
	g_object_notify ((GObject *) self, "handler");
}


GSList* vsgi_server_get_uris (VSGIServer* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return VSGI_SERVER_GET_CLASS (self)->get_uris (self);
}


static void vsgi_server_class_init (VSGIServerClass * klass) {
	vsgi_server_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGIServerPrivate));
	((VSGIServerClass *) klass)->listen = vsgi_server_real_listen;
	((VSGIServerClass *) klass)->listen_socket = vsgi_server_real_listen_socket;
	((VSGIServerClass *) klass)->stop = vsgi_server_real_stop;
	((VSGIServerClass *) klass)->fork = vsgi_server_real_fork;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_server_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_server_set_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_server_finalize;
	/**
	 * Handler processing incoming connections.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_SERVER_HANDLER, g_param_spec_object ("handler", "handler", "handler", VSGI_TYPE_HANDLER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	 * URIs this server is listening on.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_SERVER_URIS, g_param_spec_pointer ("uris", "uris", "uris", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_server_instance_init (VSGIServer * self) {
	self->priv = VSGI_SERVER_GET_PRIVATE (self);
}


static void vsgi_server_finalize (GObject* obj) {
	VSGIServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_SERVER, VSGIServer);
	_g_object_unref0 (self->priv->_handler);
	G_OBJECT_CLASS (vsgi_server_parent_class)->finalize (obj);
}


/**
 * Server that feeds a {@link VSGI.Handler} with incoming requests.
 *
 * Once you have initialized a Server instance, start it by calling
 * {@link GLib.Application.run} with the command-line arguments or a set of
 * predefined arguments.
 *
 * The server should be implemented by overriding the
 * {@link GLib.Application.command_line} signal.
 */
GType vsgi_server_get_type (void) {
	static volatile gsize vsgi_server_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_server_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGIServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGIServer), 0, (GInstanceInitFunc) vsgi_server_instance_init, NULL };
		GType vsgi_server_type_id;
		vsgi_server_type_id = g_type_register_static (G_TYPE_OBJECT, "VSGIServer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&vsgi_server_type_id__volatile, vsgi_server_type_id);
	}
	return vsgi_server_type_id__volatile;
}


static void _vala_vsgi_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGIServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_SERVER, VSGIServer);
	switch (property_id) {
		case VSGI_SERVER_HANDLER:
		g_value_set_object (value, vsgi_server_get_handler (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGIServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_SERVER, VSGIServer);
	switch (property_id) {
		case VSGI_SERVER_HANDLER:
		vsgi_server_set_handler (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



