/* vsgi-socket-server.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-socket-server.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <libsoup/soup.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gunixsocketaddress.h>

#define __g_slist_free___vala_SoupURI_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free___vala_SoupURI_free0_ (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))

struct _VSGISocketServerPrivate {
	gint _backlog;
	GSList* _uris;
	GSocketService* socket_service;
};


static gpointer vsgi_socket_server_parent_class = NULL;

#define VSGI_SOCKET_SERVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_TYPE_SOCKET_SERVER, VSGISocketServerPrivate))
enum  {
	VSGI_SOCKET_SERVER_DUMMY_PROPERTY,
	VSGI_SOCKET_SERVER_BACKLOG,
	VSGI_SOCKET_SERVER_SCHEME,
	VSGI_SOCKET_SERVER_URIS
};
static void _vala_SoupURI_free (SoupURI* self);
static void __vala_SoupURI_free0_ (gpointer var);
static void _g_slist_free___vala_SoupURI_free0_ (GSList* self);
static void vsgi_socket_server_real_listen (VSGIServer* base, GSocketAddress* address, GError** error);
static void vsgi_socket_server_real_listen_socket (VSGIServer* base, GSocket* socket, GError** error);
static void vsgi_socket_server_real_stop (VSGIServer* base);
static gboolean vsgi_socket_server_real_incoming (VSGISocketServer* self, GSocketConnection* connection);
static SoupURI* _vala_SoupURI_copy (SoupURI* self);
static GObject * vsgi_socket_server_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gboolean _vsgi_socket_server_incoming_g_socket_service_incoming (GSocketService* _sender, GSocketConnection* connection, GObject* source_object, gpointer self);
static void vsgi_socket_server_finalize (GObject* obj);
static void _vala_vsgi_socket_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_socket_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _vala_SoupURI_free (SoupURI* self) {
	g_boxed_free (soup_uri_get_type (), self);
}


static void __vala_SoupURI_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL));
}


static void _g_slist_free___vala_SoupURI_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) __vala_SoupURI_free0_, NULL);
	g_slist_free (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void vsgi_socket_server_real_listen (VSGIServer* base, GSocketAddress* address, GError** error) {
	VSGISocketServer * self;
	GSocketAddress* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	self = (VSGISocketServer*) base;
	_tmp0_ = address;
	if (_tmp0_ == NULL) {
		GError* _tmp1_ = NULL;
		_tmp1_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "The implementation does not support a default listening interface.");
		_inner_error_ = _tmp1_;
		g_propagate_error (error, _inner_error_);
		return;
	} else {
		GSocketAddress* effective_address = NULL;
		GSocketService* _tmp2_ = NULL;
		GSocketAddress* _tmp3_ = NULL;
		GSocketAddress* _tmp4_ = NULL;
		_tmp2_ = self->priv->socket_service;
		_tmp3_ = address;
		g_socket_listener_add_address ((GSocketListener*) _tmp2_, _tmp3_, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, NULL, &_tmp4_, &_inner_error_);
		_g_object_unref0 (effective_address);
		effective_address = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (effective_address);
			return;
		}
		if (G_TYPE_CHECK_INSTANCE_TYPE (effective_address, g_inet_socket_address_get_type ())) {
			GInetSocketAddress* effective_inet_address = NULL;
			GInetSocketAddress* _tmp5_ = NULL;
			GInetSocketAddress* _tmp6_ = NULL;
			GSocketFamily _tmp7_ = 0;
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (effective_address, g_inet_socket_address_get_type ()) ? ((GInetSocketAddress*) effective_address) : NULL);
			effective_inet_address = _tmp5_;
			_tmp6_ = effective_inet_address;
			_tmp7_ = g_socket_address_get_family ((GSocketAddress*) _tmp6_);
			if (_tmp7_ == G_SOCKET_FAMILY_IPV4) {
				const gchar* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				GInetSocketAddress* _tmp10_ = NULL;
				GInetAddress* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				gchar* _tmp13_ = NULL;
				GInetSocketAddress* _tmp14_ = NULL;
				guint16 _tmp15_ = 0U;
				gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				SoupURI* _tmp18_ = NULL;
				_tmp8_ = vsgi_socket_server_get_scheme (self);
				_tmp9_ = _tmp8_;
				_tmp10_ = effective_inet_address;
				_tmp11_ = g_inet_socket_address_get_address (_tmp10_);
				_tmp12_ = g_inet_address_to_string (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = effective_inet_address;
				_tmp15_ = g_inet_socket_address_get_port (_tmp14_);
				_tmp16_ = g_strdup_printf ("%s://%s:%u/", _tmp9_, _tmp13_, (guint) _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = soup_uri_new (_tmp17_);
				self->priv->_uris = g_slist_append (self->priv->_uris, _tmp18_);
				_g_free0 (_tmp17_);
				_g_free0 (_tmp13_);
			} else {
				GInetSocketAddress* _tmp19_ = NULL;
				GSocketFamily _tmp20_ = 0;
				_tmp19_ = effective_inet_address;
				_tmp20_ = g_socket_address_get_family ((GSocketAddress*) _tmp19_);
				if (_tmp20_ == G_SOCKET_FAMILY_IPV6) {
					const gchar* _tmp21_ = NULL;
					const gchar* _tmp22_ = NULL;
					GInetSocketAddress* _tmp23_ = NULL;
					GInetAddress* _tmp24_ = NULL;
					gchar* _tmp25_ = NULL;
					gchar* _tmp26_ = NULL;
					GInetSocketAddress* _tmp27_ = NULL;
					guint16 _tmp28_ = 0U;
					gchar* _tmp29_ = NULL;
					gchar* _tmp30_ = NULL;
					SoupURI* _tmp31_ = NULL;
					_tmp21_ = vsgi_socket_server_get_scheme (self);
					_tmp22_ = _tmp21_;
					_tmp23_ = effective_inet_address;
					_tmp24_ = g_inet_socket_address_get_address (_tmp23_);
					_tmp25_ = g_inet_address_to_string (_tmp24_);
					_tmp26_ = _tmp25_;
					_tmp27_ = effective_inet_address;
					_tmp28_ = g_inet_socket_address_get_port (_tmp27_);
					_tmp29_ = g_strdup_printf ("%s://[%s]:%u/", _tmp22_, _tmp26_, (guint) _tmp28_);
					_tmp30_ = _tmp29_;
					_tmp31_ = soup_uri_new (_tmp30_);
					self->priv->_uris = g_slist_append (self->priv->_uris, _tmp31_);
					_g_free0 (_tmp30_);
					_g_free0 (_tmp26_);
				}
			}
			_g_object_unref0 (effective_inet_address);
		} else {
			if (G_TYPE_CHECK_INSTANCE_TYPE (effective_address, G_TYPE_UNIX_SOCKET_ADDRESS)) {
				GUnixSocketAddress* effective_unix_address = NULL;
				GUnixSocketAddress* _tmp32_ = NULL;
				const gchar* _tmp33_ = NULL;
				const gchar* _tmp34_ = NULL;
				GUnixSocketAddress* _tmp35_ = NULL;
				const gchar* _tmp36_ = NULL;
				gchar* _tmp37_ = NULL;
				gchar* _tmp38_ = NULL;
				SoupURI* _tmp39_ = NULL;
				_tmp32_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (effective_address, G_TYPE_UNIX_SOCKET_ADDRESS) ? ((GUnixSocketAddress*) effective_address) : NULL);
				effective_unix_address = _tmp32_;
				_tmp33_ = vsgi_socket_server_get_scheme (self);
				_tmp34_ = _tmp33_;
				_tmp35_ = effective_unix_address;
				_tmp36_ = g_unix_socket_address_get_path (_tmp35_);
				_tmp37_ = g_strdup_printf ("%s+unix://%s/", _tmp34_, _tmp36_);
				_tmp38_ = _tmp37_;
				_tmp39_ = soup_uri_new (_tmp38_);
				self->priv->_uris = g_slist_append (self->priv->_uris, _tmp39_);
				_g_free0 (_tmp38_);
				_g_object_unref0 (effective_unix_address);
			}
		}
		_g_object_unref0 (effective_address);
	}
}


static void vsgi_socket_server_real_listen_socket (VSGIServer* base, GSocket* socket, GError** error) {
	VSGISocketServer * self;
	GSocketService* _tmp0_ = NULL;
	GSocket* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GSocket* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	SoupURI* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
	self = (VSGISocketServer*) base;
	g_return_if_fail (socket != NULL);
	_tmp0_ = self->priv->socket_service;
	_tmp1_ = socket;
	g_socket_listener_add_socket ((GSocketListener*) _tmp0_, _tmp1_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp2_ = vsgi_socket_server_get_scheme (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = socket;
	_tmp5_ = g_socket_get_fd (_tmp4_);
	_tmp6_ = g_strdup_printf ("%s+fd://%d/", _tmp3_, _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = soup_uri_new (_tmp7_);
	self->priv->_uris = g_slist_append (self->priv->_uris, _tmp8_);
	_g_free0 (_tmp7_);
}


static void vsgi_socket_server_real_stop (VSGIServer* base) {
	VSGISocketServer * self;
	GSocketService* _tmp0_ = NULL;
	self = (VSGISocketServer*) base;
	_tmp0_ = self->priv->socket_service;
	g_socket_service_stop (_tmp0_);
}


/**
 * Dispatch an incoming socket connection.
 */
static gboolean vsgi_socket_server_real_incoming (VSGISocketServer* self, GSocketConnection* connection) {
	g_critical ("Type `%s' does not implement abstract method `vsgi_socket_server_incoming'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean vsgi_socket_server_incoming (VSGISocketServer* self, GSocketConnection* connection) {
	g_return_val_if_fail (self != NULL, FALSE);
	return VSGI_SOCKET_SERVER_GET_CLASS (self)->incoming (self, connection);
}


VSGISocketServer* vsgi_socket_server_construct (GType object_type) {
	VSGISocketServer * self = NULL;
	self = (VSGISocketServer*) vsgi_server_construct (object_type);
	return self;
}


gint vsgi_socket_server_get_backlog (VSGISocketServer* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_backlog;
	result = _tmp0_;
	return result;
}


static void vsgi_socket_server_set_backlog (VSGISocketServer* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_backlog = _tmp0_;
	g_object_notify ((GObject *) self, "backlog");
}


const gchar* vsgi_socket_server_get_scheme (VSGISocketServer* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return VSGI_SOCKET_SERVER_GET_CLASS (self)->get_scheme (self);
}


static SoupURI* _vala_SoupURI_copy (SoupURI* self) {
	return g_boxed_copy (soup_uri_get_type (), self);
}


static gpointer __vala_SoupURI_copy0 (gpointer self) {
	return self ? _vala_SoupURI_copy (self) : NULL;
}


static GSList* vsgi_socket_server_real_get_uris (VSGIServer* base) {
	GSList* result;
	VSGISocketServer* self;
	GSList* copy_uris = NULL;
	GSList* _tmp0_ = NULL;
	self = (VSGISocketServer*) base;
	copy_uris = NULL;
	_tmp0_ = self->priv->_uris;
	{
		GSList* uri_collection = NULL;
		GSList* uri_it = NULL;
		uri_collection = _tmp0_;
		for (uri_it = uri_collection; uri_it != NULL; uri_it = uri_it->next) {
			SoupURI* _tmp1_ = NULL;
			SoupURI* uri = NULL;
			_tmp1_ = __vala_SoupURI_copy0 ((SoupURI*) uri_it->data);
			uri = _tmp1_;
			{
				SoupURI* _tmp2_ = NULL;
				SoupURI* _tmp3_ = NULL;
				_tmp2_ = uri;
				_tmp3_ = soup_uri_copy (_tmp2_);
				copy_uris = g_slist_append (copy_uris, _tmp3_);
				__vala_SoupURI_free0 (uri);
			}
		}
	}
	result = copy_uris;
	return result;
}


static gboolean _vsgi_socket_server_incoming_g_socket_service_incoming (GSocketService* _sender, GSocketConnection* connection, GObject* source_object, gpointer self) {
	gboolean result;
	result = vsgi_socket_server_incoming ((VSGISocketServer*) self, connection);
	return result;
}


static GObject * vsgi_socket_server_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	VSGISocketServer * self;
	GSocketService* _tmp0_ = NULL;
	GSocketService* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	GSocketService* _tmp3_ = NULL;
	parent_class = G_OBJECT_CLASS (vsgi_socket_server_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_SOCKET_SERVER, VSGISocketServer);
	_tmp0_ = self->priv->socket_service;
	g_signal_connect_object (_tmp0_, "incoming", (GCallback) _vsgi_socket_server_incoming_g_socket_service_incoming, self, 0);
	_tmp1_ = self->priv->socket_service;
	_tmp2_ = self->priv->_backlog;
	g_socket_listener_set_backlog ((GSocketListener*) _tmp1_, _tmp2_);
	_tmp3_ = self->priv->socket_service;
	g_socket_service_start (_tmp3_);
	return obj;
}


static void vsgi_socket_server_class_init (VSGISocketServerClass * klass) {
	vsgi_socket_server_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGISocketServerPrivate));
	((VSGIServerClass *) klass)->listen = vsgi_socket_server_real_listen;
	((VSGIServerClass *) klass)->listen_socket = vsgi_socket_server_real_listen_socket;
	((VSGIServerClass *) klass)->stop = vsgi_socket_server_real_stop;
	((VSGISocketServerClass *) klass)->incoming = vsgi_socket_server_real_incoming;
	VSGI_SERVER_CLASS (klass)->get_uris = vsgi_socket_server_real_get_uris;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_socket_server_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_socket_server_set_property;
	G_OBJECT_CLASS (klass)->constructor = vsgi_socket_server_constructor;
	G_OBJECT_CLASS (klass)->finalize = vsgi_socket_server_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_SOCKET_SERVER_BACKLOG, g_param_spec_int ("backlog", "backlog", "Listen queue depth used in the listen() call", G_MININT, G_MAXINT, 10, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * Scheme used for generated listening {@link Soup.URI}.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_SOCKET_SERVER_SCHEME, g_param_spec_string ("scheme", "scheme", "scheme", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_SOCKET_SERVER_URIS, g_param_spec_pointer ("uris", "uris", "uris", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsgi_socket_server_instance_init (VSGISocketServer * self) {
	GSocketService* _tmp0_ = NULL;
	self->priv = VSGI_SOCKET_SERVER_GET_PRIVATE (self);
	self->priv->_backlog = 10;
	self->priv->_uris = NULL;
	_tmp0_ = g_socket_service_new ();
	self->priv->socket_service = _tmp0_;
}


static void vsgi_socket_server_finalize (GObject* obj) {
	VSGISocketServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_SOCKET_SERVER, VSGISocketServer);
	__g_slist_free___vala_SoupURI_free0_0 (self->priv->_uris);
	_g_object_unref0 (self->priv->socket_service);
	G_OBJECT_CLASS (vsgi_socket_server_parent_class)->finalize (obj);
}


/**
 * Base for implementing a server upon {@link GLib.SocketService}.
 */
GType vsgi_socket_server_get_type (void) {
	static volatile gsize vsgi_socket_server_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_socket_server_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGISocketServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_socket_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGISocketServer), 0, (GInstanceInitFunc) vsgi_socket_server_instance_init, NULL };
		GType vsgi_socket_server_type_id;
		vsgi_socket_server_type_id = g_type_register_static (VSGI_TYPE_SERVER, "VSGISocketServer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&vsgi_socket_server_type_id__volatile, vsgi_socket_server_type_id);
	}
	return vsgi_socket_server_type_id__volatile;
}


static void _vala_vsgi_socket_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGISocketServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_SOCKET_SERVER, VSGISocketServer);
	switch (property_id) {
		case VSGI_SOCKET_SERVER_BACKLOG:
		g_value_set_int (value, vsgi_socket_server_get_backlog (self));
		break;
		case VSGI_SOCKET_SERVER_URIS:
		g_value_set_pointer (value, vsgi_server_get_uris ((VSGIServer*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_socket_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGISocketServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_SOCKET_SERVER, VSGISocketServer);
	switch (property_id) {
		case VSGI_SOCKET_SERVER_BACKLOG:
		vsgi_socket_server_set_backlog (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



