/* vsgi-tee-output-stream.c generated by valac 0.26.1, the Vala compiler
 * generated from vsgi-tee-output-stream.vala, do not modify */

/*
 * This file is part of Valum.
 *
 * Valum is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Valum is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Valum.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "vsgi.h"
#include <gio/gio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _VSGITeeOutputStreamPrivate {
	GOutputStream* _tee_stream;
};


static gpointer vsgi_tee_output_stream_parent_class = NULL;

#define VSGI_TEE_OUTPUT_STREAM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSGI_TYPE_TEE_OUTPUT_STREAM, VSGITeeOutputStreamPrivate))
enum  {
	VSGI_TEE_OUTPUT_STREAM_DUMMY_PROPERTY,
	VSGI_TEE_OUTPUT_STREAM_TEE_STREAM
};
static gssize vsgi_tee_output_stream_real_write (GOutputStream* base, guint8* buffer, int buffer_length1, GCancellable* cancellable, GError** error);
static gboolean vsgi_tee_output_stream_real_close (GOutputStream* base, GCancellable* cancellable, GError** error);
static void vsgi_tee_output_stream_finalize (GObject* obj);
static void _vala_vsgi_tee_output_stream_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_vsgi_tee_output_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


VSGITeeOutputStream* vsgi_tee_output_stream_construct (GType object_type, GOutputStream* base_stream, GOutputStream* tee_stream) {
	VSGITeeOutputStream * self = NULL;
	GOutputStream* _tmp0_ = NULL;
	GOutputStream* _tmp1_ = NULL;
	g_return_val_if_fail (base_stream != NULL, NULL);
	g_return_val_if_fail (tee_stream != NULL, NULL);
	_tmp0_ = base_stream;
	_tmp1_ = tee_stream;
	self = (VSGITeeOutputStream*) g_object_new (object_type, "base-stream", _tmp0_, "tee-stream", _tmp1_, NULL);
	return self;
}


VSGITeeOutputStream* vsgi_tee_output_stream_new (GOutputStream* base_stream, GOutputStream* tee_stream) {
	return vsgi_tee_output_stream_construct (VSGI_TYPE_TEE_OUTPUT_STREAM, base_stream, tee_stream);
}


static gssize vsgi_tee_output_stream_real_write (GOutputStream* base, guint8* buffer, int buffer_length1, GCancellable* cancellable, GError** error) {
	VSGITeeOutputStream * self;
	gssize result = 0L;
	gssize bytes_written = 0L;
	GOutputStream* _tmp0_ = NULL;
	GOutputStream* _tmp1_ = NULL;
	guint8* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	GCancellable* _tmp3_ = NULL;
	gssize _tmp4_ = 0L;
	gssize _tmp5_ = 0L;
	gint _tmp6_ = 0;
	gsize tee_bytes_written = 0UL;
	GOutputStream* _tmp7_ = NULL;
	guint8* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gsize _tmp9_ = 0UL;
	GError * _inner_error_ = NULL;
	self = (VSGITeeOutputStream*) base;
	_tmp0_ = g_filter_output_stream_get_base_stream ((GFilterOutputStream*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = buffer;
	_tmp2__length1 = buffer_length1;
	_tmp3_ = cancellable;
	_tmp4_ = g_output_stream_write (_tmp1_, _tmp2_, (gsize) _tmp2__length1, _tmp3_, &_inner_error_);
	bytes_written = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return 0L;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0L;
		}
	}
	_tmp5_ = bytes_written;
	buffer_length1 = (gint) _tmp5_;
	_tmp6_ = buffer_length1;
	_tmp7_ = self->priv->_tee_stream;
	_tmp8_ = buffer;
	_tmp8__length1 = buffer_length1;
	g_output_stream_write_all (_tmp7_, _tmp8_, (gsize) _tmp8__length1, &_tmp9_, NULL, &_inner_error_);
	tee_bytes_written = _tmp9_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return 0L;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0L;
		}
	}
	result = bytes_written;
	return result;
}


static gboolean vsgi_tee_output_stream_real_close (GOutputStream* base, GCancellable* cancellable, GError** error) {
	VSGITeeOutputStream * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GOutputStream* _tmp2_ = NULL;
	GOutputStream* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (VSGITeeOutputStream*) base;
	_tmp2_ = g_filter_output_stream_get_base_stream ((GFilterOutputStream*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = cancellable;
	_tmp5_ = g_output_stream_close (_tmp3_, _tmp4_, &_inner_error_);
	_tmp1_ = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	if (_tmp1_) {
		gboolean _tmp6_ = FALSE;
		GOutputStream* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		_tmp7_ = self->priv->_tee_stream;
		_tmp8_ = g_output_stream_close (_tmp7_, NULL, &_inner_error_);
		_tmp6_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				return FALSE;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
		}
		_tmp0_ = _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


GOutputStream* vsgi_tee_output_stream_get_tee_stream (VSGITeeOutputStream* self) {
	GOutputStream* result;
	GOutputStream* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tee_stream;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void vsgi_tee_output_stream_set_tee_stream (VSGITeeOutputStream* self, GOutputStream* value) {
	GOutputStream* _tmp0_ = NULL;
	GOutputStream* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_tee_stream);
	self->priv->_tee_stream = _tmp1_;
	g_object_notify ((GObject *) self, "tee-stream");
}


static void vsgi_tee_output_stream_class_init (VSGITeeOutputStreamClass * klass) {
	vsgi_tee_output_stream_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VSGITeeOutputStreamPrivate));
	((GOutputStreamClass *) klass)->write_fn = vsgi_tee_output_stream_real_write;
	((GOutputStreamClass *) klass)->close_fn = vsgi_tee_output_stream_real_close;
	G_OBJECT_CLASS (klass)->get_property = _vala_vsgi_tee_output_stream_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vsgi_tee_output_stream_set_property;
	G_OBJECT_CLASS (klass)->finalize = vsgi_tee_output_stream_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSGI_TEE_OUTPUT_STREAM_TEE_STREAM, g_param_spec_object ("tee-stream", "tee-stream", "tee-stream", G_TYPE_OUTPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void vsgi_tee_output_stream_instance_init (VSGITeeOutputStream * self) {
	self->priv = VSGI_TEE_OUTPUT_STREAM_GET_PRIVATE (self);
}


static void vsgi_tee_output_stream_finalize (GObject* obj) {
	VSGITeeOutputStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VSGI_TYPE_TEE_OUTPUT_STREAM, VSGITeeOutputStream);
	_g_object_unref0 (self->priv->_tee_stream);
	G_OBJECT_CLASS (vsgi_tee_output_stream_parent_class)->finalize (obj);
}


/**
 * Pipe data into a base and a tee streams, similarly to the UNIX 'tee' utility.
 *
 * The base stream is always priviledged: it is always written and closed first.
 * Also, The best is done to replicate the written data into the tee stream,
 * erroring only if everything has been attempted. The tee operations are not
 * cancellable.
 */
GType vsgi_tee_output_stream_get_type (void) {
	static volatile gsize vsgi_tee_output_stream_type_id__volatile = 0;
	if (g_once_init_enter (&vsgi_tee_output_stream_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VSGITeeOutputStreamClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsgi_tee_output_stream_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VSGITeeOutputStream), 0, (GInstanceInitFunc) vsgi_tee_output_stream_instance_init, NULL };
		GType vsgi_tee_output_stream_type_id;
		vsgi_tee_output_stream_type_id = g_type_register_static (g_filter_output_stream_get_type (), "VSGITeeOutputStream", &g_define_type_info, 0);
		g_once_init_leave (&vsgi_tee_output_stream_type_id__volatile, vsgi_tee_output_stream_type_id);
	}
	return vsgi_tee_output_stream_type_id__volatile;
}


static void _vala_vsgi_tee_output_stream_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VSGITeeOutputStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_TEE_OUTPUT_STREAM, VSGITeeOutputStream);
	switch (property_id) {
		case VSGI_TEE_OUTPUT_STREAM_TEE_STREAM:
		g_value_set_object (value, vsgi_tee_output_stream_get_tee_stream (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_vsgi_tee_output_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	VSGITeeOutputStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VSGI_TYPE_TEE_OUTPUT_STREAM, VSGITeeOutputStream);
	switch (property_id) {
		case VSGI_TEE_OUTPUT_STREAM_TEE_STREAM:
		vsgi_tee_output_stream_set_tee_stream (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



